Search.setIndex({"docnames": ["best_practices", "codemods", "codemods_tutorial", "experimental", "helpers", "index", "matchers", "matchers_tutorial", "metadata", "metadata_tutorial", "motivation", "nodes", "parser", "scope_tutorial", "tutorial", "visitors", "why_libcst"], "filenames": ["best_practices.rst", "codemods.rst", "codemods_tutorial.rst", "experimental.rst", "helpers.rst", "index.rst", "matchers.rst", "matchers_tutorial.ipynb", "metadata.rst", "metadata_tutorial.ipynb", "motivation.rst", "nodes.rst", "parser.rst", "scope_tutorial.ipynb", "tutorial.ipynb", "visitors.rst", "why_libcst.rst"], "titles": ["Best Practices", "Codemods", "Working With Codemods", "Experimental APIs", "Helpers", "LibCST", "Matchers", "Working with Matchers", "Metadata", "Working with Metadata", "Motivation", "Nodes", "Parsing", "Scope Analysis", "Parsing and Visiting", "Visitors", "Why LibCST?"], "terms": {"while": [0, 1, 2, 6, 7, 8, 9, 11, 12, 13, 15], "ar": [0, 1, 2, 4, 6, 7, 8, 9, 10, 11, 12, 13, 15, 16], "plenti": 0, "wai": [0, 1, 6, 7, 8, 9, 10, 11, 15], "interact": [0, 1, 7, 9, 13, 14], "libcst": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15], "we": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16], "recommend": [0, 6, 11, 12, 15], "some": [0, 1, 2, 4, 6, 8, 11, 13, 14, 16], "pattern": [0, 1, 2, 6, 8, 14], "over": [0, 6, 7, 8, 11, 15], "other": [0, 1, 6, 8, 9, 10, 11], "variou": [0, 1, 6, 10, 11, 14], "laid": [0, 6], "out": [0, 1, 2, 3, 6, 7, 8, 9, 10, 11, 12], "here": [0, 1, 7, 8, 9, 10, 11, 12, 13, 14], "along": [0, 1, 2, 12, 13], "justif": 0, "excess": 0, "us": [0, 1, 2, 3, 4, 6, 7, 8, 10, 11, 12, 13, 14, 15, 16], "impli": 0, "you": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 15], "should": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 15], "rewrit": [0, 7, 10], "your": [0, 1, 2, 3, 4, 6, 7, 8, 9, 11, 15], "check": [0, 1, 2, 4, 6, 7, 8, 11, 14, 15], "matcher": [0, 1, 2, 5], "unrol": 0, "set": [0, 1, 5, 6, 8, 11, 13, 15], "visitor": [0, 1, 2, 5, 6, 7, 8, 9, 11], "method": [0, 1, 4, 6, 8, 9, 11, 13, 15], "often": [0, 1, 6, 8, 11, 14], "make": [0, 1, 2, 3, 6, 7, 8, 10, 11, 13, 15, 16], "ensure_typ": [0, 4, 7], "type": [0, 1, 2, 4, 5, 9, 10, 11, 13, 15, 16], "checker": [0, 4, 8, 11, 16], "awar": 0, "node": [0, 1, 3, 4, 5, 6, 7, 9, 10, 12, 13, 14, 15, 16], "": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12, 13, 14, 15, 16], "i": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16], "far": [0, 1], "easier": [0, 1, 7, 8, 11, 12], "explicit": [0, 1, 6, 10, 15], "instanc": [0, 1, 4, 6, 7, 8, 11, 15], "transform": [0, 2, 5, 6, 7, 11, 13], "match": [0, 1, 2, 6, 7, 8, 11, 12, 15, 16], "against": [0, 1, 6, 8, 11], "extract": [0, 6, 11, 16], "valu": [0, 1, 2, 6, 7, 8, 9, 12, 13, 14, 15, 16], "child": [0, 6, 8, 9, 11, 15], "more": [0, 1, 4, 6, 7, 8, 9, 10, 11, 13, 14, 16], "readabl": [0, 12], "unfortun": 0, "thi": [0, 1, 2, 3, 4, 6, 7, 8, 11, 12, 13, 14, 15, 16], "clash": 0, "which": [0, 1, 2, 6, 7, 8, 11, 13, 15, 16], "do": [0, 1, 2, 3, 6, 7, 8, 11, 14, 15, 16], "understand": [0, 6, 8, 10, 16], "guarante": [0, 1, 6, 11, 15], "particular": [0, 1, 2, 4, 6, 8], "children": [0, 1, 4, 6, 10, 11, 15, 16], "instead": [0, 1, 2, 3, 6, 7, 8, 10, 11, 12, 14, 15, 16], "can": [0, 1, 2, 3, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16], "inlin": [0, 1], "nest": [0, 11], "For": [0, 1, 2, 3, 4, 6, 8, 9, 11, 12, 14, 15, 16], "exampl": [0, 1, 4, 6, 7, 8, 9, 11, 12, 13, 15, 16], "have": [0, 1, 2, 6, 7, 8, 9, 10, 11, 12, 14, 15], "written": [0, 10], "follow": [0, 1, 2, 4, 6, 7, 8, 10, 11, 12, 13, 15, 16], "def": [0, 1, 2, 7, 8, 9, 11, 13, 14, 15], "get_identifier_nam": 0, "cst": [0, 1, 2, 5, 7, 8, 9, 10, 11, 12, 13, 14, 15], "cstnode": [0, 1, 4, 5, 6, 8, 12, 13, 14, 15], "option": [0, 1, 4, 6, 7, 8, 10, 11, 12, 14, 15], "str": [0, 1, 2, 3, 4, 6, 8, 11, 12, 13, 14, 15], "m": [0, 1, 2, 6, 7, 13], "name": [0, 1, 2, 4, 6, 7, 9, 10, 12, 13, 14, 15, 16], "assert": [0, 2, 4, 11], "return": [0, 1, 2, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15], "none": [0, 1, 2, 4, 6, 7, 8, 9, 11, 12, 13, 14, 15, 16], "could": [0, 1, 6, 7, 8, 10, 11, 13, 15, 16], "write": [0, 1, 5, 6, 7, 8, 9, 10, 11, 14], "someth": [0, 2, 7, 8, 13], "like": [0, 1, 2, 3, 6, 7, 8, 11, 12, 13, 15, 16], "els": [0, 7, 8, 11, 12, 13], "If": [0, 1, 2, 3, 4, 6, 8, 10, 11, 12, 13, 15], "find": [0, 8, 11, 13], "yourself": 0, "attempt": [0, 1, 11], "manual": [0, 1, 6, 8, 11], "decor": [0, 4, 5, 11], "mai": [0, 1, 3, 6, 8, 11, 12, 13, 15], "entail": 0, "ad": [0, 1, 2, 4, 7, 9, 12, 14, 16], "addit": [0, 1, 3, 6, 8, 10, 11], "state": [0, 1, 6, 7, 15], "result": [0, 1, 3, 6, 8, 9, 10, 11, 16], "work": [0, 1, 6, 8, 11, 16], "after": [0, 1, 2, 4, 6, 10, 11, 12, 13, 14, 15], "chang": [0, 1, 2, 3, 6, 7, 10, 11, 12, 13, 14, 15, 16], "itself": [0, 1, 2, 6, 7, 8, 11, 16], "class": [0, 1, 2, 3, 6, 7, 8, 9, 11, 12, 13, 14, 15], "countbazfoobararg": 0, "cstvisitor": [0, 1, 5, 6, 8, 9, 11, 14, 15], "given": [0, 1, 2, 4, 6, 8, 11, 13, 16], "function": [0, 1, 4, 5, 7, 8, 9, 10, 12, 13, 14], "count": [0, 1, 6], "how": [0, 1, 8, 11, 14], "mani": [0, 8, 11], "argument": [0, 1, 2, 4, 6, 7, 11, 15, 16], "those": [0, 1, 4, 6, 8, 11, 13], "call": [0, 1, 2, 3, 4, 6, 7, 8, 12, 15, 16], "identifi": [0, 2, 6, 7, 8, 10, 11, 13, 14], "baz": [0, 1, 2], "foobar": 0, "__init__": [0, 1, 2, 7, 8, 9, 11, 13, 14], "self": [0, 1, 2, 7, 8, 9, 11, 13, 14, 15], "super": [0, 2, 7, 9], "arg_count": 0, "int": [0, 1, 3, 6, 7, 8, 11, 12, 14], "0": [0, 4, 5, 6, 7, 8, 9, 11, 12, 13, 14], "visit_cal": [0, 7], "see": [0, 1, 2, 6, 7, 8, 9, 11, 12, 13, 14, 15], "one": [0, 1, 2, 4, 6, 7, 8, 10, 11, 12, 15], "our": [0, 2, 3, 6, 7, 15], "care": [0, 2, 6, 7, 11, 15, 16], "about": [0, 1, 7, 11, 12, 13, 15, 16], "func": [0, 6, 7, 11, 16], "loop": [0, 7, 8, 11], "through": [0, 1, 2, 8, 9, 10, 13], "each": [0, 1, 2, 3, 4, 6, 7, 8, 10, 11, 15], "arg": [0, 1, 2, 4, 6, 7, 11, 15, 16], "an": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16], "what": [0, 1, 2, 6, 8, 10, 11], "want": [0, 1, 2, 3, 6, 7, 8, 9, 10, 13, 14, 15], "1": [0, 1, 5, 6, 7, 8, 9, 11, 12, 13, 14, 15, 16], "matcherdecoratablevisitor": [0, 1, 6], "call_stack": 0, "list": [0, 1, 2, 4, 6, 7, 8, 10, 11, 12, 14], "store": [0, 1, 3, 4, 6, 8, 11, 12, 13, 14, 16], "all": [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 15, 16], "stack": [0, 14], "append": [0, 13, 14], "leave_cal": [0, 7], "original_nod": [0, 1, 2, 6, 7, 11, 13, 14, 15], "pop": [0, 14], "latest": 0, "off": [0, 1, 16], "visit": [0, 1, 5, 6, 7, 8, 9, 11, 13], "_count_arg": 0, "most": [0, 1, 2, 4, 8, 9, 11, 12, 16], "shallow": 0, "re": [0, 1, 2, 6, 8, 10, 11, 12, 13, 14], "interest": [0, 2, 7], "so": [0, 1, 2, 3, 4, 6, 7, 8, 10, 11, 15], "onli": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16], "than": [0, 4, 6, 8, 11, 12, 16], "previou": [0, 3, 4, 7, 11], "arguabl": 0, "maintain": [0, 8, 9], "part": [0, 3, 4, 8, 10, 11, 13, 15], "It": [0, 1, 2, 3, 5, 6, 7, 8, 10, 11, 12, 15, 16], "also": [0, 1, 2, 6, 7, 8, 11, 16], "immun": 0, "ani": [0, 1, 2, 3, 4, 6, 7, 8, 10, 11, 12, 15], "futur": [0, 1, 2, 8, 11], "shape": [0, 6, 7], "note": [0, 1, 4, 6, 7, 8, 11, 12, 14, 15], "complet": [0, 1, 2, 6, 7, 9, 10], "both": [0, 1, 6, 7, 8, 11, 15], "case": [0, 1, 3, 6, 7, 8, 9, 11, 13, 15], "first": [0, 6, 7, 9, 11, 14, 15, 16], "appear": [0, 1, 6, 7, 8, 11, 15], "faster": [0, 1, 3], "actual": [0, 1, 7, 11], "same": [0, 1, 2, 3, 6, 8, 10, 11, 12, 14, 15, 16], "amount": [0, 16], "second": [0, 1, 6, 8, 9, 11, 16], "csttransform": [0, 1, 5, 6, 7, 8, 9, 11, 13, 14, 15], "modif": [0, 1, 3, 5, 6, 15], "The": [0, 1, 2, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16], "paramet": [0, 1, 2, 4, 6, 8, 9, 10, 11, 14, 16], "leave_": [0, 6, 15], "book": 0, "keep": [0, 1, 5, 13, 14], "equal": [0, 1, 6, 11, 15, 16], "via": [0, 8, 12], "correspond": [0, 1, 6, 11], "visit_": [0, 6, 15], "rememb": [0, 1, 2, 4], "immut": [0, 8, 9, 11], "new": [0, 1, 2, 3, 4, 6, 8, 11, 12, 13, 15], "henc": [0, 3], "time": [0, 1, 3, 6, 8, 13, 15], "get": [0, 1, 2, 3, 6, 7, 8, 11, 13], "updat": [0, 1, 2, 3, 11, 13, 15], "whose": [0, 6], "been": [0, 1, 2, 6, 15], "therefor": [0, 6], "explicitli": [0, 8, 11], "discard": 0, "perform": [0, 1, 2, 3, 6, 8, 10, 11, 14, 15, 16], "sai": [0, 2, 7], "renam": 0, "were": [0, 1, 2, 3, 6, 14], "global": [0, 8, 11], "might": [0, 1, 2, 3, 6, 8, 11, 15], "functionrenam": 0, "with_chang": [0, 7, 11, 13, 14], "renamed_": 0, "consid": [0, 4, 6, 8], "version": [0, 1, 2, 11, 12, 14], "ha": [0, 1, 2, 6, 8, 10, 11, 15], "subtl": 0, "bug": [0, 13], "snippet": [0, 12, 16], "some_func": [0, 7], "2": [0, 6, 7, 8, 9, 11, 12, 13, 14, 15, 16], "other_func": 0, "3": [0, 1, 2, 5, 6, 7, 8, 9, 11, 12, 13, 14], "run": [0, 1, 5, 6, 7, 8, 9, 11, 12, 15], "u": [0, 1, 2, 6, 7, 8, 10, 11, 13, 16], "look": [0, 1, 2, 6, 7, 8, 15, 16], "renamed_some_func": 0, "renamed_other_func": 0, "howev": [0, 1, 3, 6, 7, 8, 11, 12, 16], "That": [0, 2, 7, 8, 11, 13], "becaus": [0, 1, 6, 7, 8, 10, 11, 12, 15], "contain": [0, 1, 2, 3, 4, 6, 8, 10, 11, 12, 13, 15], "By": [0, 1, 8, 11, 16], "accident": [0, 11, 15], "done": [0, 6, 11], "deeper": [0, 8], "complex": [0, 6, 7, 8, 11, 12, 16], "pass": [0, 1, 3, 4, 6, 7, 8, 10, 11, 12, 15], "string": [0, 1, 2, 4, 6, 8, 10, 12, 13, 14, 15, 16], "parse_stat": [0, 5, 11, 12, 14], "parse_express": [0, 5, 11, 12, 14, 15], "construct": [0, 1, 5, 6, 8, 10, 11, 12, 13, 15], "alwai": [0, 6, 8, 10, 11, 15, 16], "order": [0, 1, 5, 7, 9, 10, 11, 14], "default": [0, 1, 2, 6, 8, 10, 11, 12, 13, 14, 15, 16], "modul": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 13, 14, 16], "even": [0, 1, 6, 10, 11, 13], "helper": [0, 1, 5, 6, 7, 10, 14], "attribut": [0, 1, 4, 6, 7, 8, 10, 12, 14, 15], "config_for_pars": [0, 1, 11], "easi": [0, 1, 10, 14, 15], "ensur": [0, 1, 2, 7, 8, 11], "line": [0, 2, 4, 5, 6, 8, 10, 11, 12, 13, 14, 16], "end": [0, 6, 8, 11, 12, 16], "indent": [0, 3, 11, 12], "consist": [0, 1, 11, 12, 14], "add": [0, 1, 2, 4, 11, 12, 13, 15], "print": [0, 1, 7, 8, 9, 11, 12, 13, 14, 15], "statement": [0, 1, 3, 4, 5, 8, 10, 12, 13, 15], "parse_modul": [0, 1, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14, 15], "some_code_str": 0, "new_modul": [0, 7], "bodi": [0, 8, 9, 11, 15, 16], "hello": 0, "world": [0, 6], "new_code_str": 0, "leav": [0, 2, 5, 6, 7, 8], "mean": [0, 1, 3, 6, 7, 8, 11], "assum": [0, 1, 2, 11, 12, 15], "format": [0, 1, 2, 5, 8, 12, 14, 16], "differ": [0, 1, 6, 8, 11, 12], "rest": [0, 2, 6, 7, 15], "wa": [0, 1, 6, 7, 11, 14, 15], "In": [0, 1, 6, 7, 8, 10, 11, 14, 15], "abov": [0, 1, 2, 4, 6, 7, 8, 10, 11, 12, 15, 16], "alreadi": [0, 1, 2, 3, 4, 6, 7, 13, 16], "pars": [0, 1, 2, 4, 5, 8, 10, 11, 13, 15, 16], "neglect": 0, "insert": [0, 4, 10, 11, 12, 15], "window": [0, 1], "unix": [0, 1], "file": [0, 1, 2, 3, 7, 8, 10, 11, 12, 16], "vice": [0, 10], "versa": [0, 10], "depend": [0, 1, 3, 8, 11, 12, 15], "system": [0, 1, 8], "ran": 0, "under": [0, 1, 4, 6, 11], "defin": [1, 2, 6, 7, 8, 10, 11, 13, 15, 16], "autom": [1, 5, 14], "refactor": [1, 5, 6, 7, 13, 14], "appli": [1, 3, 6, 11], "codebas": [1, 2], "arbitrari": [1, 6, 8, 11], "size": 1, "provid": [1, 3, 4, 5, 6, 7, 11, 12, 13, 14, 15, 16], "framework": 1, "higher": [1, 4, 6], "simpler": [1, 6, 10, 16], "includ": [1, 2, 3, 4, 6, 7, 8, 11, 12, 15], "provis": [1, 2], "quickli": 1, "creat": [1, 4, 6, 7, 8, 11, 15, 16], "deriv": [1, 11, 12], "from": [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 15, 16], "common": [1, 6, 11, 14], "context": [1, 2, 6, 11, 12], "automat": [1, 5, 6, 8, 9, 11, 14, 15], "metadata": [1, 2, 3, 5, 6, 11, 13, 15], "resolut": [1, 8, 15], "multi": [1, 11, 12], "intend": [1, 7, 8], "transform_modul": 1, "sourc": [1, 3, 4, 5, 6, 7, 8, 10, 11, 12, 13, 15, 16], "abstract": [1, 2, 5, 6, 8, 10, 11], "must": [1, 2, 4, 6, 11, 15, 16], "subclass": [1, 4, 6, 8, 11, 13, 14, 15], "wish": [1, 2, 6, 16], "non": [1, 4, 8, 11, 12], "mutat": [1, 11], "tree": [1, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14, 15], "directli": [1, 6, 8, 10, 11, 12, 15], "contextawaretransform": 1, "metadatadepend": [1, 6, 8], "declar": [1, 8, 11], "metadata_depend": [1, 8, 9], "properti": [1, 6, 8, 11, 12, 16], "get_metadata": [1, 8, 9], "retriev": [1, 6, 8], "resolv": [1, 6, 8, 9, 11, 13], "should_allow_multiple_pass": 1, "bool": [1, 3, 6, 7, 8, 9, 11, 14, 15], "overrid": [1, 11, 12, 15], "true": [1, 2, 6, 7, 8, 9, 10, 11, 14, 15, 16], "allow": [1, 3, 6, 7, 8, 10, 11, 15, 16], "repeatedli": [1, 2], "until": 1, "doesn": [1, 6, 8, 11, 12, 14, 15, 16], "t": [1, 2, 3, 6, 7, 8, 10, 11, 12, 14, 15, 16], "between": [1, 6, 8, 10, 11, 16], "suffic": 1, "warn": [1, 3, 5], "emit": 1, "displai": [1, 11], "user": [1, 2, 3, 8, 11, 12], "who": 1, "invok": 1, "refer": [1, 2, 6, 8, 11], "current": [1, 2, 3, 4, 6, 8, 11, 12, 14], "travers": [1, 5, 8, 14], "avail": [1, 2, 6, 8, 11, 15], "dure": [1, 11], "particularli": 1, "handi": 1, "code_for_nod": [1, 3, 11, 12], "don": [1, 2, 6, 7, 8, 11, 14, 15, 16], "track": [1, 6, 7, 8, 11, 13], "top": [1, 2, 3, 6, 8, 11, 16], "level": [1, 3, 4, 6, 8, 10, 11, 15], "transform_module_impl": 1, "take": [1, 2, 4, 6, 7, 8, 10, 11, 15, 16], "calcul": [1, 11], "lifetim": 1, "entrypoint": [1, 12], "handl": [1, 7, 8, 9, 12, 13, 15], "logic": [1, 6, 7, 10], "codemodcontext": [1, 2], "A": [1, 6, 8, 10, 11, 12, 15, 16], "hold": [1, 11], "inform": [1, 3, 6, 8, 9, 11, 12, 13, 16], "share": 1, "amongst": 1, "singl": [1, 3, 4, 6, 7, 8, 10, 11, 12, 15], "invoc": 1, "when": [1, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15], "chain": [1, 6, 11], "multipl": [1, 3, 6, 7, 8, 10, 11, 13, 15], "togeth": [1, 4, 11], "need": [1, 2, 3, 6, 7, 8, 10, 11, 12, 14, 15, 16], "respons": 1, "wrapper": [1, 6, 8, 9, 10, 13], "filenam": 1, "being": [1, 3, 6, 9, 11, 12], "modifi": [1, 2, 3, 5, 6, 7, 10, 11, 13, 14, 15, 16], "gather": [1, 9], "contextawarevisitor": 1, "scratch": 1, "dict": [1, 6, 8, 11, 13, 14], "dictionari": [1, 6], "spread": 1, "across": [1, 6, 11], "free": 1, "live": 1, "disk": 1, "popul": 1, "parallel_exec_transform_with_prettyprint": 1, "full_module_nam": 1, "repositori": [1, 2, 8], "root": [1, 2, 3, 6, 8], "correctli": [1, 10, 16], "configur": [1, 12], "Will": 1, "form": [1, 6, 11], "dot": [1, 4, 8, 11], "foo": [1, 2, 4, 6, 7, 9, 15], "bar": [1, 2, 4], "repo": [1, 2], "py": [1, 2, 8], "metadatawrapp": [1, 6, 8, 13, 15], "To": [1, 6, 8, 11, 13, 14], "access": [1, 2, 5, 10, 11, 12, 13, 14], "comput": [1, 3, 8, 11, 15], "insid": [1, 2, 4, 6, 7, 8, 11, 15], "activ": 1, "metadata_manag": 1, "fullrepomanag": [1, 8], "manag": [1, 6, 7, 8, 11, 15], "As": [1, 6, 7, 8, 10, 11, 15], "conveni": [1, 6, 8, 11, 12, 15], "compat": [1, 6, 12], "extend": [1, 8, 9, 11], "featur": [1, 6, 7, 11], "still": [1, 6, 7, 11, 15], "implement": [1, 6, 8, 13, 14, 15, 16], "matcherdecoratabletransform": [1, 6, 7], "well": [1, 2, 5, 6, 7, 9, 11, 16], "collect": [1, 8, 13, 14], "info": 1, "collector": 1, "sinc": [1, 6, 11, 12], "parent": [1, 6, 11, 15], "cannot": [1, 6, 11, 13, 15], "definit": [1, 8, 11, 15], "instanti": [1, 2], "befor": [1, 2, 4, 6, 7, 8, 11, 15], "its": [1, 2, 3, 4, 6, 7, 8, 10, 11, 13, 15, 16], "own": [1, 2, 4, 8, 10, 11, 15], "strict": [1, 6], "subset": 1, "necessari": [1, 10, 16], "bail": [1, 7], "mid": 1, "oper": [1, 3, 5, 6, 7, 8, 10, 12, 14, 15, 16], "realiz": 1, "reason": [1, 3, 8, 10, 11, 12], "skip": [1, 6, 8, 11], "rais": [1, 4, 6, 8, 11, 12, 15], "skipfil": 1, "except": [1, 3, 4, 6, 8, 11, 12, 15], "up": [1, 5, 6, 7, 8, 10, 11, 15], "thrown": 1, "preserv": [1, 11, 12, 16], "messag": [1, 4, 11, 12], "final": [1, 2, 6, 7, 11, 12], "test": [1, 3, 5, 11], "verif": 1, "project": [1, 8], "codemodtest": [1, 2], "develop": [1, 13, 15], "major": [1, 12], "just": [1, 3, 6, 7, 8, 9, 10, 11, 13], "augment": 1, "unexpect": [1, 2, 15], "edg": [1, 6], "facil": 1, "auto": 1, "kwarg": [1, 11], "assertcodemod": [1, 2], "verifi": [1, 2, 7, 10, 13, 14], "code": [1, 2, 4, 5, 6, 7, 8, 10, 11, 12, 13, 16], "chunk": 1, "unittest": [1, 2], "favorit": 1, "runner": 1, "ellipsi": [1, 11], "classmethod": [1, 8, 11], "addclasscleanup": 1, "addcleanup": 1, "cleanup": 1, "item": [1, 8, 10, 11], "setupclass": 1, "fail": [1, 11], "unlik": [1, 4, 6, 11, 15], "teardownclass": 1, "assertcodeequ": 1, "expect": [1, 6, 12, 13, 14], "sure": [1, 4, 6], "thei": [1, 2, 6, 8, 10, 11, 12, 13, 14, 15], "sanit": 1, "safe": [1, 6, 7, 8, 10, 11, 15], "come": [1, 6, 8, 11, 16], "tripl": [1, 11], "quot": [1, 11], "object": [1, 4, 6, 7, 8, 12, 13, 14], "context_overrid": 1, "python_vers": [1, 12], "expected_warn": 1, "sequenc": [1, 7, 11, 15], "expected_skip": 1, "fals": [1, 6, 7, 8, 9, 11, 14, 15], "constructor": [1, 7, 11, 12], "specifi": [1, 2, 6, 7, 8, 10, 11, 15], "valid": [1, 2, 3, 4, 6, 8, 10, 11, 12, 15], "successfulli": [1, 7], "unless": [1, 8, 10, 11], "empti": [1, 4, 6, 10, 11, 12, 13, 15], "addition": [1, 6, 16], "python": [1, 2, 4, 5, 6, 7, 8, 10, 11, 12, 15, 16], "parser": [1, 8, 11, 12, 16], "overridden": 1, "6": [1, 2, 5, 7, 12, 13, 14], "interpret": [1, 11, 12], "gener": [1, 2, 5, 6, 8, 11, 12, 13, 15, 16], "left": [1, 6, 7, 11, 12, 14, 15, 16], "assertnolog": 1, "logger": 1, "log": [1, 8], "logger_nam": 1, "doclasscleanup": 1, "normal": [1, 6, 8, 11], "enterclasscontext": 1, "cm": 1, "entercontext": 1, "wide": 1, "enter": 1, "suppli": [1, 3, 6, 10, 11, 12], "success": 1, "__exit__": 1, "__enter__": 1, "static": [1, 8, 10, 11, 14], "make_fixture_data": 1, "data": [1, 4, 8, 11], "origint": 1, "dedent": [1, 8, 11], "trail": [1, 4, 8, 10, 11, 12], "newlin": [1, 4, 11, 12, 16], "present": [1, 2, 6, 11, 16], "document": [1, 2, 6, 7, 9, 11], "section": [1, 11], "meant": 1, "programmat": [1, 14], "manner": [1, 8, 9], "featureset": 1, "union": [1, 2, 4, 6, 8, 11, 12, 13, 15], "transformsuccess": 1, "transformfailur": 1, "transformexit": 1, "transformskip": 1, "repres": [1, 6, 8, 10, 11, 12, 16], "transformresult": 1, "never": [1, 2, 8], "On": 1, "interrupt": 1, "ctrl": 1, "c": [1, 8, 11, 13], "elect": 1, "throw": [1, 8], "decid": [1, 6, 14], "occur": [1, 11, 12], "crash": 1, "alia": [1, 6, 11, 15], "upon": [1, 8], "content": [1, 2, 11, 12], "warning_messag": 1, "post": 1, "failur": 1, "error": [1, 2, 5], "traceback_str": 1, "traceback": 1, "record": [1, 3, 8], "request": [1, 15], "due": [1, 4, 11, 16], "blacklist": 1, "skip_reason": 1, "skipreason": 1, "skip_descript": 1, "descript": [1, 2], "enumer": 1, "detect": [1, 12], "e": [1, 3, 6, 8, 11, 12, 13], "g": [1, 3, 8, 11, 12, 13], "keyboardinterrupt": 1, "facilit": [1, 15], "achiev": [1, 10], "codemodcommand": 1, "util": [1, 2, 3], "tool": [1, 2, 13, 16], "translat": 1, "custom": [1, 2, 8], "help": [1, 2, 7, 11, 13], "brief": 1, "overview": 1, "univers": 1, "python3": [1, 2], "parallel": [1, 15], "seri": [1, 2, 11, 12], "directori": [1, 2, 8], "accord": 1, "formatt": [1, 2], "unifi": 1, "diff": 1, "them": [1, 2, 3, 6, 11, 15], "stdin": 1, "stdout": 1, "progress": [1, 2], "stderr": 1, "noop": 1, "noopcommand": 1, "where": [1, 4, 6, 7, 10, 11, 12, 16], "found": [1, 6, 7, 8, 9, 11], "initi": [1, 2, 3, 6, 8, 10, 11], "enabl": [1, 7], "behav": [1, 6, 11], "ident": [1, 6, 8, 11, 14], "text": [1, 11], "certain": [1, 4, 6], "addimportsvisitor": [1, 2], "import": [1, 2, 4, 5, 7, 8, 9, 11, 12, 14, 15, 16], "removeimportsvisitor": 1, "remov": [1, 5, 6, 7, 10, 11, 15, 16], "unreferenc": 1, "No": [1, 10], "short": [1, 6, 7], "summari": 1, "show": [1, 2, 12, 13, 14], "add_arg": [1, 2], "arg_pars": [1, 2], "argumentpars": [1, 2], "cli": 1, "These": [1, 3, 8, 11], "posit": [1, 3, 6, 9, 11, 13], "keyword": [1, 4, 11, 16], "few": [1, 2, 3, 6, 7], "boilerpl": [1, 4, 7], "visitorbasedcodemodcommand": [1, 2], "act": [1, 6], "magicargscodemodcommand": 1, "magic": [1, 2, 10], "yield": [1, 11], "get_transform": 1, "kei": [1, 6, 8, 11, 14], "easiest": 1, "subsequ": [1, 11], "usual": [1, 8, 11, 16], "possibl": [1, 6, 8, 9, 10, 11, 15, 16], "point": [1, 2, 11], "sever": [1, 2, 6], "de": 1, "facto": 1, "circumst": [1, 6], "demand": 1, "gather_fil": 1, "files_or_dir": 1, "include_stub": 1, "intermingl": 1, "exist": [1, 3, 4, 6, 8, 10, 11, 15], "locat": [1, 2, 3, 4, 6, 8, 13], "pyi": 1, "stub": [1, 15], "exec_transform_with_prettyprint": 1, "include_gener": 1, "generated_code_mark": 1, "format_cod": 1, "formatter_arg": 1, "marker": [1, 2, 11], "spot": 1, "doe": [1, 2, 3, 4, 6, 7, 8, 10, 11, 12, 15, 16], "otherwis": [1, 6, 11, 13, 15], "binari": [1, 6], "whether": [1, 6, 8, 11, 14, 15], "input": [1, 4, 10, 12, 16], "job": [1, 8, 16], "unified_diff": [1, 13, 14], "show_success": 1, "hide_gener": 1, "hide_blacklist": 1, "hide_progress": 1, "blacklist_pattern": 1, "repo_root": 1, "paralleltransformresult": 1, "fork": [1, 8], "control": [1, 6, 8], "maximum": 1, "number": [1, 6, 8, 12, 13, 16], "flight": 1, "least": [1, 6, 11], "cpu": 1, "core": [1, 2], "themselv": [1, 6, 11], "indic": [1, 2, 6, 8, 11, 12, 15], "supress": 1, "similarli": [1, 6, 11], "regex": [1, 6], "api": [1, 5, 11], "fact": [1, 4, 6, 7], "lambda": [1, 6], "pickleabl": 1, "pickl": 1, "undefin": [1, 5, 8], "implicitli": [1, 6, 11], "reli": 1, "behavior": [1, 12, 15], "pleas": [1, 6, 8], "simpl": [1, 2, 4, 6, 9, 13, 15, 16], "diff_cod": 1, "oldcod": 1, "newcod": 1, "two": [1, 4, 6, 7, 8, 9, 11, 14, 16], "produc": [1, 2, 8, 11], "assign": [1, 6, 8, 13, 16], "compar": [1, 6, 7, 8, 11], "revis": 1, "softwar": 1, "reduc": [1, 4, 7, 16], "now": [1, 2, 16], "gatherimportsvisitor": 1, "substitut": [1, 2, 4], "scope": [1, 5], "analysi": [1, 5, 8, 14], "qualifi": [1, 6], "robust": 1, "determin": [1, 6, 11], "module_import": 1, "alias": [1, 11], "object_map": 1, "map": [1, 8, 15], "module_alias": 1, "local": [1, 8, 10, 11, 13], "alias_map": 1, "tupl": [1, 8, 11, 12, 14], "syntax": [1, 2, 3, 4, 5, 6, 10, 11, 14], "opt": [1, 10], "origin": [1, 6, 7, 8, 10, 11, 15, 16], "all_import": 1, "importfrom": [1, 8, 11, 13], "encount": [1, 11, 12], "gatherexportsvisitor": 1, "export": 1, "__all__": 1, "variabl": [1, 2, 4, 8, 11, 13], "explicit_exported_object": 1, "absent": 1, "question": [1, 15], "add_needed_import": [1, 2], "give": [1, 2, 9, 10, 11], "would": [1, 6, 7, 8, 10, 11, 15, 16], "anoth": [1, 6, 7, 8, 11, 16], "schedul": 1, "obj": [1, 6], "asnam": [1, 11, 13], "finish": 1, "action": [1, 7, 13], "avoid": [1, 3, 5, 11], "duplic": [1, 7, 8], "longer": [1, 6], "long": [1, 6], "remain": 1, "abl": [1, 9, 10, 11], "unabl": [1, 11], "__any__": 1, "remove_unused_import": 1, "stop": [1, 6, 14], "remove_unused_import_by_nod": 1, "referenc": [1, 4, 11], "especi": 1, "go": [1, 7, 11], "removefrompar": [1, 5, 6, 13, 15], "rid": [1, 7], "leave_annassign": 1, "annassign": [1, 8, 11], "updated_nod": [1, 2, 5, 6, 7, 11, 13, 14, 15], "removalsentinel": [1, 5, 6, 11, 13, 15], "annot": [1, 4, 6, 8, 11, 13], "clean": [1, 2, 11], "removalfrompar": 1, "hood": [1, 6], "basemetadataprovid": [1, 6, 8], "name_provid": [1, 8], "qualifiednameprovid": [1, 6, 8], "scope_provid": [1, 8, 13], "scopeprovid": [1, 8, 13], "somewher": 1, "exeuct": 1, "applytypeannotationsvisitor": 1, "mdule": 1, "store_stub_in_context": 1, "x": [1, 4, 8, 9, 11], "stub_modul": 1, "source_modul": 1, "overwritten": 1, "overwrit": [1, 6, 8, 11, 13, 15], "overwrite_existing_annot": 1, "later": [1, 6, 14], "flag": 1, "last": [1, 4, 6, 8, 11], "effect": [1, 6, 10, 11, 15], "gatherunusedimportsvisitor": 1, "process": [1, 4, 8], "full": [1, 4, 8, 11], "indirectli": 1, "unused_import": [1, 13], "unus": [1, 5, 11], "importalia": [1, 11], "pair": [1, 8, 11], "parent_import": 1, "filter_unused_import": 1, "candid": 1, "iter": [1, 2, 6, 8, 11, 13, 15], "main": 1, "is_in_us": 1, "filter": 1, "gathercommentsvisitor": 1, "comment": [1, 4, 5, 10, 11, 12, 16], "captur": [1, 6, 11], "special": [1, 11], "purpos": [1, 6, 8, 11], "noqa": 1, "style": [1, 2, 14], "lint": [1, 3, 13], "suppress": 1, "standalon": 1, "affect": [1, 11], "ones": 1, "classvar": [1, 8], "providert": [1, 8], "position_provid": [1, 8], "positionprovid": [1, 6, 8, 9, 13], "gathernamesfromstringannotationsvisitor": 1, "liter": [1, 6, 7, 8], "sometyp": 1, "relat": 1, "typevar": 1, "larg": 2, "scale": 2, "entir": [2, 3, 4, 6, 8, 11, 12, 13], "let": [2, 7, 11, 16], "convert": [2, 6, 11], "legaci": 2, "shini": 2, "f": [2, 4, 8, 9, 13], "ship": [2, 8, 9, 12], "command": [2, 5, 8], "interfac": [2, 5, 8, 9], "known": 2, "librari": [2, 5, 8, 11, 16], "pre": 2, "try": [2, 6, 7, 8, 11, 12], "lucki": 2, "enough": [2, 3, 16], "perfectli": 2, "chanc": 2, "edit": 2, "yaml": 2, "extern": [2, 3, 8], "black": [2, 16], "blackist": 2, "touch": 2, "execut": [2, 5, 8, 11, 12, 15], "specif": [2, 6, 8, 11], "organ": 2, "discov": 2, "quick": [2, 8], "ll": [2, 9, 11, 13, 14], "convert_format_to_fstr": 2, "convertformatstringcommand": 2, "right": [2, 4, 6, 7, 11, 12, 14, 15], "whirl": 2, "subdirectori": 2, "replac": [2, 3, 6, 11, 15], "rel": [2, 8, 11, 16], "walk": 2, "anyth": [2, 11, 12], "consol": [2, 8], "everyth": 2, "notic": [2, 3, 11, 15], "principl": [2, 4], "packag": [2, 4], "isol": 2, "constant": [2, 8, 11], "ve": [2, 6, 7, 15, 16], "got": [2, 7], "everi": [2, 6, 11, 15], "raw": [2, 11, 12], "simplest": 2, "similar": [2, 4, 6, 8, 11, 14], "argpars": 2, "ast": [2, 5, 8, 10, 11, 14], "literal_ev": [2, 11], "convertconstantcommand": 2, "codemodd": 2, "staticmethod": 2, "add_argu": 2, "dest": 2, "metavar": 2, "requir": [2, 4, 6, 8, 10, 11, 15, 16], "base": [2, 4, 5, 6, 8, 11, 15], "save": [2, 6, 13], "init": [2, 6, 11], "leave_simplestr": 2, "simplestr": [2, 4, 6, 8, 11, 15], "know": [2, 4, 7, 8, 10, 11], "isn": [2, 6, 7, 8, 10, 11, 16], "concern": [2, 6, 7], "unchang": [2, 6], "pretti": [2, 14], "member": 2, "properli": [2, 12], "cool": 2, "constant_fold": 2, "happen": [2, 8, 10, 11], "unit": [2, 8], "desir": [2, 11], "fold": 2, "wrote": [2, 9], "testconvertconstantcommand": 2, "test_noop": 2, "test_substitut": 2, "test_constant_fold": 2, "minor": [3, 12], "releas": [3, 11], "probabl": [3, 8, 11], "shouldn": [3, 10, 11, 12], "pin": 3, "applic": [3, 5, 14], "exact": [3, 5, 11, 12, 16], "breakag": 3, "experimentalreentrantcodegenprovid": 3, "fast": 3, "increment": [3, 8], "optim": 3, "nich": 3, "friendli": 3, "without": [3, 6, 8, 10, 11, 12, 15], "rare": 3, "onc": [3, 9, 11], "think": [3, 6, 8, 11, 16], "why": [3, 5, 8], "independ": 3, "patch": 3, "accept": [3, 4, 11, 12], "reject": 3, "architectur": 3, "advantag": [3, 7, 9, 15], "regener": 3, "typecheck": [3, 8], "pyre": [3, 8, 11], "mypi": [3, 8], "small": [3, 8, 11], "lot": [3, 7], "restrict": [3, 6, 11], "safeti": [3, 9], "saniti": 3, "smallest": 3, "granular": [3, 16], "recurs": [3, 4, 8, 11], "unpatch": 3, "piec": [3, 8, 12, 16], "layer": [3, 10], "codegenparti": 3, "either": [3, 6, 7, 8, 11], "get_modified_code_rang": 3, "get_modified_cod": 3, "old": [3, 14], "start_offset": 3, "end_offset": 3, "has_trailing_newlin": [3, 11, 16], "get_original_module_cod": 3, "equival": [3, 6, 8, 11, 12, 15, 16], "byte": [3, 4, 8, 10, 11, 12], "cach": [3, 8], "get_original_module_byt": 3, "get_original_statement_cod": 3, "get_modified_statement_cod": 3, "basestat": [3, 4, 11, 15], "inherit": [3, 7, 8, 11, 12], "detail": [3, 5, 8, 11, 13, 14], "get_modified_module_cod": 3, "place": [3, 4, 6, 11, 15], "get_modified_module_byt": 3, "built": [4, 8, 9, 15], "recur": 4, "read": [4, 7, 8, 11, 14], "direct": 4, "assist": 4, "parse_template_modul": 4, "templat": [4, 5, 11], "config": [4, 5, 11, 12], "partialparserconfig": [4, 5, 11, 12], "template_replac": 4, "baseexpress": [4, 6, 7, 11, 12], "assigntarget": [4, 11], "param": [4, 7, 8, 9, 11, 14], "basesmallstat": [4, 11, 15], "basesuit": [4, 11], "baseslic": [4, 11], "subscriptel": [4, 11], "lead": [4, 8, 11, 12], "whitespac": [4, 5, 8, 10, 12, 16], "appropri": [4, 11], "expans": [4, 11, 12], "mod": 4, "n": [4, 6, 7, 8, 9, 11, 12, 13, 15, 16], "fromimport": 4, "best": [4, 5, 6, 15], "practic": [4, 5, 6], "support": [4, 5, 6, 8, 11, 12, 14], "parse_template_express": 4, "express": [4, 5, 6, 7, 10, 12], "nowher": [4, 12], "y": [4, 9, 11], "binaryoper": [4, 6, 11, 12, 14, 15], "parse_template_stat": 4, "simplestatementlin": [4, 11, 12, 16], "basecompoundstat": [4, 11, 12], "msg": [4, 11], "uh": [4, 11], "oh": [4, 11], "greater": 4, "zero": [4, 6, 7, 11, 12], "insert_header_com": 4, "header": [4, 11, 16], "copyright": 4, "preambl": 4, "start": [4, 6, 8, 9, 11, 12, 13, 15], "get_full_name_for_nod": 4, "concaten": [4, 11], "subscript": [4, 8], "functiondef": [4, 8, 10, 11, 14, 15], "classdef": [4, 8, 11, 14], "get_full_name_for_node_or_rais": 4, "nodetyp": 4, "cstnodet": [4, 6, 11, 15], "refin": 4, "convinc": 4, "situat": 4, "5": [5, 6, 7, 8, 11, 12, 13, 14], "7": [5, 7, 11, 12, 14], "8": [5, 7, 9, 11, 12, 13, 16], "parenthes": [5, 8, 11], "etc": [5, 8, 11], "build": [5, 6, 7], "codemod": [5, 14], "linter": 5, "concret": [5, 11, 14], "motiv": 5, "represent": [5, 8, 11, 14], "eas": 5, "basic": 5, "usag": [5, 8, 11], "isinst": [5, 7, 11, 13], "prefer": [5, 8, 11], "miscellan": 5, "mayb": [5, 6], "sentinel": 5, "flattensentinel": [5, 11, 15], "batch": [5, 9], "toolkit": 5, "experiment": 5, "reentrant": 5, "index": [5, 8, 11, 12], "search": [5, 8], "page": 5, "ask": 6, "cumbersom": [6, 7], "hard": [6, 8, 12, 16], "offer": [6, 16], "concis": [6, 7], "matter": 6, "predefin": 6, "accomplish": 6, "sentin": 6, "donotcar": 6, "findal": 6, "select": [6, 11], "maybesentinel": [6, 11, 13, 16], "basematchernod": 6, "metadata_resolv": 6, "oneof": 6, "allof": 6, "matchiftru": 6, "doesnotmatch": 6, "redund": 6, "atleastn": 6, "atmostn": 6, "_basemetadatamatch": 6, "mirror": 6, "usedi": 6, "savematchednod": 6, "prioiriti": 6, "prioriti": 6, "earlier": 6, "extractal": 6, "analog": 6, "callabl": [6, 8, 11, 15], "view": [6, 11], "cut": 6, "onto": 6, "_cstvisitfunct": 6, "combin": [6, 11], "call_if_insid": [6, 7], "call_if_not_insid": 6, "There": [6, 8, 10, 11, 16], "rule": [6, 7, 11], "forth": 6, "separ": [6, 8, 11, 14], "gate": 6, "relev": [6, 12, 15, 16], "_": [6, 15], "attr": [6, 8, 11], "outsid": [6, 8, 11], "pai": 6, "extra": [6, 10, 11, 16], "cost": 6, "anywher": [6, 11], "power": [6, 11, 16], "on_visit": [6, 15], "on_leav": [6, 15], "on_visit_attribut": [6, 15], "on_leave_attribut": [6, 15], "matchmetadata": 6, "matchmetadataiftru": 6, "made": [6, 7, 15, 16], "sole": [6, 15], "traver": 6, "indetermin": 6, "implic": 6, "counterpart": 6, "expr": [6, 11, 15, 16], "semicolon": [6, 11, 16], "starter": 6, "evalu": [6, 11], "tend": [6, 11], "issu": 6, "exactli": [6, 7, 10, 12, 16], "limit": 6, "fill": 6, "gap": [6, 12], "invers": 6, "bitwis": 6, "Or": [6, 11], "shorthand": 6, "altern": [6, 11], "downsid": [6, 16], "upsid": 6, "_matchert": 6, "choos": 6, "satisfi": 6, "roundabout": 6, "real": 6, "sens": [6, 7, 15, 16], "redundantli": 6, "drop": 6, "typeof": 6, "belong": [6, 10, 11], "boolean": [6, 7, 15], "side": [6, 11], "booleanoper": [6, 11], "_othernodet": 6, "invert": [6, 7], "One": [6, 8, 11], "matchregex": 6, "regular": [6, 8, 10], "spell": 6, "letter": [6, 11], "_matchiftruet": 6, "ourselv": 6, "compil": [6, 11, 16], "doc": [6, 8, 11], "org": [6, 8, 11], "charact": [6, 8, 11, 12], "alphabet": 6, "r": [6, 11, 12, 14, 16], "za": 6, "z": [6, 11], "load": [6, 8, 16], "meta": 6, "expressioncontextprovid": [6, 8], "expressioncontext": [6, 8], "target": [6, 11], "fetch": 6, "inspect": [6, 8, 10, 11], "further": [6, 8, 11], "qualnam": 6, "begin": [6, 8, 11], "unind": 6, "column": [6, 8, 12, 13], "operand": 6, "integ": [6, 11, 12, 14, 15, 16], "left_operand": 6, "right_operand": 6, "donotcaresentinel": 6, "attribt": 6, "three": [6, 8, 13, 14], "regardless": [6, 8], "Not": [6, 8, 11], "great": [6, 16], "degre": 6, "flexibl": [6, 7, 16], "much": [6, 7, 8, 11, 15, 16], "partial": [6, 13], "zeroormor": [6, 7], "element": [6, 15], "fullmatch": 6, "latter": 6, "row": 6, "And": [6, 11], "4": [6, 7, 9, 11, 13, 14], "less": 6, "fewer": 6, "zerooron": 6, "claus": [6, 11], "onlin": [7, 9, 13, 14], "tutori": [7, 8, 9, 13, 14], "is_call_with_boolean": 7, "earli": [7, 11], "aw": 7, "fairli": 7, "call_1": 7, "call_2": 7, "bit": 7, "better": 7, "better_is_call_with_boolean": 7, "oop": 7, "shorter": 7, "trick": 7, "sleev": 7, "though": [7, 13], "turn": 7, "best_is_call_with_boolean": 7, "benefit": [7, 8], "english": 7, "9": 7, "10": [7, 8, 14], "11": [7, 14], "boolinvert": 7, "in_cal": 7, "leave_nam": 7, "12": 7, "nsome_func": 7, "gt": [7, 13, 14], "13": 7, "eleg": 7, "thing": [7, 11], "14": 7, "betterboolinvert": 7, "15": [7, 13], "around": [7, 8, 11], "busi": 7, "problem": [7, 11], "awai": 7, "16": 7, "bestboolinvert": 7, "invert_bool_liter": 7, "17": 7, "weren": 7, "standard": [8, 11], "associ": [8, 9, 11], "design": [8, 10, 11], "nameprint": 8, "visit_nam": [8, 9], "po": [8, 9], "wrap": [8, 10, 11], "resolve_mani": 8, "deep": [8, 11], "copi": [8, 10, 14, 15], "twice": 8, "uniqu": 8, "unsafe_skip_copi": 8, "deepli": 8, "clone": [8, 11], "came": 8, "mw": 8, "modulewrapp": 8, "dosomeanalysisvisitor": 8, "_t": 8, "undeclar": 8, "cstvisitort": 8, "visit_batch": [8, 15], "batchablecstvisitor": [8, 15], "before_visit": [8, 15], "after_leav": [8, 15], "low": [8, 15], "get_inherited_depend": 8, "mro": 8, "cl": [8, 13], "exit": 8, "clear": [8, 10, 13], "_metadata_depend": 8, "batchablemetadataprovid": [8, 9], "batchabl": [8, 15], "gen_cach": 8, "path": 8, "matadata": 8, "per": 8, "set_metadata": [8, 9], "_providedmetadatat": 8, "_metadatat": 8, "_comput": 8, "effici": [8, 9, 14], "visitormetadataprovid": 8, "bytespanpositionprovid": 8, "whitespaceinclusivepositionprovid": 8, "parentnodeprovid": 8, "typeinferenceprovid": 8, "structur": [8, 11, 16], "concept": 8, "term": 8, "output": 8, "offset": [8, 12, 13], "length": 8, "coderang": 8, "bound": [8, 11], "ignor": [8, 10], "syntact": [8, 10, 11, 12], "signific": [8, 11], "eventu": 8, "codeposit": 8, "inclus": 8, "exclus": [8, 16], "codespan": 8, "measur": 8, "unicod": 8, "encod": [8, 11, 12, 16], "distanc": 8, "span": [8, 11], "mimic": 8, "expr_context": 8, "starredel": [8, 11], "honor": 8, "del": [8, 11], "mappingproxi": [8, 11], "lpar": [8, 11, 12, 14, 15, 16], "rpar": [8, 11, 12, 14, 15, 16], "augassign": [8, 11], "b": [8, 11, 12, 13], "delet": [8, 10, 11, 15, 16], "enforc": [8, 11], "program": 8, "languag": [8, 11], "block": 8, "comprehens": 8, "condit": [8, 11], "five": 8, "builtinscop": 8, "globalscop": [8, 13], "classscop": [8, 13], "functionscop": [8, 13], "comprehensionscop": 8, "within": [8, 11], "bring": 8, "symbol": 8, "analyz": 8, "d": [8, 11, 13], "advanc": 8, "figur": 8, "expression_context_provid": 8, "baseassign": 8, "buitinassign": 8, "embed": 8, "annont": 8, "forward": [8, 13], "__new__": [8, 13], "basestr": [8, 11], "is_annot": 8, "is_type_hint": 8, "record_assign": 8, "builtinassign": [8, 13], "builtin": [8, 13], "relationship": 8, "viewabl": 8, "__contains__": 8, "__getitem__": 8, "differenti": [8, 11], "disallow": 8, "hoist": 8, "decis": 8, "javascript": 8, "fn": [8, 11, 16], "var": [8, 13], "contrast": 8, "conditional_valu": 8, "elif": [8, 11], "other_conditional_valu": 8, "possibli": [8, 11, 15], "nameerror": 8, "falsi": 8, "codepath": 8, "taken": 8, "forc": [8, 15], "get_qualified_names_for": 8, "qualifiednam": 8, "qualifiednamesourc": 8, "pep": [8, 11], "3155": 8, "__qualname__": 8, "namespac": 8, "listcomp": [8, 11], "setcomp": [8, 11], "dictcomp": [8, 11], "assignmen": 8, "http": [8, 11], "html": [8, 11], "rang": [8, 11, 13], "__iter__": 8, "unambigu": [8, 11], "introduc": [8, 16], "fulli": [8, 10, 15, 16], "hierarchi": [8, 11], "fullyqualifiednameprovid": 8, "folder": 8, "account": 8, "underli": 8, "shadow": 8, "otherth": 8, "has_nam": 8, "absolut": 8, "mgr": 8, "dir": 8, "get_metadata_wrapper_for_path": 8, "fqname": 8, "k": [8, 11, 13], "v": [8, 11], "_node": 8, "root_path": 8, "timeout": 8, "link": 8, "thu": 8, "down": [8, 12], "doabl": 8, "sometim": [8, 11], "bottom": [8, 11], "queri": 8, "setup": 8, "watchman": 8, "fullrepomang": 8, "inter": 8, "commun": 8, "server": 8, "repo_root_dir": 8, "timeoutexpir": 8, "resolve_cach": 8, "get_cache_for_path": 8, "good": [8, 16], "idea": [8, 11], "somewhat": 9, "unusu": 9, "hoc": 9, "mark": 9, "isparamprovid": 9, "is_param": 9, "visit_param": 9, "primari": 9, "isparam": 9, "x_name_nod": 9, "paramprint": 9, "nb": 9, "back": [10, 12], "area": 10, "portion": 10, "equat": 10, "some_input": 10, "correl": 10, "flat": [10, 11], "asyncfunct": 10, "grammar": [10, 11, 16], "async": [10, 11], "parenthesi": 10, "attach": 10, "scenario": 10, "dedupl": 10, "irregular": 10, "difficult": [10, 11, 16], "high": 10, "close": [10, 11, 16], "comma": [10, 11, 13, 16], "recogn": 10, "semant": [10, 11, 15, 16], "littl": 10, "trivia": [10, 11], "expos": 10, "untyp": [10, 11], "runtim": [10, 11], "constraint": 10, "serial": [10, 12], "invalid": [10, 16], "strong": 10, "sane": [10, 11], "treat": [10, 11, 15], "intellig": 10, "ownership": [10, 16], "disappear": 10, "field": [10, 11, 12, 16], "fix": [10, 11, 13], "adjac": 10, "proper": 10, "space": [10, 11, 12], "reparent": 10, "move": 10, "easili": [10, 11, 14], "break": [10, 11], "upstream": 10, "render": [10, 11, 12], "cover": 11, "sensit": 11, "fashion": 11, "validate_types_shallow": 11, "typeerror": 11, "mismatch": 11, "validate_types_deep": 11, "highli": 11, "useless": 11, "uncondition": [11, 15], "overlap": 11, "whole": 11, "immedi": 11, "transit": 11, "indentedblock": 11, "flatten": 11, "lexic": 11, "_cstnodeselft": 11, "callback": 11, "leave_if": 11, "new_nod": 11, "new_condit": 11, "orels": 11, "todo": 11, "deep_clon": 11, "deep_equ": [11, 14], "deep_replac": 11, "old_nod": 11, "previous": 11, "deep_remov": 11, "with_deep_chang": 11, "dataclass": 11, "infer": [11, 12], "correct": 11, "encapsul": 11, "emptylin": 11, "next": 11, "footer": [11, 16], "utf": [11, 12, 16], "default_ind": [11, 12, 16], "tab": [11, 12], "default_newlin": [11, 12, 16], "_moduleselft": 11, "entri": 11, "respect": [11, 15], "get_docstr": 11, "cleandoc": 11, "docstr": 11, "typic": 11, "leftparen": 11, "rightparen": 11, "preced": 11, "dictat": 11, "outer": 11, "unaryoper": 11, "baseunaryop": 11, "negat": 11, "basebinaryop": 11, "basebooleanop": 11, "comparis": 11, "basecompop": 11, "hand": 11, "w": 11, "comparisontarget": 11, "roughli": 11, "lessthan": 11, "asynchron": 11, "whitespace_aft": [11, 12, 14, 15, 16], "simplewhitespac": [11, 12, 14, 15, 16], "await": 11, "generatorexp": 11, "wait": 11, "whitespace_after_await": 11, "baseparenthesizablewhitespac": 11, "inner": [11, 14], "fun": [11, 13], "learn": 11, "sub": 11, "whitespace_after_yield": 11, "stanza": 11, "whitespace_before_from": 11, "veri": 11, "whitespace_after_from": 11, "ifexp": 11, "whitespace_before_if": 11, "whitespace_after_if": 11, "whitespace_before_els": 11, "whitespace_after_els": 11, "anonym": 11, "colon": 11, "whitespace_after_lambda": 11, "do_math": 11, "pictur": 11, "post_on_instagram": 11, "mix": 11, "star": [11, 16], "rather": 11, "whitespace_after_func": [11, 16], "open": 11, "whitespace_before_arg": [11, 16], "surround": 11, "asterisk": 11, "assignequ": 11, "sign": 11, "denot": 11, "expand": [11, 12], "whitespace_after_star": [11, 16], "whitespace_after_arg": [11, 16], "placehold": 11, "conjunct": [11, 15], "basenumb": 11, "float": 11, "imaginari": 11, "100000": 11, "100_000": 11, "evaluated_valu": 11, "05": 11, "050": 11, "5e": 11, "2j": 11, "concatenatedstr": 11, "formattedstr": 11, "sort": 11, "texual": 11, "prefix": [11, 14, 16], "escap": 11, "my": 11, "precid": 11, "br": 11, "rb": 11, "quotat": 11, "raw_valu": 11, "manipul": [11, 16], "abc": [11, 12, 15], "abcdef": 11, "join": [11, 13, 14], "antifeatur": 11, "whitespace_between": 11, "substr": 11, "compos": 11, "interpol": 11, "curli": 11, "498": 11, "ab": 11, "cd": 11, "ef": 11, "formattedstringtext": 11, "formattedstringexpress": 11, "convers": 11, "format_spec": 11, "whitespace_before_express": 11, "whitespace_after_express": 11, "baseformattedstringcont": 11, "fr": 11, "rf": 11, "enclos": 11, "suffix": 11, "mini": 11, "baseel": 11, "baselist": 11, "lbracket": 11, "leftsquarebracket": 11, "_missing_typ": 11, "default_factori": 11, "repr": [11, 14], "hash": 11, "kw_onli": 11, "_field_typ": 11, "rbracket": 11, "rightsquarebracket": 11, "mutabl": 11, "baseset": 11, "lbrace": 11, "leftcurlybrac": 11, "rbrace": 11, "rightcurlybrac": 11, "basedictel": 11, "dictel": 11, "starreddictel": 11, "el": 11, "whitespace_before_valu": 11, "basedict": 11, "k1": 11, "v1": 11, "k2": 11, "v2": 11, "whitespace_before_colon": 11, "whitespace_after_colon": 11, "asymmetri": 11, "basecomp": 11, "for_in": 11, "compfor": 11, "basesimplecomp": 11, "elt": 11, "baseassigntargetexpress": 11, "thought": 11, "ifs": 11, "inner_comp_for": 11, "compif": 11, "inner_for_in": 11, "uncommon": 11, "whitespace_befor": [11, 12, 14, 15, 16], "whitespace_after_for": 11, "whitespace_before_in": 11, "whitespace_after_in": 11, "coerc": 11, "whitespace_before_test": 11, "whitespace_after_valu": 11, "slot": 11, "pure": 11, "NOT": 11, "lower": 11, "upper": 11, "step": [11, 14], "first_colon": 11, "second_colon": 11, "omit": 11, "third": [11, 12], "parti": [11, 12], "numpi": 11, "dimension": 11, "arrai": 11, "squar": 11, "simplestatementsuit": 11, "simplifi": 11, "disambigu": 11, "falsei": 11, "whitespace_after_assert": 11, "baseaugop": 11, "continu": 11, "basedeltargetexpress": 11, "whitespace_after_del": 11, "unassign": 11, "unneed": 11, "nameitem": 11, "whitespace_after_glob": 11, "whitespace_after_import": 11, "importstar": 11, "whitespace_before_import": 11, "paren": 11, "nonloc": 11, "whitespace_after_nonloc": 11, "exc": 11, "caus": [11, 15], "whitespace_after_rais": 11, "whitespace_after_return": 11, "group": 11, "although": 11, "incarn": 11, "compound_stmt": 11, "leading_lin": [11, 16], "metaclass": 11, "lines_after_decor": 11, "whitespace_after_class": 11, "whitespace_after_nam": 11, "suit": 11, "appos": 11, "whitespace_after_def": 11, "whitespace_before_param": 11, "truthi": 11, "signifi": 11, "whitespace_after_test": 11, "handler": 11, "excepthandl": 11, "finalbodi": 11, "whitespace_after_whil": 11, "With": [11, 13], "withitem": 11, "whitespace_after_with": 11, "3107": 11, "526": 11, "hint": 11, "484": 11, "good_idea": 11, "concat": 11, "arrow": 11, "whitespace_before_ind": 11, "whitespace_after_ind": 11, "whitespace_before_a": 11, "whitespace_after_a": 11, "whitespace_before_equ": 11, "whitespace_after_equ": 11, "cpython": [11, 12], "exclud": [11, 15], "bytecod": 11, "whitespace_after_at": 11, "trailing_whitespac": [11, 16], "trailingwhitespac": [11, 16], "catch": 11, "caught": 11, "whitespace_after_except": 11, "whichev": 11, "evaluated_nam": 11, "evaluated_alia": 11, "forbidden": 11, "tem": 11, "star_arg": 11, "paramstar": 11, "kwonly_param": 11, "star_kwarg": 11, "unspecifi": [11, 12], "posonly_param": 11, "posonly_ind": 11, "paramslash": 11, "preceed": 11, "whitespace_after_param": 11, "describ": 11, "570": 11, "3102": 11, "dummi": 11, "leading_whitespac": 11, "token": [11, 14, 15], "inconsist": 11, "ambigu": 11, "fall": 11, "bitinvert": 11, "minu": 11, "plu": 11, "bitand": 11, "bitor": 11, "bitxor": 11, "divid": 11, "floordivid": 11, "leftshift": 11, "matrixmultipli": 11, "modulo": 11, "multipli": 11, "rightshift": 11, "subtract": 11, "greaterthan": 11, "greaterthanequ": 11, "lessthanequ": 11, "notequ": 11, "realiti": 11, "401": 11, "isnot": 11, "notin": 11, "agument": 11, "addassign": 11, "bitandassign": 11, "bitorassign": 11, "bitxorassign": 11, "divideassign": 11, "floordivideassign": 11, "leftshiftassign": 11, "matrixmultiplyassign": 11, "moduloassign": 11, "multiplyassign": 11, "powerassign": 11, "rightshiftassign": 11, "subtractassign": 11, "miscelan": 11, "carri": 11, "pound": 11, "strip": 11, "termin": 11, "backslash": 11, "permit": 11, "parenthesizedwhitespac": 11, "kind": 11, "lexical_analysi": 11, "implicit": 11, "first_lin": 11, "empty_lin": 11, "regularli": 11, "last_lin": 11, "solv": 11, "versu": 11, "iftest": 11, "legal": 11, "parenthesiz": 11, "technic": 11, "serv": 11, "anywai": 11, "preexist": 11, "fn_call": 11, "new_fn_cal": 11, "dummy_modul": 11, "had": 11, "redbaron": 11, "approach": 11, "proxi": 11, "tradeoff": 11, "mainli": 12, "semi": 12, "environ": 12, "32": 12, "xff": 12, "xfe": 12, "x00": 12, "x00a": 12, "x00b": 12, "x00c": 12, "autoconfig": 12, "round": 12, "among": 12, "did": 12, "prior": 12, "parsed_python_vers": 12, "pythonversioninfo": [12, 14], "future_import": 12, "frozenset": 12, "__future__": 12, "parsersyntaxerror": 12, "syntaxerror": 12, "potenti": 12, "unintend": 12, "human": 12, "explan": 12, "alongsid": 12, "__str__": 12, "ex": 12, "raw_lin": 12, "raw_column": 12, "incomplet": 12, "eof": 12, "caret": 12, "blank": 12, "editor_lin": 12, "editor": 12, "editor_column": 12, "shown": 12, "width": 12, "wcwidth": 12, "familiar": 13, "demonstr": [13, 14], "coupl": 13, "func_undefin": 13, "var_undefin": 13, "prevent": 13, "h": 13, "j": 13, "l": 13, "o": 13, "att": 13, "analys": 13, "lt": 13, "0x3ff7cf5f6d0": 13, "0x3ff5b439b10": 13, "0x3ff5b43a650": 13, "0x3ff5b438f90": 13, "focu": [13, 16], "report": 13, "suggest": 13, "defaultdict": 13, "undefined_refer": 13, "len": 13, "2d": 13, "23": 13, "commmon": 13, "flake8": 13, "f401": 13, "removeunusedimporttransform": 13, "leave_import": 13, "leave_importfrom": 13, "lookup": 13, "tabl": 13, "names_to_keep": 13, "leave_import_alik": 13, "name_valu": 13, "difflib": [13, 14], "fixed_modul": 13, "splitlin": [13, 14], "workflow": 14, "39": 14, "easlii": 14, "py_sourc": 14, "pythontoken": 14, "__repr__": 14, "tokeninfo": 14, "start_po": 14, "_replac": 14, "version_info": 14, "split_lin": 14, "keepend": 14, "tokenize_lin": 14, "pyi_sourc": 14, "source_tre": 14, "stub_tre": 14, "simpli": 14, "signatur": 14, "visit_functiondef": [14, 15], "leave_functiondef": 14, "typingcollector": 14, "canon": 14, "conon": 14, "visit_classdef": 14, "leave_classdef": 14, "typingtransform": 14, "modified_tre": 14, "ufmt": 14, "reform": 14, "34": 14, "sake": 14, "reflect": 15, "leave_arg": 15, "effort": 15, "too": 15, "forget": 15, "leave_return": 15, "log_stmt": 15, "subject": 15, "cstnodet_co": 15, "outlin": [15, 16], "below": 15, "word": 15, "nor": 15, "declin": 15, "visit_simplestr": 15, "fooingaround": 15, "repl": 15, "demo": 15, "123": 15, "ndef": 15, "Then": 15, "algorithm": 15, "visit_binaryoper": 15, "visit_binaryoperation_lpar": 15, "leave_binaryoperation_lpar": 15, "visit_binaryoperation_left": 15, "visit_integ": 15, "visit_integer_lpar": 15, "leave_integer_lpar": 15, "visit_integer_rpar": 15, "leave_integer_rpar": 15, "leave_integ": 15, "leave_binaryoperation_left": 15, "visit_binaryoperation_oper": 15, "visit_add": 15, "visit_add_whitespace_befor": 15, "visit_simplewhitespac": 15, "leave_simplewhitespac": 15, "leave_add_whitespace_befor": 15, "visit_add_whitespace_aft": 15, "leave_add_whitespace_aft": 15, "leave_add": 15, "leave_binaryoperation_oper": 15, "visit_binaryoperation_right": 15, "leave_binaryoperation_right": 15, "visit_binaryoperation_rpar": 15, "leave_binaryoperation_rpar": 15, "leave_binaryoper": 15, "get_visitor": 15, "batchable_visitor": 15, "hook": 15, "compromis": 16, "tradit": 16, "carefulli": 16, "reorgan": 16, "lossless": 16, "feel": 16, "ctx": 16, "num": 16, "wouldn": 16, "reprint": 16, "jpeg": 16, "lossi": 16, "gone": 16, "tell": 16, "lost": 16, "popular": 16, "lib2to3": 16, "2to3": 16, "file_input": 16, "simple_stmt": 16, "leaf": 16, "trailer": 16, "arglist": 16, "endmark": 16, "retain": 16, "unclear": 16, "significantli": 16, "intern": 16, "greatli": 16, "almost": 16, "slower": 16, "nevertheless": 16, "trade": 16, "worthwhil": 16, "deal": 16}, "objects": {"libcst": [[11, 0, 1, "", "Add"], [11, 0, 1, "", "AddAssign"], [11, 0, 1, "", "And"], [11, 0, 1, "", "AnnAssign"], [11, 0, 1, "", "Annotation"], [11, 0, 1, "", "Arg"], [11, 0, 1, "", "AsName"], [11, 0, 1, "", "Assert"], [11, 0, 1, "", "Assign"], [11, 0, 1, "", "AssignEqual"], [11, 0, 1, "", "AssignTarget"], [11, 0, 1, "", "Asynchronous"], [11, 0, 1, "", "Attribute"], [11, 0, 1, "", "AugAssign"], [11, 0, 1, "", "Await"], [11, 0, 1, "", "BaseAssignTargetExpression"], [11, 0, 1, "", "BaseAugOp"], [11, 0, 1, "", "BaseBinaryOp"], [11, 0, 1, "", "BaseBooleanOp"], [11, 0, 1, "", "BaseComp"], [11, 0, 1, "", "BaseCompOp"], [11, 0, 1, "", "BaseCompoundStatement"], [11, 0, 1, "", "BaseDelTargetExpression"], [11, 0, 1, "", "BaseDict"], [11, 0, 1, "", "BaseDictElement"], [11, 0, 1, "", "BaseElement"], [11, 0, 1, "", "BaseExpression"], [11, 0, 1, "", "BaseFormattedStringContent"], [11, 0, 1, "", "BaseList"], [8, 0, 1, "", "BaseMetadataProvider"], [11, 0, 1, "", "BaseNumber"], [11, 0, 1, "", "BaseParenthesizableWhitespace"], [11, 0, 1, "", "BaseSet"], [11, 0, 1, "", "BaseSimpleComp"], [11, 0, 1, "", "BaseSlice"], [11, 0, 1, "", "BaseSmallStatement"], [11, 0, 1, "", "BaseString"], [11, 0, 1, "", "BaseSuite"], [11, 0, 1, "", "BaseUnaryOp"], [15, 0, 1, "", "BatchableCSTVisitor"], [11, 0, 1, "", "BinaryOperation"], [11, 0, 1, "", "BitAnd"], [11, 0, 1, "", "BitAndAssign"], [11, 0, 1, "", "BitInvert"], [11, 0, 1, "", "BitOr"], [11, 0, 1, "", "BitOrAssign"], [11, 0, 1, "", "BitXor"], [11, 0, 1, "", "BitXorAssign"], [11, 0, 1, "", "BooleanOperation"], [11, 0, 1, "", "Break"], [11, 0, 1, "", "CSTNode"], [15, 0, 1, "", "CSTTransformer"], [15, 0, 1, "", "CSTVisitor"], [11, 0, 1, "", "Call"], [11, 0, 1, "", "ClassDef"], [11, 0, 1, "", "Colon"], [11, 0, 1, "", "Comma"], [11, 0, 1, "", "Comment"], [11, 0, 1, "", "CompFor"], [11, 0, 1, "", "CompIf"], [11, 0, 1, "", "Comparison"], [11, 0, 1, "", "ComparisonTarget"], [11, 0, 1, "", "ConcatenatedString"], [11, 0, 1, "", "Continue"], [11, 0, 1, "", "Decorator"], [11, 0, 1, "", "Del"], [11, 0, 1, "", "Dict"], [11, 0, 1, "", "DictComp"], [11, 0, 1, "", "DictElement"], [11, 0, 1, "", "Divide"], [11, 0, 1, "", "DivideAssign"], [11, 0, 1, "", "Dot"], [11, 0, 1, "", "Element"], [11, 0, 1, "", "Ellipsis"], [11, 0, 1, "", "Else"], [11, 0, 1, "", "EmptyLine"], [11, 0, 1, "", "Equal"], [11, 0, 1, "", "ExceptHandler"], [11, 0, 1, "", "Expr"], [11, 0, 1, "", "Finally"], [15, 0, 1, "", "FlattenSentinel"], [11, 0, 1, "", "Float"], [11, 0, 1, "", "FloorDivide"], [11, 0, 1, "", "FloorDivideAssign"], [11, 0, 1, "", "For"], [11, 0, 1, "", "FormattedString"], [11, 0, 1, "", "FormattedStringExpression"], [11, 0, 1, "", "FormattedStringText"], [11, 0, 1, "", "From"], [11, 0, 1, "", "FunctionDef"], [11, 0, 1, "", "GeneratorExp"], [11, 0, 1, "", "Global"], [11, 0, 1, "", "GreaterThan"], [11, 0, 1, "", "GreaterThanEqual"], [11, 0, 1, "", "If"], [11, 0, 1, "", "IfExp"], [11, 0, 1, "", "Imaginary"], [11, 0, 1, "", "Import"], [11, 0, 1, "", "ImportAlias"], [11, 0, 1, "", "ImportFrom"], [11, 0, 1, "", "ImportStar"], [11, 0, 1, "", "In"], [11, 0, 1, "", "IndentedBlock"], [11, 0, 1, "", "Index"], [11, 0, 1, "", "Integer"], [11, 0, 1, "", "Is"], [11, 0, 1, "", "IsNot"], [11, 0, 1, "", "Lambda"], [11, 0, 1, "", "LeftCurlyBrace"], [11, 0, 1, "", "LeftParen"], [11, 0, 1, "", "LeftShift"], [11, 0, 1, "", "LeftShiftAssign"], [11, 0, 1, "", "LeftSquareBracket"], [11, 0, 1, "", "LessThan"], [11, 0, 1, "", "LessThanEqual"], [11, 0, 1, "", "List"], [11, 0, 1, "", "ListComp"], [11, 0, 1, "", "MatrixMultiply"], [11, 0, 1, "", "MatrixMultiplyAssign"], [11, 0, 1, "", "MaybeSentinel"], [8, 0, 1, "", "MetadataDependent"], [11, 0, 1, "", "Minus"], [11, 0, 1, "", "Module"], [11, 0, 1, "", "Modulo"], [11, 0, 1, "", "ModuloAssign"], [11, 0, 1, "", "Multiply"], [11, 0, 1, "", "MultiplyAssign"], [11, 0, 1, "", "Name"], [11, 0, 1, "", "NameItem"], [11, 0, 1, "", "Newline"], [11, 0, 1, "", "Nonlocal"], [11, 0, 1, "", "Not"], [11, 0, 1, "", "NotEqual"], [11, 0, 1, "", "NotIn"], [11, 0, 1, "", "Or"], [11, 0, 1, "", "Param"], [11, 0, 1, "", "ParamSlash"], [11, 0, 1, "", "ParamStar"], [11, 0, 1, "", "Parameters"], [11, 0, 1, "", "ParenthesizedWhitespace"], [12, 0, 1, "", "ParserSyntaxError"], [12, 0, 1, "", "PartialParserConfig"], [11, 0, 1, "", "Pass"], [11, 0, 1, "", "Plus"], [11, 0, 1, "", "Power"], [11, 0, 1, "", "PowerAssign"], [11, 0, 1, "", "Raise"], [15, 0, 1, "", "RemovalSentinel"], [15, 4, 1, "", "RemoveFromParent"], [11, 0, 1, "", "Return"], [11, 0, 1, "", "RightCurlyBrace"], [11, 0, 1, "", "RightParen"], [11, 0, 1, "", "RightShift"], [11, 0, 1, "", "RightShiftAssign"], [11, 0, 1, "", "RightSquareBracket"], [11, 0, 1, "", "Semicolon"], [11, 0, 1, "", "Set"], [11, 0, 1, "", "SetComp"], [11, 0, 1, "", "SimpleStatementLine"], [11, 0, 1, "", "SimpleStatementSuite"], [11, 0, 1, "", "SimpleString"], [11, 0, 1, "", "SimpleWhitespace"], [11, 0, 1, "", "Slice"], [11, 0, 1, "", "StarredDictElement"], [11, 0, 1, "", "StarredElement"], [11, 0, 1, "", "Subscript"], [11, 0, 1, "", "SubscriptElement"], [11, 0, 1, "", "Subtract"], [11, 0, 1, "", "SubtractAssign"], [11, 0, 1, "", "TrailingWhitespace"], [11, 0, 1, "", "Try"], [11, 0, 1, "", "Tuple"], [11, 0, 1, "", "UnaryOperation"], [11, 0, 1, "", "While"], [11, 0, 1, "", "With"], [11, 0, 1, "", "WithItem"], [11, 0, 1, "", "Yield"], [12, 4, 1, "", "parse_expression"], [12, 4, 1, "", "parse_module"], [12, 4, 1, "", "parse_statement"], [15, 4, 1, "", "visit_batched"]], "libcst.AnnAssign": [[11, 1, 1, "", "annotation"], [11, 1, 1, "", "equal"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "target"], [11, 1, 1, "", "value"]], "libcst.Annotation": [[11, 1, 1, "", "annotation"], [11, 1, 1, "", "whitespace_after_indicator"], [11, 1, 1, "", "whitespace_before_indicator"]], "libcst.Arg": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "equal"], [11, 1, 1, "", "keyword"], [11, 1, 1, "", "star"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after_arg"], [11, 1, 1, "", "whitespace_after_star"]], "libcst.AsName": [[11, 1, 1, "", "name"], [11, 1, 1, "", "whitespace_after_as"], [11, 1, 1, "", "whitespace_before_as"]], "libcst.Assert": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "msg"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "test"], [11, 1, 1, "", "whitespace_after_assert"]], "libcst.Assign": [[11, 1, 1, "", "semicolon"], [11, 1, 1, "", "targets"], [11, 1, 1, "", "value"]], "libcst.AssignEqual": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.AssignTarget": [[11, 1, 1, "", "target"], [11, 1, 1, "", "whitespace_after_equal"], [11, 1, 1, "", "whitespace_before_equal"]], "libcst.Asynchronous": [[11, 1, 1, "", "whitespace_after"]], "libcst.Attribute": [[11, 1, 1, "", "attr"], [11, 1, 1, "", "dot"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"]], "libcst.AugAssign": [[11, 1, 1, "", "operator"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "target"], [11, 1, 1, "", "value"]], "libcst.Await": [[11, 1, 1, "", "expression"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "whitespace_after_await"]], "libcst.BaseComp": [[11, 1, 1, "", "for_in"]], "libcst.BaseCompoundStatement": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"]], "libcst.BaseList": [[11, 1, 1, "", "lbracket"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbracket"], [11, 1, 1, "", "rpar"]], "libcst.BaseMetadataProvider": [[8, 1, 1, "", "gen_cache"], [8, 2, 1, "", "get_metadata"], [8, 2, 1, "", "set_metadata"]], "libcst.BaseParenthesizableWhitespace": [[11, 3, 1, "", "empty"]], "libcst.BaseSimpleComp": [[11, 1, 1, "", "elt"], [11, 1, 1, "", "for_in"]], "libcst.BaseSmallStatement": [[11, 1, 1, "", "semicolon"]], "libcst.BaseSuite": [[11, 1, 1, "", "body"]], "libcst.BatchableCSTVisitor": [[15, 2, 1, "", "get_visitors"]], "libcst.BinaryOperation": [[11, 1, 1, "", "left"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "operator"], [11, 1, 1, "", "right"], [11, 1, 1, "", "rpar"]], "libcst.BooleanOperation": [[11, 1, 1, "", "left"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "operator"], [11, 1, 1, "", "right"], [11, 1, 1, "", "rpar"]], "libcst.Break": [[11, 1, 1, "", "semicolon"]], "libcst.CSTNode": [[11, 3, 1, "", "children"], [11, 2, 1, "", "deep_clone"], [11, 2, 1, "", "deep_equals"], [11, 2, 1, "", "deep_remove"], [11, 2, 1, "", "deep_replace"], [11, 2, 1, "", "field"], [11, 2, 1, "", "validate_types_deep"], [11, 2, 1, "", "validate_types_shallow"], [11, 2, 1, "", "visit"], [11, 2, 1, "", "with_changes"], [11, 2, 1, "", "with_deep_changes"]], "libcst.CSTTransformer": [[15, 2, 1, "", "on_leave"], [15, 2, 1, "", "on_leave_attribute"], [15, 2, 1, "", "on_visit"], [15, 2, 1, "", "on_visit_attribute"]], "libcst.CSTVisitor": [[15, 2, 1, "", "on_leave"], [15, 2, 1, "", "on_leave_attribute"], [15, 2, 1, "", "on_visit"], [15, 2, 1, "", "on_visit_attribute"]], "libcst.Call": [[11, 1, 1, "", "args"], [11, 1, 1, "", "func"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "whitespace_after_func"], [11, 1, 1, "", "whitespace_before_args"]], "libcst.ClassDef": [[11, 1, 1, "", "bases"], [11, 1, 1, "", "body"], [11, 1, 1, "", "decorators"], [11, 2, 1, "", "get_docstring"], [11, 1, 1, "", "keywords"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "lines_after_decorators"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "name"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "whitespace_after_class"], [11, 1, 1, "", "whitespace_after_name"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.Colon": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.Comma": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.Comment": [[11, 1, 1, "", "value"]], "libcst.CompFor": [[11, 1, 1, "", "asynchronous"], [11, 1, 1, "", "ifs"], [11, 1, 1, "", "inner_for_in"], [11, 1, 1, "", "iter"], [11, 1, 1, "", "target"], [11, 1, 1, "", "whitespace_after_for"], [11, 1, 1, "", "whitespace_after_in"], [11, 1, 1, "", "whitespace_before"], [11, 1, 1, "", "whitespace_before_in"]], "libcst.CompIf": [[11, 1, 1, "", "test"], [11, 1, 1, "", "whitespace_before"], [11, 1, 1, "", "whitespace_before_test"]], "libcst.Comparison": [[11, 1, 1, "", "comparisons"], [11, 1, 1, "", "left"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"]], "libcst.ComparisonTarget": [[11, 1, 1, "", "comparator"], [11, 1, 1, "", "operator"]], "libcst.ConcatenatedString": [[11, 3, 1, "", "evaluated_value"], [11, 1, 1, "", "left"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "right"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "whitespace_between"]], "libcst.Continue": [[11, 1, 1, "", "semicolon"]], "libcst.Decorator": [[11, 1, 1, "", "decorator"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "trailing_whitespace"], [11, 1, 1, "", "whitespace_after_at"]], "libcst.Del": [[11, 1, 1, "", "semicolon"], [11, 1, 1, "", "target"], [11, 1, 1, "", "whitespace_after_del"]], "libcst.Dict": [[11, 1, 1, "", "elements"], [11, 1, 1, "", "lbrace"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbrace"], [11, 1, 1, "", "rpar"]], "libcst.DictComp": [[11, 1, 1, "", "for_in"], [11, 1, 1, "", "key"], [11, 1, 1, "", "lbrace"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbrace"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after_colon"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.DictElement": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "key"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after_colon"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.Dot": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.Element": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "value"]], "libcst.Ellipsis": [[11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"]], "libcst.Else": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.EmptyLine": [[11, 1, 1, "", "comment"], [11, 1, 1, "", "indent"], [11, 1, 1, "", "newline"], [11, 1, 1, "", "whitespace"]], "libcst.ExceptHandler": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "name"], [11, 1, 1, "", "type"], [11, 1, 1, "", "whitespace_after_except"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.Expr": [[11, 1, 1, "", "semicolon"], [11, 1, 1, "", "value"]], "libcst.Finally": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.FlattenSentinel": [[15, 1, 1, "", "nodes"]], "libcst.Float": [[11, 3, 1, "", "evaluated_value"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"]], "libcst.For": [[11, 1, 1, "", "asynchronous"], [11, 1, 1, "", "body"], [11, 1, 1, "", "iter"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "orelse"], [11, 1, 1, "", "target"], [11, 1, 1, "", "whitespace_after_for"], [11, 1, 1, "", "whitespace_after_in"], [11, 1, 1, "", "whitespace_before_colon"], [11, 1, 1, "", "whitespace_before_in"]], "libcst.FormattedString": [[11, 1, 1, "", "end"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "parts"], [11, 3, 1, "", "prefix"], [11, 3, 1, "", "quote"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "start"]], "libcst.FormattedStringExpression": [[11, 1, 1, "", "conversion"], [11, 1, 1, "", "equal"], [11, 1, 1, "", "expression"], [11, 1, 1, "", "format_spec"], [11, 1, 1, "", "whitespace_after_expression"], [11, 1, 1, "", "whitespace_before_expression"]], "libcst.FormattedStringText": [[11, 1, 1, "", "value"]], "libcst.From": [[11, 1, 1, "", "item"], [11, 1, 1, "", "whitespace_after_from"], [11, 1, 1, "", "whitespace_before_from"]], "libcst.FunctionDef": [[11, 1, 1, "", "asynchronous"], [11, 1, 1, "", "body"], [11, 1, 1, "", "decorators"], [11, 2, 1, "", "get_docstring"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "lines_after_decorators"], [11, 1, 1, "", "name"], [11, 1, 1, "", "params"], [11, 1, 1, "", "returns"], [11, 1, 1, "", "whitespace_after_def"], [11, 1, 1, "", "whitespace_after_name"], [11, 1, 1, "", "whitespace_before_colon"], [11, 1, 1, "", "whitespace_before_params"]], "libcst.GeneratorExp": [[11, 1, 1, "", "elt"], [11, 1, 1, "", "for_in"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"]], "libcst.Global": [[11, 1, 1, "", "names"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "whitespace_after_global"]], "libcst.If": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "orelse"], [11, 1, 1, "", "test"], [11, 1, 1, "", "whitespace_after_test"], [11, 1, 1, "", "whitespace_before_test"]], "libcst.IfExp": [[11, 1, 1, "", "body"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "orelse"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "test"], [11, 1, 1, "", "whitespace_after_else"], [11, 1, 1, "", "whitespace_after_if"], [11, 1, 1, "", "whitespace_before_else"], [11, 1, 1, "", "whitespace_before_if"]], "libcst.Imaginary": [[11, 3, 1, "", "evaluated_value"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"]], "libcst.Import": [[11, 1, 1, "", "names"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "whitespace_after_import"]], "libcst.ImportAlias": [[11, 1, 1, "", "asname"], [11, 1, 1, "", "comma"], [11, 3, 1, "", "evaluated_alias"], [11, 3, 1, "", "evaluated_name"], [11, 1, 1, "", "name"]], "libcst.ImportFrom": [[11, 1, 1, "", "lpar"], [11, 1, 1, "", "module"], [11, 1, 1, "", "names"], [11, 1, 1, "", "relative"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "whitespace_after_from"], [11, 1, 1, "", "whitespace_after_import"], [11, 1, 1, "", "whitespace_before_import"]], "libcst.IndentedBlock": [[11, 1, 1, "", "body"], [11, 1, 1, "", "footer"], [11, 1, 1, "", "header"], [11, 1, 1, "", "indent"]], "libcst.Index": [[11, 1, 1, "", "value"]], "libcst.Integer": [[11, 3, 1, "", "evaluated_value"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"]], "libcst.Lambda": [[11, 1, 1, "", "body"], [11, 1, 1, "", "colon"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "params"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "whitespace_after_lambda"]], "libcst.LeftCurlyBrace": [[11, 1, 1, "", "whitespace_after"]], "libcst.LeftParen": [[11, 1, 1, "", "whitespace_after"]], "libcst.LeftSquareBracket": [[11, 1, 1, "", "whitespace_after"]], "libcst.LessThanEqual": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.List": [[11, 1, 1, "", "elements"], [11, 1, 1, "", "lbracket"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbracket"], [11, 1, 1, "", "rpar"]], "libcst.ListComp": [[11, 1, 1, "", "elt"], [11, 1, 1, "", "for_in"], [11, 1, 1, "", "lbracket"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbracket"], [11, 1, 1, "", "rpar"]], "libcst.MaybeSentinel": [[11, 1, 1, "", "DEFAULT"]], "libcst.MetadataDependent": [[8, 1, 1, "", "METADATA_DEPENDENCIES"], [8, 2, 1, "", "get_inherited_dependencies"], [8, 2, 1, "", "get_metadata"], [8, 1, 1, "", "metadata"], [8, 2, 1, "", "resolve"]], "libcst.Module": [[11, 1, 1, "", "body"], [11, 3, 1, "", "bytes"], [11, 3, 1, "", "code"], [11, 2, 1, "", "code_for_node"], [11, 3, 1, "", "config_for_parsing"], [11, 1, 1, "", "default_indent"], [11, 1, 1, "", "default_newline"], [11, 1, 1, "", "encoding"], [11, 1, 1, "", "footer"], [11, 2, 1, "", "get_docstring"], [11, 1, 1, "", "has_trailing_newline"], [11, 1, 1, "", "header"], [11, 2, 1, "", "visit"]], "libcst.Name": [[11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"]], "libcst.NameItem": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "name"]], "libcst.Newline": [[11, 1, 1, "", "value"]], "libcst.Nonlocal": [[11, 1, 1, "", "names"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "whitespace_after_nonlocal"]], "libcst.NotEqual": [[11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.NotIn": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"], [11, 1, 1, "", "whitespace_between"]], "libcst.Or": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.Param": [[11, 1, 1, "", "annotation"], [11, 1, 1, "", "comma"], [11, 1, 1, "", "default"], [11, 1, 1, "", "equal"], [11, 1, 1, "", "name"], [11, 1, 1, "", "star"], [11, 1, 1, "", "whitespace_after_param"], [11, 1, 1, "", "whitespace_after_star"]], "libcst.ParamSlash": [[11, 1, 1, "", "comma"]], "libcst.ParamStar": [[11, 1, 1, "", "comma"]], "libcst.Parameters": [[11, 1, 1, "", "kwonly_params"], [11, 1, 1, "", "params"], [11, 1, 1, "", "posonly_ind"], [11, 1, 1, "", "posonly_params"], [11, 1, 1, "", "star_arg"], [11, 1, 1, "", "star_kwarg"]], "libcst.ParenthesizedWhitespace": [[11, 3, 1, "", "empty"], [11, 1, 1, "", "empty_lines"], [11, 1, 1, "", "first_line"], [11, 1, 1, "", "indent"], [11, 1, 1, "", "last_line"]], "libcst.ParserSyntaxError": [[12, 2, 1, "", "__str__"], [12, 3, 1, "", "context"], [12, 3, 1, "", "editor_column"], [12, 3, 1, "", "editor_line"], [12, 1, 1, "", "message"], [12, 1, 1, "", "raw_column"], [12, 1, 1, "", "raw_line"]], "libcst.PartialParserConfig": [[12, 1, 1, "", "default_indent"], [12, 1, 1, "", "default_newline"], [12, 1, 1, "", "encoding"], [12, 1, 1, "", "future_imports"], [12, 1, 1, "", "parsed_python_version"], [12, 1, 1, "", "python_version"]], "libcst.Pass": [[11, 1, 1, "", "semicolon"]], "libcst.Plus": [[11, 1, 1, "", "whitespace_after"]], "libcst.Raise": [[11, 1, 1, "", "cause"], [11, 1, 1, "", "exc"], [11, 1, 1, "", "semicolon"], [11, 1, 1, "", "whitespace_after_raise"]], "libcst.RemovalSentinel": [[15, 1, 1, "", "REMOVE"]], "libcst.Return": [[11, 1, 1, "", "semicolon"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after_return"]], "libcst.RightCurlyBrace": [[11, 1, 1, "", "whitespace_before"]], "libcst.RightParen": [[11, 1, 1, "", "whitespace_before"]], "libcst.RightSquareBracket": [[11, 1, 1, "", "whitespace_before"]], "libcst.Semicolon": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.Set": [[11, 1, 1, "", "elements"], [11, 1, 1, "", "lbrace"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbrace"], [11, 1, 1, "", "rpar"]], "libcst.SetComp": [[11, 1, 1, "", "elt"], [11, 1, 1, "", "for_in"], [11, 1, 1, "", "lbrace"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbrace"], [11, 1, 1, "", "rpar"]], "libcst.SimpleStatementLine": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "trailing_whitespace"]], "libcst.SimpleStatementSuite": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_whitespace"], [11, 1, 1, "", "trailing_whitespace"]], "libcst.SimpleString": [[11, 3, 1, "", "evaluated_value"], [11, 1, 1, "", "lpar"], [11, 3, 1, "", "prefix"], [11, 3, 1, "", "quote"], [11, 3, 1, "", "raw_value"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"]], "libcst.SimpleWhitespace": [[11, 3, 1, "", "empty"], [11, 1, 1, "", "value"]], "libcst.Slice": [[11, 1, 1, "", "first_colon"], [11, 1, 1, "", "lower"], [11, 1, 1, "", "second_colon"], [11, 1, 1, "", "step"], [11, 1, 1, "", "upper"]], "libcst.StarredDictElement": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_before_value"]], "libcst.StarredElement": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_before_value"]], "libcst.Subscript": [[11, 1, 1, "", "lbracket"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rbracket"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "slice"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after_value"]], "libcst.SubscriptElement": [[11, 1, 1, "", "comma"], [11, 1, 1, "", "slice"]], "libcst.Subtract": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.SubtractAssign": [[11, 1, 1, "", "whitespace_after"], [11, 1, 1, "", "whitespace_before"]], "libcst.TrailingWhitespace": [[11, 1, 1, "", "comment"], [11, 1, 1, "", "newline"], [11, 1, 1, "", "whitespace"]], "libcst.Try": [[11, 1, 1, "", "body"], [11, 1, 1, "", "finalbody"], [11, 1, 1, "", "handlers"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "orelse"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.Tuple": [[11, 1, 1, "", "elements"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"]], "libcst.UnaryOperation": [[11, 1, 1, "", "expression"], [11, 1, 1, "", "lpar"], [11, 1, 1, "", "operator"], [11, 1, 1, "", "rpar"]], "libcst.While": [[11, 1, 1, "", "body"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "orelse"], [11, 1, 1, "", "test"], [11, 1, 1, "", "whitespace_after_while"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.With": [[11, 1, 1, "", "asynchronous"], [11, 1, 1, "", "body"], [11, 1, 1, "", "items"], [11, 1, 1, "", "leading_lines"], [11, 1, 1, "", "whitespace_after_with"], [11, 1, 1, "", "whitespace_before_colon"]], "libcst.WithItem": [[11, 1, 1, "", "asname"], [11, 1, 1, "", "comma"], [11, 1, 1, "", "item"]], "libcst.Yield": [[11, 1, 1, "", "lpar"], [11, 1, 1, "", "rpar"], [11, 1, 1, "", "value"], [11, 1, 1, "", "whitespace_after_yield"]], "libcst.codemod": [[1, 0, 1, "", "Codemod"], [1, 0, 1, "", "CodemodCommand"], [1, 0, 1, "", "CodemodContext"], [1, 0, 1, "", "CodemodTest"], [1, 0, 1, "", "ContextAwareTransformer"], [1, 0, 1, "", "ContextAwareVisitor"], [1, 0, 1, "", "MagicArgsCodemodCommand"], [1, 0, 1, "", "ParallelTransformResult"], [1, 0, 1, "", "SkipFile"], [1, 0, 1, "", "SkipReason"], [1, 0, 1, "", "TransformExit"], [1, 0, 1, "", "TransformFailure"], [1, 1, 1, "", "TransformResult"], [1, 0, 1, "", "TransformSkip"], [1, 0, 1, "", "TransformSuccess"], [1, 0, 1, "", "VisitorBasedCodemodCommand"], [1, 4, 1, "", "diff_code"], [1, 4, 1, "", "exec_transform_with_prettyprint"], [1, 4, 1, "", "gather_files"], [1, 4, 1, "", "parallel_exec_transform_with_prettyprint"], [1, 4, 1, "", "transform_module"]], "libcst.codemod.Codemod": [[1, 3, 1, "", "module"], [1, 2, 1, "", "should_allow_multiple_passes"], [1, 2, 1, "", "transform_module"], [1, 2, 1, "", "transform_module_impl"], [1, 2, 1, "", "warn"]], "libcst.codemod.CodemodCommand": [[1, 1, 1, "", "DESCRIPTION"], [1, 2, 1, "", "add_args"], [1, 2, 1, "", "transform_module_impl"]], "libcst.codemod.CodemodContext": [[1, 1, 1, "", "filename"], [1, 1, 1, "", "full_module_name"], [1, 1, 1, "", "metadata_manager"], [1, 3, 1, "", "module"], [1, 1, 1, "", "scratch"], [1, 1, 1, "", "warnings"], [1, 1, 1, "", "wrapper"]], "libcst.codemod.CodemodTest": [[1, 1, 1, "", "TRANSFORM"], [1, 2, 1, "", "addClassCleanup"], [1, 2, 1, "", "assertCodeEqual"], [1, 2, 1, "", "assertCodemod"], [1, 2, 1, "", "assertNoLogs"], [1, 2, 1, "", "doClassCleanups"], [1, 2, 1, "", "enterClassContext"], [1, 2, 1, "", "enterContext"], [1, 2, 1, "", "make_fixture_data"]], "libcst.codemod.ContextAwareVisitor": [[1, 3, 1, "", "module"], [1, 2, 1, "", "warn"]], "libcst.codemod.MagicArgsCodemodCommand": [[1, 2, 1, "", "get_transforms"]], "libcst.codemod.ParallelTransformResult": [[1, 1, 1, "", "failures"], [1, 1, 1, "", "skips"], [1, 1, 1, "", "successes"], [1, 1, 1, "", "warnings"]], "libcst.codemod.SkipReason": [[1, 1, 1, "", "BLACKLISTED"], [1, 1, 1, "", "GENERATED"], [1, 1, 1, "", "OTHER"]], "libcst.codemod.TransformExit": [[1, 1, 1, "", "warning_messages"]], "libcst.codemod.TransformFailure": [[1, 1, 1, "", "error"], [1, 1, 1, "", "traceback_str"], [1, 1, 1, "", "warning_messages"]], "libcst.codemod.TransformSkip": [[1, 1, 1, "", "skip_description"], [1, 1, 1, "", "skip_reason"], [1, 1, 1, "", "warning_messages"]], "libcst.codemod.TransformSuccess": [[1, 1, 1, "", "code"], [1, 1, 1, "", "warning_messages"]], "libcst.codemod.visitors": [[1, 0, 1, "", "AddImportsVisitor"], [1, 0, 1, "", "ApplyTypeAnnotationsVisitor"], [1, 0, 1, "", "GatherCommentsVisitor"], [1, 0, 1, "", "GatherExportsVisitor"], [1, 0, 1, "", "GatherImportsVisitor"], [1, 0, 1, "", "GatherNamesFromStringAnnotationsVisitor"], [1, 0, 1, "", "GatherUnusedImportsVisitor"], [1, 0, 1, "", "RemoveImportsVisitor"]], "libcst.codemod.visitors.AddImportsVisitor": [[1, 2, 1, "", "add_needed_import"]], "libcst.codemod.visitors.ApplyTypeAnnotationsVisitor": [[1, 2, 1, "", "store_stub_in_context"], [1, 2, 1, "", "transform_module_impl"]], "libcst.codemod.visitors.GatherCommentsVisitor": [[1, 1, 1, "", "METADATA_DEPENDENCIES"], [1, 1, 1, "", "comments"]], "libcst.codemod.visitors.GatherNamesFromStringAnnotationsVisitor": [[1, 1, 1, "", "METADATA_DEPENDENCIES"], [1, 1, 1, "", "names"]], "libcst.codemod.visitors.GatherUnusedImportsVisitor": [[1, 1, 1, "", "METADATA_DEPENDENCIES"], [1, 2, 1, "", "filter_unused_imports"], [1, 2, 1, "", "is_in_use"], [1, 1, 1, "", "unused_imports"]], "libcst.codemod.visitors.RemoveImportsVisitor": [[1, 1, 1, "", "METADATA_DEPENDENCIES"], [1, 2, 1, "", "remove_unused_import"], [1, 2, 1, "", "remove_unused_import_by_node"]], "libcst.helpers": [[4, 4, 1, "", "ensure_type"], [4, 4, 1, "", "get_full_name_for_node"], [4, 4, 1, "", "get_full_name_for_node_or_raise"], [4, 4, 1, "", "insert_header_comments"], [4, 4, 1, "", "parse_template_expression"], [4, 4, 1, "", "parse_template_module"], [4, 4, 1, "", "parse_template_statement"]], "libcst.matchers": [[6, 0, 1, "", "AllOf"], [6, 0, 1, "", "AtLeastN"], [6, 0, 1, "", "AtMostN"], [6, 0, 1, "", "BaseMatcherNode"], [6, 4, 1, "", "DoNotCare"], [6, 4, 1, "", "DoesNotMatch"], [6, 0, 1, "", "MatchIfTrue"], [6, 0, 1, "", "MatchMetadata"], [6, 0, 1, "", "MatchMetadataIfTrue"], [6, 4, 1, "", "MatchRegex"], [6, 0, 1, "", "MatcherDecoratableTransformer"], [6, 0, 1, "", "MatcherDecoratableVisitor"], [6, 0, 1, "", "OneOf"], [6, 4, 1, "", "SaveMatchedNode"], [6, 0, 1, "", "TypeOf"], [6, 4, 1, "", "ZeroOrMore"], [6, 4, 1, "", "ZeroOrOne"], [6, 4, 1, "", "call_if_inside"], [6, 4, 1, "", "call_if_not_inside"], [6, 4, 1, "", "extract"], [6, 4, 1, "", "extractall"], [6, 4, 1, "", "findall"], [6, 4, 1, "", "leave"], [6, 4, 1, "", "matches"], [6, 4, 1, "", "replace"], [6, 4, 1, "", "visit"]], "libcst.matchers.AllOf": [[6, 3, 1, "", "options"]], "libcst.matchers.AtLeastN": [[6, 3, 1, "", "matcher"], [6, 3, 1, "", "n"]], "libcst.matchers.AtMostN": [[6, 3, 1, "", "matcher"], [6, 3, 1, "", "n"]], "libcst.matchers.MatchIfTrue": [[6, 3, 1, "", "func"]], "libcst.matchers.MatchMetadata": [[6, 3, 1, "", "key"], [6, 3, 1, "", "value"]], "libcst.matchers.MatchMetadataIfTrue": [[6, 3, 1, "", "func"], [6, 3, 1, "", "key"]], "libcst.matchers.MatcherDecoratableTransformer": [[6, 2, 1, "", "extract"], [6, 2, 1, "", "extractall"], [6, 2, 1, "", "findall"], [6, 2, 1, "", "matches"], [6, 2, 1, "", "on_leave"], [6, 2, 1, "", "on_leave_attribute"], [6, 2, 1, "", "on_visit"], [6, 2, 1, "", "on_visit_attribute"], [6, 2, 1, "", "replace"]], "libcst.matchers.MatcherDecoratableVisitor": [[6, 2, 1, "", "extract"], [6, 2, 1, "", "extractall"], [6, 2, 1, "", "findall"], [6, 2, 1, "", "matches"], [6, 2, 1, "", "on_leave"], [6, 2, 1, "", "on_leave_attribute"], [6, 2, 1, "", "on_visit"], [6, 2, 1, "", "on_visit_attribute"], [6, 2, 1, "", "replace"]], "libcst.matchers.OneOf": [[6, 3, 1, "", "options"]], "libcst.matchers.TypeOf": [[6, 3, 1, "", "initalized"], [6, 3, 1, "", "options"]], "libcst.metadata": [[8, 0, 1, "", "Access"], [8, 0, 1, "", "Accesses"], [8, 0, 1, "", "Assignment"], [8, 0, 1, "", "Assignments"], [8, 0, 1, "", "BaseAssignment"], [8, 0, 1, "", "BatchableMetadataProvider"], [8, 0, 1, "", "BuiltinAssignment"], [8, 0, 1, "", "BuiltinScope"], [8, 0, 1, "", "ByteSpanPositionProvider"], [8, 0, 1, "", "ClassScope"], [8, 0, 1, "", "CodePosition"], [8, 0, 1, "", "CodeRange"], [8, 0, 1, "", "CodeSpan"], [3, 0, 1, "", "CodegenPartial"], [8, 0, 1, "", "ComprehensionScope"], [3, 0, 1, "", "ExperimentalReentrantCodegenProvider"], [8, 0, 1, "", "ExpressionContext"], [8, 0, 1, "", "ExpressionContextProvider"], [8, 0, 1, "", "FullRepoManager"], [8, 0, 1, "", "FullyQualifiedNameProvider"], [8, 0, 1, "", "FunctionScope"], [8, 0, 1, "", "GlobalScope"], [8, 0, 1, "", "MetadataWrapper"], [8, 0, 1, "", "ParentNodeProvider"], [8, 0, 1, "", "PositionProvider"], [8, 0, 1, "", "QualifiedName"], [8, 0, 1, "", "QualifiedNameProvider"], [8, 0, 1, "", "QualifiedNameSource"], [8, 0, 1, "", "Scope"], [8, 0, 1, "", "ScopeProvider"], [8, 0, 1, "", "TypeInferenceProvider"], [8, 0, 1, "", "VisitorMetadataProvider"], [8, 0, 1, "", "WhitespaceInclusivePositionProvider"]], "libcst.metadata.Access": [[8, 1, 1, "", "is_annotation"], [8, 1, 1, "", "is_type_hint"], [8, 1, 1, "", "node"], [8, 2, 1, "", "record_assignment"], [8, 2, 1, "", "record_assignments"], [8, 3, 1, "", "referents"], [8, 1, 1, "", "scope"]], "libcst.metadata.Accesses": [[8, 2, 1, "", "__contains__"], [8, 2, 1, "", "__getitem__"], [8, 2, 1, "", "__iter__"]], "libcst.metadata.Assignment": [[8, 1, 1, "", "node"]], "libcst.metadata.Assignments": [[8, 2, 1, "", "__contains__"], [8, 2, 1, "", "__getitem__"], [8, 2, 1, "", "__iter__"]], "libcst.metadata.BaseAssignment": [[8, 1, 1, "", "name"], [8, 3, 1, "", "references"], [8, 1, 1, "", "scope"]], "libcst.metadata.CodePosition": [[8, 1, 1, "", "column"], [8, 1, 1, "", "line"]], "libcst.metadata.CodeRange": [[8, 1, 1, "", "end"], [8, 1, 1, "", "start"]], "libcst.metadata.CodeSpan": [[8, 1, 1, "", "length"], [8, 1, 1, "", "start"]], "libcst.metadata.CodegenPartial": [[3, 1, 1, "", "end_offset"], [3, 2, 1, "", "get_modified_module_bytes"], [3, 2, 1, "", "get_modified_module_code"], [3, 2, 1, "", "get_modified_statement_code"], [3, 2, 1, "", "get_original_module_bytes"], [3, 2, 1, "", "get_original_module_code"], [3, 2, 1, "", "get_original_statement_code"], [3, 1, 1, "", "has_trailing_newline"], [3, 1, 1, "", "start_offset"]], "libcst.metadata.ExpressionContext": [[8, 1, 1, "", "DEL"], [8, 1, 1, "", "LOAD"], [8, 1, 1, "", "STORE"]], "libcst.metadata.FullRepoManager": [[8, 2, 1, "", "__init__"], [8, 3, 1, "", "cache"], [8, 2, 1, "", "get_cache_for_path"], [8, 2, 1, "", "get_metadata_wrapper_for_path"], [8, 2, 1, "", "resolve_cache"]], "libcst.metadata.FullyQualifiedNameProvider": [[8, 1, 1, "", "METADATA_DEPENDENCIES"], [8, 2, 1, "", "gen_cache"]], "libcst.metadata.MetadataWrapper": [[8, 2, 1, "", "__init__"], [8, 3, 1, "", "module"], [8, 2, 1, "", "resolve"], [8, 2, 1, "", "resolve_many"], [8, 2, 1, "", "visit"], [8, 2, 1, "", "visit_batched"]], "libcst.metadata.QualifiedName": [[8, 1, 1, "", "name"], [8, 1, 1, "", "source"]], "libcst.metadata.QualifiedNameProvider": [[8, 1, 1, "", "METADATA_DEPENDENCIES"], [8, 2, 1, "", "has_name"]], "libcst.metadata.QualifiedNameSource": [[8, 1, 1, "", "BUILTIN"], [8, 1, 1, "", "IMPORT"], [8, 1, 1, "", "LOCAL"]], "libcst.metadata.Scope": [[8, 2, 1, "", "__contains__"], [8, 2, 1, "", "__getitem__"], [8, 3, 1, "", "accesses"], [8, 3, 1, "", "assignments"], [8, 2, 1, "", "get_qualified_names_for"], [8, 1, 1, "", "globals"], [8, 1, 1, "", "parent"]], "libcst.metadata.ScopeProvider": [[8, 1, 1, "", "METADATA_DEPENDENCIES"]], "libcst.metadata.TypeInferenceProvider": [[8, 1, 1, "", "METADATA_DEPENDENCIES"], [8, 2, 1, "", "gen_cache"]]}, "objtypes": {"0": "py:class", "1": "py:attribute", "2": "py:method", "3": "py:property", "4": "py:function"}, "objnames": {"0": ["py", "class", "Python class"], "1": ["py", "attribute", "Python attribute"], "2": ["py", "method", "Python method"], "3": ["py", "property", "Python property"], "4": ["py", "function", "Python function"]}, "titleterms": {"best": 0, "practic": 0, "avoid": 0, "isinst": 0, "when": 0, "travers": [0, 4, 6, 10, 15], "prefer": 0, "updated_nod": 0, "modifi": 0, "tree": [0, 16], "provid": [0, 8, 9], "config": 0, "gener": [0, 3, 14], "code": [0, 3, 14], "from": [0, 14], "templat": 0, "codemod": [1, 2], "base": 1, "execut": 1, "interfac": 1, "command": 1, "line": [1, 9], "support": 1, "toolkit": 1, "librari": 1, "transform": [1, 4, 14], "work": [2, 7, 9], "With": 2, "set": 2, "up": 2, "run": 2, "write": 2, "test": [2, 10], "experiment": 3, "api": [3, 6, 8], "reentrant": 3, "helper": [4, 11, 15], "construct": 4, "libcst": [5, 16], "introduct": 5, "tutori": 5, "refer": [5, 13], "indic": 5, "tabl": 5, "privaci": 5, "polici": 5, "term": 5, "us": [5, 9], "matcher": [6, 7], "function": [6, 11, 15], "decor": [6, 7], "order": [6, 15], "type": [6, 8, 14], "concret": [6, 16], "special": 6, "sequenc": 6, "wildcard": 6, "basic": 7, "usag": 7, "metadata": [8, 9], "access": [8, 9], "posit": 8, "express": [8, 11], "context": 8, "scope": [8, 13], "qualifi": 8, "name": [8, 11], "parent": 8, "node": [8, 11], "infer": 8, "column": 9, "metadatawrapp": 9, "depend": 9, "declar": 9, "motiv": 10, "exact": 10, "represent": 10, "eas": 10, "modif": 10, "well": 10, "cstnode": 11, "modul": 11, "object": 11, "attribut": 11, "oper": 11, "comparison": 11, "control": 11, "flow": 11, "lambda": 11, "call": 11, "liter": 11, "valu": 11, "number": 11, "string": 11, "format": 11, "f": 11, "collect": 11, "simpl": 11, "element": 11, "dictionari": 11, "comprehens": 11, "subscript": 11, "slice": 11, "parenthesi": 11, "bracket": 11, "brace": 11, "statement": 11, "compound": 11, "block": 11, "unari": 11, "boolean": 11, "binari": 11, "augment": 11, "assign": 11, "miscellan": 11, "whitespac": 11, "mayb": 11, "sentinel": 11, "pars": [12, 14], "syntax": [12, 16], "error": 12, "analysi": 13, "warn": 13, "unus": 13, "import": 13, "undefin": 13, "automat": 13, "remov": 13, "visit": [14, 15], "sourc": 14, "exampl": 14, "add": 14, "annot": 14, "pyi": 14, "stub": 14, "file": 14, "python": 14, "build": 14, "visitor": [14, 15], "leav": 15, "batch": 15, "why": 16, "abstract": 16, "ast": 16, "cst": 16}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 8, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "nbsphinx": 4, "sphinx.ext.intersphinx": 1, "sphinx.ext.viewcode": 1, "sphinx": 57}, "alltitles": {"Best Practices": [[0, "best-practices"]], "Avoid isinstance when traversing": [[0, "avoid-isinstance-when-traversing"]], "Prefer updated_node when modifying trees": [[0, "prefer-updated-node-when-modifying-trees"]], "Provide a config when generating code from templates": [[0, "provide-a-config-when-generating-code-from-templates"]], "Codemods": [[1, "codemods"]], "Codemod Base": [[1, "codemod-base"]], "Execution Interface": [[1, "execution-interface"]], "Command-Line Support": [[1, "command-line-support"]], "Command-Line Toolkit": [[1, "command-line-toolkit"]], "Library of Transforms": [[1, "library-of-transforms"]], "Working With Codemods": [[2, "working-with-codemods"]], "Setting up and Running Codemods": [[2, "setting-up-and-running-codemods"]], "Writing a Codemod": [[2, "writing-a-codemod"]], "Testing Codemods": [[2, "testing-codemods"]], "Experimental APIs": [[3, "experimental-apis"]], "Reentrant Code Generation": [[3, "reentrant-code-generation"]], "Helpers": [[4, "helpers"]], "Construction Helpers": [[4, "construction-helpers"]], "Transformation Helpers": [[4, "transformation-helpers"]], "Traversing Helpers": [[4, "traversing-helpers"]], "LibCST": [[5, "libcst"], [16, "libcst"]], "Introduction:": [[5, null]], "Tutorial:": [[5, null]], "Reference:": [[5, null]], "Indices and tables": [[5, "indices-and-tables"]], "Privacy Policy and Terms of Use": [[5, "privacy-policy-and-terms-of-use"]], "Matchers": [[6, "matchers"]], "Matcher APIs": [[6, "matcher-apis"]], "Functions": [[6, "functions"]], "Decorators": [[6, "decorators"]], "Traversal Order": [[6, "traversal-order"], [15, "traversal-order"]], "Matcher Types": [[6, "matcher-types"]], "Concrete Matchers": [[6, "concrete-matchers"]], "Special Matchers": [[6, "special-matchers"]], "Sequence Wildcard Matchers": [[6, "sequence-wildcard-matchers"]], "Working with Matchers": [[7, "Working-with-Matchers"]], "Basic Matcher Usage": [[7, "Basic-Matcher-Usage"]], "Matcher Decorators": [[7, "Matcher-Decorators"]], "Metadata": [[8, "metadata"]], "Metadata APIs": [[8, "metadata-apis"]], "Accessing Metadata": [[8, "accessing-metadata"], [9, "Accessing-Metadata"]], "Providing Metadata": [[8, "providing-metadata"], [9, "Providing-Metadata"]], "Metadata Providers": [[8, "metadata-providers"]], "Position Metadata": [[8, "position-metadata"]], "Expression Context Metadata": [[8, "expression-context-metadata"]], "Scope Metadata": [[8, "scope-metadata"]], "Qualified Name Metadata": [[8, "qualified-name-metadata"]], "Parent Node Metadata": [[8, "parent-node-metadata"]], "Type Inference Metadata": [[8, "type-inference-metadata"]], "Working with Metadata": [[9, "Working-with-Metadata"]], "Line and Column Metadata": [[9, "Line-and-Column-Metadata"]], "Using the MetadataWrapper": [[9, "Using-the-MetadataWrapper"]], "Using Dependency Declaration": [[9, "Using-Dependency-Declaration"]], "Motivation": [[10, "motivation"]], "Exact Representation": [[10, "exact-representation"]], "Ease of Traversal": [[10, "ease-of-traversal"]], "Ease of Modification": [[10, "ease-of-modification"]], "Well Tested": [[10, "well-tested"]], "Nodes": [[11, "nodes"]], "CSTNode": [[11, "cstnode"]], "Module": [[11, "module"]], "Expressions": [[11, "expressions"]], "Names and Object Attributes": [[11, "names-and-object-attributes"]], "Operations and Comparisons": [[11, "operations-and-comparisons"]], "Control Flow": [[11, "control-flow"]], "Lambdas and Function Calls": [[11, "lambdas-and-function-calls"]], "Literal Values": [[11, "literal-values"]], "Numbers": [[11, "numbers"]], "Strings": [[11, "strings"]], "Formatted Strings (f-strings)": [[11, "formatted-strings-f-strings"]], "Collections": [[11, "collections"]], "Simple Collections": [[11, "simple-collections"]], "Simple Collection Elements": [[11, "simple-collection-elements"]], "Dictionaries": [[11, "dictionaries"]], "Dictionary Elements": [[11, "dictionary-elements"]], "Comprehensions": [[11, "comprehensions"]], "Subscripts and Slices": [[11, "subscripts-and-slices"]], "Parenthesis, Brackets, and Braces": [[11, "parenthesis-brackets-and-braces"]], "Statements": [[11, "statements"]], "Simple Statements": [[11, "simple-statements"]], "Compound Statements": [[11, "compound-statements"]], "Helper Nodes": [[11, "helper-nodes"]], "Statement Blocks": [[11, "statement-blocks"]], "Operators": [[11, "operators"]], "Unary Operators": [[11, "unary-operators"]], "Boolean Operators": [[11, "boolean-operators"]], "Binary Operators": [[11, "binary-operators"]], "Comparison Operators": [[11, "comparison-operators"]], "Augmented Assignment Operators": [[11, "augmented-assignment-operators"]], "Miscellaneous": [[11, "miscellaneous"]], "Whitespace": [[11, "whitespace"]], "Maybe Sentinel": [[11, "maybe-sentinel"]], "Parsing": [[12, "parsing"]], "Syntax Errors": [[12, "syntax-errors"]], "Scope Analysis": [[13, "Scope-Analysis"]], "Warn on unused imports and undefined references": [[13, "Warn-on-unused-imports-and-undefined-references"]], "Automatically Remove Unused Import": [[13, "Automatically-Remove-Unused-Import"]], "Parsing and Visiting": [[14, "Parsing-and-Visiting"]], "Parse Source Code": [[14, "Parse-Source-Code"]], "Example: add typing annotation from pyi stub file to Python source": [[14, "Example:-add-typing-annotation-from-pyi-stub-file-to-Python-source"]], "Build Visitor or Transformer": [[14, "Build-Visitor-or-Transformer"]], "Generate Source Code": [[14, "Generate-Source-Code"]], "Visitors": [[15, "visitors"]], "Visit and Leave Helper Functions": [[15, "visit-and-leave-helper-functions"]], "Batched Visitors": [[15, "batched-visitors"]], "Why LibCST?": [[16, "why-libcst"]], "Abstract Syntax Trees (AST)": [[16, "abstract-syntax-trees-ast"]], "Concrete Syntax Trees (CST)": [[16, "concrete-syntax-trees-cst"]]}, "indexentries": {"addimportsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.AddImportsVisitor"]], "applytypeannotationsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.ApplyTypeAnnotationsVisitor"]], "blacklisted (libcst.codemod.skipreason attribute)": [[1, "libcst.codemod.SkipReason.BLACKLISTED"]], "codemod (class in libcst.codemod)": [[1, "libcst.codemod.Codemod"]], "codemodcommand (class in libcst.codemod)": [[1, "libcst.codemod.CodemodCommand"]], "codemodcontext (class in libcst.codemod)": [[1, "libcst.codemod.CodemodContext"]], "codemodtest (class in libcst.codemod)": [[1, "libcst.codemod.CodemodTest"]], "contextawaretransformer (class in libcst.codemod)": [[1, "libcst.codemod.ContextAwareTransformer"]], "contextawarevisitor (class in libcst.codemod)": [[1, "libcst.codemod.ContextAwareVisitor"]], "description (libcst.codemod.codemodcommand attribute)": [[1, "libcst.codemod.CodemodCommand.DESCRIPTION"]], "generated (libcst.codemod.skipreason attribute)": [[1, "libcst.codemod.SkipReason.GENERATED"]], "gathercommentsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.GatherCommentsVisitor"]], "gatherexportsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.GatherExportsVisitor"]], "gatherimportsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.GatherImportsVisitor"]], "gathernamesfromstringannotationsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.GatherNamesFromStringAnnotationsVisitor"]], "gatherunusedimportsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.GatherUnusedImportsVisitor"]], "metadata_dependencies (libcst.codemod.visitors.gathercommentsvisitor attribute)": [[1, "libcst.codemod.visitors.GatherCommentsVisitor.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.codemod.visitors.gathernamesfromstringannotationsvisitor attribute)": [[1, "libcst.codemod.visitors.GatherNamesFromStringAnnotationsVisitor.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.codemod.visitors.gatherunusedimportsvisitor attribute)": [[1, "libcst.codemod.visitors.GatherUnusedImportsVisitor.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.codemod.visitors.removeimportsvisitor attribute)": [[1, "libcst.codemod.visitors.RemoveImportsVisitor.METADATA_DEPENDENCIES"]], "magicargscodemodcommand (class in libcst.codemod)": [[1, "libcst.codemod.MagicArgsCodemodCommand"]], "other (libcst.codemod.skipreason attribute)": [[1, "libcst.codemod.SkipReason.OTHER"]], "paralleltransformresult (class in libcst.codemod)": [[1, "libcst.codemod.ParallelTransformResult"]], "removeimportsvisitor (class in libcst.codemod.visitors)": [[1, "libcst.codemod.visitors.RemoveImportsVisitor"]], "skipfile (class in libcst.codemod)": [[1, "libcst.codemod.SkipFile"]], "skipreason (class in libcst.codemod)": [[1, "libcst.codemod.SkipReason"]], "transform (libcst.codemod.codemodtest attribute)": [[1, "libcst.codemod.CodemodTest.TRANSFORM"]], "transformexit (class in libcst.codemod)": [[1, "libcst.codemod.TransformExit"]], "transformfailure (class in libcst.codemod)": [[1, "libcst.codemod.TransformFailure"]], "transformresult (in module libcst.codemod)": [[1, "libcst.codemod.TransformResult"]], "transformskip (class in libcst.codemod)": [[1, "libcst.codemod.TransformSkip"]], "transformsuccess (class in libcst.codemod)": [[1, "libcst.codemod.TransformSuccess"]], "visitorbasedcodemodcommand (class in libcst.codemod)": [[1, "libcst.codemod.VisitorBasedCodemodCommand"]], "addclasscleanup() (libcst.codemod.codemodtest class method)": [[1, "libcst.codemod.CodemodTest.addClassCleanup"]], "add_args() (libcst.codemod.codemodcommand static method)": [[1, "libcst.codemod.CodemodCommand.add_args"]], "add_needed_import() (libcst.codemod.visitors.addimportsvisitor static method)": [[1, "libcst.codemod.visitors.AddImportsVisitor.add_needed_import"]], "assertcodeequal() (libcst.codemod.codemodtest method)": [[1, "libcst.codemod.CodemodTest.assertCodeEqual"]], "assertcodemod() (libcst.codemod.codemodtest method)": [[1, "libcst.codemod.CodemodTest.assertCodemod"]], "assertnologs() (libcst.codemod.codemodtest method)": [[1, "libcst.codemod.CodemodTest.assertNoLogs"]], "code (libcst.codemod.transformsuccess attribute)": [[1, "libcst.codemod.TransformSuccess.code"]], "comments (libcst.codemod.visitors.gathercommentsvisitor attribute)": [[1, "libcst.codemod.visitors.GatherCommentsVisitor.comments"]], "diff_code() (in module libcst.codemod)": [[1, "libcst.codemod.diff_code"]], "doclasscleanups() (libcst.codemod.codemodtest class method)": [[1, "libcst.codemod.CodemodTest.doClassCleanups"]], "enterclasscontext() (libcst.codemod.codemodtest class method)": [[1, "libcst.codemod.CodemodTest.enterClassContext"]], "entercontext() (libcst.codemod.codemodtest method)": [[1, "libcst.codemod.CodemodTest.enterContext"]], "error (libcst.codemod.transformfailure attribute)": [[1, "libcst.codemod.TransformFailure.error"]], "exec_transform_with_prettyprint() (in module libcst.codemod)": [[1, "libcst.codemod.exec_transform_with_prettyprint"]], "failures (libcst.codemod.paralleltransformresult attribute)": [[1, "libcst.codemod.ParallelTransformResult.failures"]], "filename (libcst.codemod.codemodcontext attribute)": [[1, "libcst.codemod.CodemodContext.filename"]], "filter_unused_imports() (libcst.codemod.visitors.gatherunusedimportsvisitor method)": [[1, "libcst.codemod.visitors.GatherUnusedImportsVisitor.filter_unused_imports"]], "full_module_name (libcst.codemod.codemodcontext attribute)": [[1, "libcst.codemod.CodemodContext.full_module_name"]], "gather_files() (in module libcst.codemod)": [[1, "libcst.codemod.gather_files"]], "get_transforms() (libcst.codemod.magicargscodemodcommand method)": [[1, "libcst.codemod.MagicArgsCodemodCommand.get_transforms"]], "is_in_use() (libcst.codemod.visitors.gatherunusedimportsvisitor method)": [[1, "libcst.codemod.visitors.GatherUnusedImportsVisitor.is_in_use"]], "make_fixture_data() (libcst.codemod.codemodtest static method)": [[1, "libcst.codemod.CodemodTest.make_fixture_data"]], "metadata_manager (libcst.codemod.codemodcontext attribute)": [[1, "libcst.codemod.CodemodContext.metadata_manager"]], "module (libcst.codemod.codemod property)": [[1, "libcst.codemod.Codemod.module"]], "module (libcst.codemod.codemodcontext property)": [[1, "libcst.codemod.CodemodContext.module"]], "module (libcst.codemod.contextawarevisitor property)": [[1, "libcst.codemod.ContextAwareVisitor.module"]], "names (libcst.codemod.visitors.gathernamesfromstringannotationsvisitor attribute)": [[1, "libcst.codemod.visitors.GatherNamesFromStringAnnotationsVisitor.names"]], "parallel_exec_transform_with_prettyprint() (in module libcst.codemod)": [[1, "libcst.codemod.parallel_exec_transform_with_prettyprint"]], "remove_unused_import() (libcst.codemod.visitors.removeimportsvisitor static method)": [[1, "libcst.codemod.visitors.RemoveImportsVisitor.remove_unused_import"]], "remove_unused_import_by_node() (libcst.codemod.visitors.removeimportsvisitor static method)": [[1, "libcst.codemod.visitors.RemoveImportsVisitor.remove_unused_import_by_node"]], "scratch (libcst.codemod.codemodcontext attribute)": [[1, "libcst.codemod.CodemodContext.scratch"]], "should_allow_multiple_passes() (libcst.codemod.codemod method)": [[1, "libcst.codemod.Codemod.should_allow_multiple_passes"]], "skip_description (libcst.codemod.transformskip attribute)": [[1, "libcst.codemod.TransformSkip.skip_description"]], "skip_reason (libcst.codemod.transformskip attribute)": [[1, "libcst.codemod.TransformSkip.skip_reason"]], "skips (libcst.codemod.paralleltransformresult attribute)": [[1, "libcst.codemod.ParallelTransformResult.skips"]], "store_stub_in_context() (libcst.codemod.visitors.applytypeannotationsvisitor static method)": [[1, "libcst.codemod.visitors.ApplyTypeAnnotationsVisitor.store_stub_in_context"]], "successes (libcst.codemod.paralleltransformresult attribute)": [[1, "libcst.codemod.ParallelTransformResult.successes"]], "traceback_str (libcst.codemod.transformfailure attribute)": [[1, "libcst.codemod.TransformFailure.traceback_str"]], "transform_module() (in module libcst.codemod)": [[1, "libcst.codemod.transform_module"]], "transform_module() (libcst.codemod.codemod method)": [[1, "libcst.codemod.Codemod.transform_module"]], "transform_module_impl() (libcst.codemod.codemod method)": [[1, "libcst.codemod.Codemod.transform_module_impl"]], "transform_module_impl() (libcst.codemod.codemodcommand method)": [[1, "libcst.codemod.CodemodCommand.transform_module_impl"]], "transform_module_impl() (libcst.codemod.visitors.applytypeannotationsvisitor method)": [[1, "libcst.codemod.visitors.ApplyTypeAnnotationsVisitor.transform_module_impl"]], "unused_imports (libcst.codemod.visitors.gatherunusedimportsvisitor attribute)": [[1, "libcst.codemod.visitors.GatherUnusedImportsVisitor.unused_imports"]], "warn() (libcst.codemod.codemod method)": [[1, "libcst.codemod.Codemod.warn"]], "warn() (libcst.codemod.contextawarevisitor method)": [[1, "libcst.codemod.ContextAwareVisitor.warn"]], "warning_messages (libcst.codemod.transformexit attribute)": [[1, "libcst.codemod.TransformExit.warning_messages"]], "warning_messages (libcst.codemod.transformfailure attribute)": [[1, "libcst.codemod.TransformFailure.warning_messages"]], "warning_messages (libcst.codemod.transformskip attribute)": [[1, "libcst.codemod.TransformSkip.warning_messages"]], "warning_messages (libcst.codemod.transformsuccess attribute)": [[1, "libcst.codemod.TransformSuccess.warning_messages"]], "warnings (libcst.codemod.codemodcontext attribute)": [[1, "libcst.codemod.CodemodContext.warnings"]], "warnings (libcst.codemod.paralleltransformresult attribute)": [[1, "libcst.codemod.ParallelTransformResult.warnings"]], "wrapper (libcst.codemod.codemodcontext attribute)": [[1, "libcst.codemod.CodemodContext.wrapper"]], "codegenpartial (class in libcst.metadata)": [[3, "libcst.metadata.CodegenPartial"]], "experimentalreentrantcodegenprovider (class in libcst.metadata)": [[3, "libcst.metadata.ExperimentalReentrantCodegenProvider"]], "end_offset (libcst.metadata.codegenpartial attribute)": [[3, "libcst.metadata.CodegenPartial.end_offset"]], "get_modified_module_bytes() (libcst.metadata.codegenpartial method)": [[3, "libcst.metadata.CodegenPartial.get_modified_module_bytes"]], "get_modified_module_code() (libcst.metadata.codegenpartial method)": [[3, "libcst.metadata.CodegenPartial.get_modified_module_code"]], "get_modified_statement_code() (libcst.metadata.codegenpartial method)": [[3, "libcst.metadata.CodegenPartial.get_modified_statement_code"]], "get_original_module_bytes() (libcst.metadata.codegenpartial method)": [[3, "libcst.metadata.CodegenPartial.get_original_module_bytes"]], "get_original_module_code() (libcst.metadata.codegenpartial method)": [[3, "libcst.metadata.CodegenPartial.get_original_module_code"]], "get_original_statement_code() (libcst.metadata.codegenpartial method)": [[3, "libcst.metadata.CodegenPartial.get_original_statement_code"]], "has_trailing_newline (libcst.metadata.codegenpartial attribute)": [[3, "libcst.metadata.CodegenPartial.has_trailing_newline"]], "start_offset (libcst.metadata.codegenpartial attribute)": [[3, "libcst.metadata.CodegenPartial.start_offset"]], "ensure_type() (in module libcst.helpers)": [[4, "libcst.helpers.ensure_type"]], "get_full_name_for_node() (in module libcst.helpers)": [[4, "libcst.helpers.get_full_name_for_node"]], "get_full_name_for_node_or_raise() (in module libcst.helpers)": [[4, "libcst.helpers.get_full_name_for_node_or_raise"]], "insert_header_comments() (in module libcst.helpers)": [[4, "libcst.helpers.insert_header_comments"]], "parse_template_expression() (in module libcst.helpers)": [[4, "libcst.helpers.parse_template_expression"]], "parse_template_module() (in module libcst.helpers)": [[4, "libcst.helpers.parse_template_module"]], "parse_template_statement() (in module libcst.helpers)": [[4, "libcst.helpers.parse_template_statement"]], "allof (class in libcst.matchers)": [[6, "libcst.matchers.AllOf"]], "atleastn (class in libcst.matchers)": [[6, "libcst.matchers.AtLeastN"]], "atmostn (class in libcst.matchers)": [[6, "libcst.matchers.AtMostN"]], "basematchernode (class in libcst.matchers)": [[6, "libcst.matchers.BaseMatcherNode"]], "donotcare() (in module libcst.matchers)": [[6, "libcst.matchers.DoNotCare"]], "doesnotmatch() (in module libcst.matchers)": [[6, "libcst.matchers.DoesNotMatch"]], "matchiftrue (class in libcst.matchers)": [[6, "libcst.matchers.MatchIfTrue"]], "matchmetadata (class in libcst.matchers)": [[6, "libcst.matchers.MatchMetadata"]], "matchmetadataiftrue (class in libcst.matchers)": [[6, "libcst.matchers.MatchMetadataIfTrue"]], "matchregex() (in module libcst.matchers)": [[6, "libcst.matchers.MatchRegex"]], "matcherdecoratabletransformer (class in libcst.matchers)": [[6, "libcst.matchers.MatcherDecoratableTransformer"]], "matcherdecoratablevisitor (class in libcst.matchers)": [[6, "libcst.matchers.MatcherDecoratableVisitor"]], "oneof (class in libcst.matchers)": [[6, "libcst.matchers.OneOf"]], "savematchednode() (in module libcst.matchers)": [[6, "libcst.matchers.SaveMatchedNode"]], "typeof (class in libcst.matchers)": [[6, "libcst.matchers.TypeOf"]], "zeroormore() (in module libcst.matchers)": [[6, "libcst.matchers.ZeroOrMore"]], "zeroorone() (in module libcst.matchers)": [[6, "libcst.matchers.ZeroOrOne"]], "call_if_inside() (in module libcst.matchers)": [[6, "libcst.matchers.call_if_inside"]], "call_if_not_inside() (in module libcst.matchers)": [[6, "libcst.matchers.call_if_not_inside"]], "extract() (in module libcst.matchers)": [[6, "libcst.matchers.extract"]], "extract() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.extract"]], "extract() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.extract"]], "extractall() (in module libcst.matchers)": [[6, "libcst.matchers.extractall"]], "extractall() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.extractall"]], "extractall() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.extractall"]], "findall() (in module libcst.matchers)": [[6, "libcst.matchers.findall"]], "findall() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.findall"]], "findall() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.findall"]], "func (libcst.matchers.matchiftrue property)": [[6, "libcst.matchers.MatchIfTrue.func"]], "func (libcst.matchers.matchmetadataiftrue property)": [[6, "libcst.matchers.MatchMetadataIfTrue.func"]], "initalized (libcst.matchers.typeof property)": [[6, "libcst.matchers.TypeOf.initalized"]], "key (libcst.matchers.matchmetadata property)": [[6, "libcst.matchers.MatchMetadata.key"]], "key (libcst.matchers.matchmetadataiftrue property)": [[6, "libcst.matchers.MatchMetadataIfTrue.key"]], "leave() (in module libcst.matchers)": [[6, "libcst.matchers.leave"]], "matcher (libcst.matchers.atleastn property)": [[6, "libcst.matchers.AtLeastN.matcher"]], "matcher (libcst.matchers.atmostn property)": [[6, "libcst.matchers.AtMostN.matcher"]], "matches() (in module libcst.matchers)": [[6, "libcst.matchers.matches"]], "matches() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.matches"]], "matches() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.matches"]], "n (libcst.matchers.atleastn property)": [[6, "libcst.matchers.AtLeastN.n"]], "n (libcst.matchers.atmostn property)": [[6, "libcst.matchers.AtMostN.n"]], "on_leave() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.on_leave"]], "on_leave() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.on_leave"]], "on_leave_attribute() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.on_leave_attribute"]], "on_leave_attribute() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.on_leave_attribute"]], "on_visit() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.on_visit"]], "on_visit() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.on_visit"]], "on_visit_attribute() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.on_visit_attribute"]], "on_visit_attribute() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.on_visit_attribute"]], "options (libcst.matchers.allof property)": [[6, "libcst.matchers.AllOf.options"]], "options (libcst.matchers.oneof property)": [[6, "libcst.matchers.OneOf.options"]], "options (libcst.matchers.typeof property)": [[6, "libcst.matchers.TypeOf.options"]], "replace() (in module libcst.matchers)": [[6, "libcst.matchers.replace"]], "replace() (libcst.matchers.matcherdecoratabletransformer method)": [[6, "libcst.matchers.MatcherDecoratableTransformer.replace"]], "replace() (libcst.matchers.matcherdecoratablevisitor method)": [[6, "libcst.matchers.MatcherDecoratableVisitor.replace"]], "value (libcst.matchers.matchmetadata property)": [[6, "libcst.matchers.MatchMetadata.value"]], "visit() (in module libcst.matchers)": [[6, "libcst.matchers.visit"]], "access (class in libcst.metadata)": [[8, "libcst.metadata.Access"]], "accesses (class in libcst.metadata)": [[8, "libcst.metadata.Accesses"]], "assignment (class in libcst.metadata)": [[8, "libcst.metadata.Assignment"]], "assignments (class in libcst.metadata)": [[8, "libcst.metadata.Assignments"]], "builtin (libcst.metadata.qualifiednamesource attribute)": [[8, "libcst.metadata.QualifiedNameSource.BUILTIN"]], "baseassignment (class in libcst.metadata)": [[8, "libcst.metadata.BaseAssignment"]], "basemetadataprovider (class in libcst)": [[8, "libcst.BaseMetadataProvider"]], "batchablemetadataprovider (class in libcst.metadata)": [[8, "libcst.metadata.BatchableMetadataProvider"]], "builtinassignment (class in libcst.metadata)": [[8, "libcst.metadata.BuiltinAssignment"]], "builtinscope (class in libcst.metadata)": [[8, "libcst.metadata.BuiltinScope"]], "bytespanpositionprovider (class in libcst.metadata)": [[8, "libcst.metadata.ByteSpanPositionProvider"]], "classscope (class in libcst.metadata)": [[8, "libcst.metadata.ClassScope"]], "codeposition (class in libcst.metadata)": [[8, "libcst.metadata.CodePosition"]], "coderange (class in libcst.metadata)": [[8, "libcst.metadata.CodeRange"]], "codespan (class in libcst.metadata)": [[8, "libcst.metadata.CodeSpan"]], "comprehensionscope (class in libcst.metadata)": [[8, "libcst.metadata.ComprehensionScope"]], "del (libcst.metadata.expressioncontext attribute)": [[8, "libcst.metadata.ExpressionContext.DEL"]], "expressioncontext (class in libcst.metadata)": [[8, "libcst.metadata.ExpressionContext"]], "expressioncontextprovider (class in libcst.metadata)": [[8, "libcst.metadata.ExpressionContextProvider"]], "fullrepomanager (class in libcst.metadata)": [[8, "libcst.metadata.FullRepoManager"]], "fullyqualifiednameprovider (class in libcst.metadata)": [[8, "libcst.metadata.FullyQualifiedNameProvider"]], "functionscope (class in libcst.metadata)": [[8, "libcst.metadata.FunctionScope"]], "globalscope (class in libcst.metadata)": [[8, "libcst.metadata.GlobalScope"]], "import (libcst.metadata.qualifiednamesource attribute)": [[8, "libcst.metadata.QualifiedNameSource.IMPORT"]], "load (libcst.metadata.expressioncontext attribute)": [[8, "libcst.metadata.ExpressionContext.LOAD"]], "local (libcst.metadata.qualifiednamesource attribute)": [[8, "libcst.metadata.QualifiedNameSource.LOCAL"]], "metadata_dependencies (libcst.metadatadependent attribute)": [[8, "libcst.MetadataDependent.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.metadata.fullyqualifiednameprovider attribute)": [[8, "libcst.metadata.FullyQualifiedNameProvider.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.metadata.qualifiednameprovider attribute)": [[8, "libcst.metadata.QualifiedNameProvider.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.metadata.scopeprovider attribute)": [[8, "libcst.metadata.ScopeProvider.METADATA_DEPENDENCIES"]], "metadata_dependencies (libcst.metadata.typeinferenceprovider attribute)": [[8, "libcst.metadata.TypeInferenceProvider.METADATA_DEPENDENCIES"]], "metadatadependent (class in libcst)": [[8, "libcst.MetadataDependent"]], "metadatawrapper (class in libcst.metadata)": [[8, "libcst.metadata.MetadataWrapper"]], "parentnodeprovider (class in libcst.metadata)": [[8, "libcst.metadata.ParentNodeProvider"]], "positionprovider (class in libcst.metadata)": [[8, "libcst.metadata.PositionProvider"]], "qualifiedname (class in libcst.metadata)": [[8, "libcst.metadata.QualifiedName"]], "qualifiednameprovider (class in libcst.metadata)": [[8, "libcst.metadata.QualifiedNameProvider"]], "qualifiednamesource (class in libcst.metadata)": [[8, "libcst.metadata.QualifiedNameSource"]], "store (libcst.metadata.expressioncontext attribute)": [[8, "libcst.metadata.ExpressionContext.STORE"]], "scope (class in libcst.metadata)": [[8, "libcst.metadata.Scope"]], "scopeprovider (class in libcst.metadata)": [[8, "libcst.metadata.ScopeProvider"]], "typeinferenceprovider (class in libcst.metadata)": [[8, "libcst.metadata.TypeInferenceProvider"]], "visitormetadataprovider (class in libcst.metadata)": [[8, "libcst.metadata.VisitorMetadataProvider"]], "whitespaceinclusivepositionprovider (class in libcst.metadata)": [[8, "libcst.metadata.WhitespaceInclusivePositionProvider"]], "__contains__() (libcst.metadata.accesses method)": [[8, "libcst.metadata.Accesses.__contains__"]], "__contains__() (libcst.metadata.assignments method)": [[8, "libcst.metadata.Assignments.__contains__"]], "__contains__() (libcst.metadata.scope method)": [[8, "libcst.metadata.Scope.__contains__"]], "__getitem__() (libcst.metadata.accesses method)": [[8, "libcst.metadata.Accesses.__getitem__"]], "__getitem__() (libcst.metadata.assignments method)": [[8, "libcst.metadata.Assignments.__getitem__"]], "__getitem__() (libcst.metadata.scope method)": [[8, "libcst.metadata.Scope.__getitem__"]], "__init__() (libcst.metadata.fullrepomanager method)": [[8, "libcst.metadata.FullRepoManager.__init__"]], "__init__() (libcst.metadata.metadatawrapper method)": [[8, "libcst.metadata.MetadataWrapper.__init__"]], "__iter__() (libcst.metadata.accesses method)": [[8, "libcst.metadata.Accesses.__iter__"]], "__iter__() (libcst.metadata.assignments method)": [[8, "libcst.metadata.Assignments.__iter__"]], "accesses (libcst.metadata.scope property)": [[8, "libcst.metadata.Scope.accesses"]], "assignments (libcst.metadata.scope property)": [[8, "libcst.metadata.Scope.assignments"]], "cache (libcst.metadata.fullrepomanager property)": [[8, "libcst.metadata.FullRepoManager.cache"]], "column (libcst.metadata.codeposition attribute)": [[8, "libcst.metadata.CodePosition.column"]], "end (libcst.metadata.coderange attribute)": [[8, "libcst.metadata.CodeRange.end"]], "gen_cache (libcst.basemetadataprovider attribute)": [[8, "libcst.BaseMetadataProvider.gen_cache"]], "gen_cache() (libcst.metadata.fullyqualifiednameprovider class method)": [[8, "libcst.metadata.FullyQualifiedNameProvider.gen_cache"]], "gen_cache() (libcst.metadata.typeinferenceprovider static method)": [[8, "libcst.metadata.TypeInferenceProvider.gen_cache"]], "get_cache_for_path() (libcst.metadata.fullrepomanager method)": [[8, "libcst.metadata.FullRepoManager.get_cache_for_path"]], "get_inherited_dependencies() (libcst.metadatadependent class method)": [[8, "libcst.MetadataDependent.get_inherited_dependencies"]], "get_metadata() (libcst.basemetadataprovider method)": [[8, "libcst.BaseMetadataProvider.get_metadata"]], "get_metadata() (libcst.metadatadependent method)": [[8, "libcst.MetadataDependent.get_metadata"]], "get_metadata_wrapper_for_path() (libcst.metadata.fullrepomanager method)": [[8, "libcst.metadata.FullRepoManager.get_metadata_wrapper_for_path"]], "get_qualified_names_for() (libcst.metadata.scope method)": [[8, "libcst.metadata.Scope.get_qualified_names_for"]], "globals (libcst.metadata.scope attribute)": [[8, "libcst.metadata.Scope.globals"]], "has_name() (libcst.metadata.qualifiednameprovider static method)": [[8, "libcst.metadata.QualifiedNameProvider.has_name"]], "is_annotation (libcst.metadata.access attribute)": [[8, "libcst.metadata.Access.is_annotation"]], "is_type_hint (libcst.metadata.access attribute)": [[8, "libcst.metadata.Access.is_type_hint"]], "length (libcst.metadata.codespan attribute)": [[8, "libcst.metadata.CodeSpan.length"]], "line (libcst.metadata.codeposition attribute)": [[8, "libcst.metadata.CodePosition.line"]], "metadata (libcst.metadatadependent attribute)": [[8, "libcst.MetadataDependent.metadata"]], "module (libcst.metadata.metadatawrapper property)": [[8, "libcst.metadata.MetadataWrapper.module"]], "name (libcst.metadata.baseassignment attribute)": [[8, "libcst.metadata.BaseAssignment.name"]], "name (libcst.metadata.qualifiedname attribute)": [[8, "libcst.metadata.QualifiedName.name"]], "node (libcst.metadata.access attribute)": [[8, "libcst.metadata.Access.node"]], "node (libcst.metadata.assignment attribute)": [[8, "libcst.metadata.Assignment.node"]], "parent (libcst.metadata.scope attribute)": [[8, "libcst.metadata.Scope.parent"]], "record_assignment() (libcst.metadata.access method)": [[8, "libcst.metadata.Access.record_assignment"]], "record_assignments() (libcst.metadata.access method)": [[8, "libcst.metadata.Access.record_assignments"]], "references (libcst.metadata.baseassignment property)": [[8, "libcst.metadata.BaseAssignment.references"]], "referents (libcst.metadata.access property)": [[8, "libcst.metadata.Access.referents"]], "resolve() (libcst.metadatadependent method)": [[8, "libcst.MetadataDependent.resolve"]], "resolve() (libcst.metadata.metadatawrapper method)": [[8, "libcst.metadata.MetadataWrapper.resolve"]], "resolve_cache() (libcst.metadata.fullrepomanager method)": [[8, "libcst.metadata.FullRepoManager.resolve_cache"]], "resolve_many() (libcst.metadata.metadatawrapper method)": [[8, "libcst.metadata.MetadataWrapper.resolve_many"]], "scope (libcst.metadata.access attribute)": [[8, "libcst.metadata.Access.scope"]], "scope (libcst.metadata.baseassignment attribute)": [[8, "libcst.metadata.BaseAssignment.scope"]], "set_metadata() (libcst.basemetadataprovider method)": [[8, "libcst.BaseMetadataProvider.set_metadata"]], "source (libcst.metadata.qualifiedname attribute)": [[8, "libcst.metadata.QualifiedName.source"]], "start (libcst.metadata.coderange attribute)": [[8, "libcst.metadata.CodeRange.start"]], "start (libcst.metadata.codespan attribute)": [[8, "libcst.metadata.CodeSpan.start"]], "visit() (libcst.metadata.metadatawrapper method)": [[8, "libcst.metadata.MetadataWrapper.visit"]], "visit_batched() (libcst.metadata.metadatawrapper method)": [[8, "libcst.metadata.MetadataWrapper.visit_batched"]], "annassign (class in libcst)": [[11, "libcst.AnnAssign"]], "annotation (class in libcst)": [[11, "libcst.Annotation"]], "arg (class in libcst)": [[11, "libcst.Arg"]], "asname (class in libcst)": [[11, "libcst.AsName"]], "assert (class in libcst)": [[11, "libcst.Assert"]], "assign (class in libcst)": [[11, "libcst.Assign"]], "assignequal (class in libcst)": [[11, "libcst.AssignEqual"]], "assigntarget (class in libcst)": [[11, "libcst.AssignTarget"]], "asynchronous (class in libcst)": [[11, "libcst.Asynchronous"]], "attribute (class in libcst)": [[11, "libcst.Attribute"]], "augassign (class in libcst)": [[11, "libcst.AugAssign"]], "await (class in libcst)": [[11, "libcst.Await"]], "baseassigntargetexpression (class in libcst)": [[11, "libcst.BaseAssignTargetExpression"]], "basecomp (class in libcst)": [[11, "libcst.BaseComp"]], "basecompoundstatement (class in libcst)": [[11, "libcst.BaseCompoundStatement"]], "basedeltargetexpression (class in libcst)": [[11, "libcst.BaseDelTargetExpression"]], "basedict (class in libcst)": [[11, "libcst.BaseDict"]], "basedictelement (class in libcst)": [[11, "libcst.BaseDictElement"]], "baseelement (class in libcst)": [[11, "libcst.BaseElement"]], "baseexpression (class in libcst)": [[11, "libcst.BaseExpression"]], "baseformattedstringcontent (class in libcst)": [[11, "libcst.BaseFormattedStringContent"]], "baselist (class in libcst)": [[11, "libcst.BaseList"]], "basenumber (class in libcst)": [[11, "libcst.BaseNumber"]], "baseparenthesizablewhitespace (class in libcst)": [[11, "libcst.BaseParenthesizableWhitespace"]], "baseset (class in libcst)": [[11, "libcst.BaseSet"]], "basesimplecomp (class in libcst)": [[11, "libcst.BaseSimpleComp"]], "baseslice (class in libcst)": [[11, "libcst.BaseSlice"]], "basesmallstatement (class in libcst)": [[11, "libcst.BaseSmallStatement"]], "basestring (class in libcst)": [[11, "libcst.BaseString"]], "basesuite (class in libcst)": [[11, "libcst.BaseSuite"]], "binaryoperation (class in libcst)": [[11, "libcst.BinaryOperation"]], "booleanoperation (class in libcst)": [[11, "libcst.BooleanOperation"]], "break (class in libcst)": [[11, "libcst.Break"]], "cstnode (class in libcst)": [[11, "libcst.CSTNode"]], "call (class in libcst)": [[11, "libcst.Call"]], "classdef (class in libcst)": [[11, "libcst.ClassDef"]], "colon (class in libcst)": [[11, "libcst.Colon"]], "comma (class in libcst)": [[11, "libcst.Comma"]], "comment (class in libcst)": [[11, "libcst.Comment"]], "compfor (class in libcst)": [[11, "libcst.CompFor"]], "compif (class in libcst)": [[11, "libcst.CompIf"]], "comparison (class in libcst)": [[11, "libcst.Comparison"]], "comparisontarget (class in libcst)": [[11, "libcst.ComparisonTarget"]], "concatenatedstring (class in libcst)": [[11, "libcst.ConcatenatedString"]], "continue (class in libcst)": [[11, "libcst.Continue"]], "default (libcst.maybesentinel attribute)": [[11, "libcst.MaybeSentinel.DEFAULT"]], "decorator (class in libcst)": [[11, "libcst.Decorator"]], "del (class in libcst)": [[11, "libcst.Del"]], "dict (class in libcst)": [[11, "libcst.Dict"]], "dictcomp (class in libcst)": [[11, "libcst.DictComp"]], "dictelement (class in libcst)": [[11, "libcst.DictElement"]], "dot (class in libcst)": [[11, "libcst.Dot"]], "element (class in libcst)": [[11, "libcst.Element"]], "ellipsis (class in libcst)": [[11, "libcst.Ellipsis"]], "else (class in libcst)": [[11, "libcst.Else"]], "emptyline (class in libcst)": [[11, "libcst.EmptyLine"]], "excepthandler (class in libcst)": [[11, "libcst.ExceptHandler"]], "expr (class in libcst)": [[11, "libcst.Expr"]], "finally (class in libcst)": [[11, "libcst.Finally"]], "float (class in libcst)": [[11, "libcst.Float"]], "for (class in libcst)": [[11, "libcst.For"]], "formattedstring (class in libcst)": [[11, "libcst.FormattedString"]], "formattedstringexpression (class in libcst)": [[11, "libcst.FormattedStringExpression"]], "formattedstringtext (class in libcst)": [[11, "libcst.FormattedStringText"]], "from (class in libcst)": [[11, "libcst.From"]], "functiondef (class in libcst)": [[11, "libcst.FunctionDef"]], "generatorexp (class in libcst)": [[11, "libcst.GeneratorExp"]], "global (class in libcst)": [[11, "libcst.Global"]], "if (class in libcst)": [[11, "libcst.If"]], "ifexp (class in libcst)": [[11, "libcst.IfExp"]], "imaginary (class in libcst)": [[11, "libcst.Imaginary"]], "import (class in libcst)": [[11, "libcst.Import"]], "importalias (class in libcst)": [[11, "libcst.ImportAlias"]], "importfrom (class in libcst)": [[11, "libcst.ImportFrom"]], "importstar (class in libcst)": [[11, "libcst.ImportStar"]], "indentedblock (class in libcst)": [[11, "libcst.IndentedBlock"]], "index (class in libcst)": [[11, "libcst.Index"]], "integer (class in libcst)": [[11, "libcst.Integer"]], "lambda (class in libcst)": [[11, "libcst.Lambda"]], "leftcurlybrace (class in libcst)": [[11, "libcst.LeftCurlyBrace"]], "leftparen (class in libcst)": [[11, "libcst.LeftParen"]], "leftsquarebracket (class in libcst)": [[11, "libcst.LeftSquareBracket"]], "lessthanequal (class in libcst)": [[11, "libcst.LessThanEqual"]], "list (class in libcst)": [[11, "libcst.List"]], "listcomp (class in libcst)": [[11, "libcst.ListComp"]], "maybesentinel (class in libcst)": [[11, "libcst.MaybeSentinel"]], "module (class in libcst)": [[11, "libcst.Module"]], "name (class in libcst)": [[11, "libcst.Name"]], "nameitem (class in libcst)": [[11, "libcst.NameItem"]], "newline (class in libcst)": [[11, "libcst.Newline"]], "nonlocal (class in libcst)": [[11, "libcst.Nonlocal"]], "notequal (class in libcst)": [[11, "libcst.NotEqual"]], "notin (class in libcst)": [[11, "libcst.NotIn"]], "or (class in libcst)": [[11, "libcst.Or"]], "param (class in libcst)": [[11, "libcst.Param"]], "paramslash (class in libcst)": [[11, "libcst.ParamSlash"]], "paramstar (class in libcst)": [[11, "libcst.ParamStar"]], "parameters (class in libcst)": [[11, "libcst.Parameters"]], "parenthesizedwhitespace (class in libcst)": [[11, "libcst.ParenthesizedWhitespace"]], "pass (class in libcst)": [[11, "libcst.Pass"]], "plus (class in libcst)": [[11, "libcst.Plus"]], "raise (class in libcst)": [[11, "libcst.Raise"]], "return (class in libcst)": [[11, "libcst.Return"]], "rightcurlybrace (class in libcst)": [[11, "libcst.RightCurlyBrace"]], "rightparen (class in libcst)": [[11, "libcst.RightParen"]], "rightsquarebracket (class in libcst)": [[11, "libcst.RightSquareBracket"]], "semicolon (class in libcst)": [[11, "libcst.Semicolon"]], "set (class in libcst)": [[11, "libcst.Set"]], "setcomp (class in libcst)": [[11, "libcst.SetComp"]], "simplestatementline (class in libcst)": [[11, "libcst.SimpleStatementLine"]], "simplestatementsuite (class in libcst)": [[11, "libcst.SimpleStatementSuite"]], "simplestring (class in libcst)": [[11, "libcst.SimpleString"]], "simplewhitespace (class in libcst)": [[11, "libcst.SimpleWhitespace"]], "slice (class in libcst)": [[11, "libcst.Slice"]], "starreddictelement (class in libcst)": [[11, "libcst.StarredDictElement"]], "starredelement (class in libcst)": [[11, "libcst.StarredElement"]], "subscript (class in libcst)": [[11, "libcst.Subscript"]], "subscriptelement (class in libcst)": [[11, "libcst.SubscriptElement"]], "subtract (class in libcst)": [[11, "libcst.Subtract"]], "subtractassign (class in libcst)": [[11, "libcst.SubtractAssign"]], "trailingwhitespace (class in libcst)": [[11, "libcst.TrailingWhitespace"]], "try (class in libcst)": [[11, "libcst.Try"]], "tuple (class in libcst)": [[11, "libcst.Tuple"]], "unaryoperation (class in libcst)": [[11, "libcst.UnaryOperation"]], "while (class in libcst)": [[11, "libcst.While"]], "with (class in libcst)": [[11, "libcst.With"]], "withitem (class in libcst)": [[11, "libcst.WithItem"]], "yield (class in libcst)": [[11, "libcst.Yield"]], "annotation (libcst.annassign attribute)": [[11, "libcst.AnnAssign.annotation"]], "annotation (libcst.annotation attribute)": [[11, "libcst.Annotation.annotation"]], "annotation (libcst.param attribute)": [[11, "libcst.Param.annotation"]], "args (libcst.call attribute)": [[11, "libcst.Call.args"]], "asname (libcst.importalias attribute)": [[11, "libcst.ImportAlias.asname"]], "asname (libcst.withitem attribute)": [[11, "libcst.WithItem.asname"]], "asynchronous (libcst.compfor attribute)": [[11, "libcst.CompFor.asynchronous"]], "asynchronous (libcst.for attribute)": [[11, "libcst.For.asynchronous"]], "asynchronous (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.asynchronous"]], "asynchronous (libcst.with attribute)": [[11, "libcst.With.asynchronous"]], "attr (libcst.attribute attribute)": [[11, "libcst.Attribute.attr"]], "bases (libcst.classdef attribute)": [[11, "libcst.ClassDef.bases"]], "body (libcst.basecompoundstatement attribute)": [[11, "libcst.BaseCompoundStatement.body"]], "body (libcst.basesuite attribute)": [[11, "libcst.BaseSuite.body"]], "body (libcst.classdef attribute)": [[11, "libcst.ClassDef.body"]], "body (libcst.else attribute)": [[11, "libcst.Else.body"]], "body (libcst.excepthandler attribute)": [[11, "libcst.ExceptHandler.body"]], "body (libcst.finally attribute)": [[11, "libcst.Finally.body"]], "body (libcst.for attribute)": [[11, "libcst.For.body"]], "body (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.body"]], "body (libcst.if attribute)": [[11, "libcst.If.body"]], "body (libcst.ifexp attribute)": [[11, "libcst.IfExp.body"]], "body (libcst.indentedblock attribute)": [[11, "libcst.IndentedBlock.body"]], "body (libcst.lambda attribute)": [[11, "libcst.Lambda.body"]], "body (libcst.module attribute)": [[11, "libcst.Module.body"]], "body (libcst.simplestatementline attribute)": [[11, "libcst.SimpleStatementLine.body"]], "body (libcst.simplestatementsuite attribute)": [[11, "libcst.SimpleStatementSuite.body"]], "body (libcst.try attribute)": [[11, "libcst.Try.body"]], "body (libcst.while attribute)": [[11, "libcst.While.body"]], "body (libcst.with attribute)": [[11, "libcst.With.body"]], "bytes (libcst.module property)": [[11, "libcst.Module.bytes"]], "cause (libcst.raise attribute)": [[11, "libcst.Raise.cause"]], "children (libcst.cstnode property)": [[11, "libcst.CSTNode.children"]], "code (libcst.module property)": [[11, "libcst.Module.code"]], "code_for_node() (libcst.module method)": [[11, "libcst.Module.code_for_node"]], "colon (libcst.lambda attribute)": [[11, "libcst.Lambda.colon"]], "comma (libcst.arg attribute)": [[11, "libcst.Arg.comma"]], "comma (libcst.assert attribute)": [[11, "libcst.Assert.comma"]], "comma (libcst.dictelement attribute)": [[11, "libcst.DictElement.comma"]], "comma (libcst.element attribute)": [[11, "libcst.Element.comma"]], "comma (libcst.importalias attribute)": [[11, "libcst.ImportAlias.comma"]], "comma (libcst.nameitem attribute)": [[11, "libcst.NameItem.comma"]], "comma (libcst.param attribute)": [[11, "libcst.Param.comma"]], "comma (libcst.paramslash attribute)": [[11, "libcst.ParamSlash.comma"]], "comma (libcst.paramstar attribute)": [[11, "libcst.ParamStar.comma"]], "comma (libcst.starreddictelement attribute)": [[11, "libcst.StarredDictElement.comma"]], "comma (libcst.starredelement attribute)": [[11, "libcst.StarredElement.comma"]], "comma (libcst.subscriptelement attribute)": [[11, "libcst.SubscriptElement.comma"]], "comma (libcst.withitem attribute)": [[11, "libcst.WithItem.comma"]], "comment (libcst.emptyline attribute)": [[11, "libcst.EmptyLine.comment"]], "comment (libcst.trailingwhitespace attribute)": [[11, "libcst.TrailingWhitespace.comment"]], "comparator (libcst.comparisontarget attribute)": [[11, "libcst.ComparisonTarget.comparator"]], "comparisons (libcst.comparison attribute)": [[11, "libcst.Comparison.comparisons"]], "config_for_parsing (libcst.module property)": [[11, "libcst.Module.config_for_parsing"]], "conversion (libcst.formattedstringexpression attribute)": [[11, "libcst.FormattedStringExpression.conversion"]], "decorator (libcst.decorator attribute)": [[11, "libcst.Decorator.decorator"]], "decorators (libcst.classdef attribute)": [[11, "libcst.ClassDef.decorators"]], "decorators (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.decorators"]], "deep_clone() (libcst.cstnode method)": [[11, "libcst.CSTNode.deep_clone"]], "deep_equals() (libcst.cstnode method)": [[11, "libcst.CSTNode.deep_equals"]], "deep_remove() (libcst.cstnode method)": [[11, "libcst.CSTNode.deep_remove"]], "deep_replace() (libcst.cstnode method)": [[11, "libcst.CSTNode.deep_replace"]], "default (libcst.param attribute)": [[11, "libcst.Param.default"]], "default_indent (libcst.module attribute)": [[11, "libcst.Module.default_indent"]], "default_newline (libcst.module attribute)": [[11, "libcst.Module.default_newline"]], "dot (libcst.attribute attribute)": [[11, "libcst.Attribute.dot"]], "elements (libcst.dict attribute)": [[11, "libcst.Dict.elements"]], "elements (libcst.list attribute)": [[11, "libcst.List.elements"]], "elements (libcst.set attribute)": [[11, "libcst.Set.elements"]], "elements (libcst.tuple attribute)": [[11, "libcst.Tuple.elements"]], "elt (libcst.basesimplecomp attribute)": [[11, "libcst.BaseSimpleComp.elt"]], "elt (libcst.generatorexp attribute)": [[11, "libcst.GeneratorExp.elt"]], "elt (libcst.listcomp attribute)": [[11, "libcst.ListComp.elt"]], "elt (libcst.setcomp attribute)": [[11, "libcst.SetComp.elt"]], "empty (libcst.baseparenthesizablewhitespace property)": [[11, "libcst.BaseParenthesizableWhitespace.empty"]], "empty (libcst.parenthesizedwhitespace property)": [[11, "libcst.ParenthesizedWhitespace.empty"]], "empty (libcst.simplewhitespace property)": [[11, "libcst.SimpleWhitespace.empty"]], "empty_lines (libcst.parenthesizedwhitespace attribute)": [[11, "libcst.ParenthesizedWhitespace.empty_lines"]], "encoding (libcst.module attribute)": [[11, "libcst.Module.encoding"]], "end (libcst.formattedstring attribute)": [[11, "libcst.FormattedString.end"]], "equal (libcst.annassign attribute)": [[11, "libcst.AnnAssign.equal"]], "equal (libcst.arg attribute)": [[11, "libcst.Arg.equal"]], "equal (libcst.formattedstringexpression attribute)": [[11, "libcst.FormattedStringExpression.equal"]], "equal (libcst.param attribute)": [[11, "libcst.Param.equal"]], "evaluated_alias (libcst.importalias property)": [[11, "libcst.ImportAlias.evaluated_alias"]], "evaluated_name (libcst.importalias property)": [[11, "libcst.ImportAlias.evaluated_name"]], "evaluated_value (libcst.concatenatedstring property)": [[11, "libcst.ConcatenatedString.evaluated_value"]], "evaluated_value (libcst.float property)": [[11, "libcst.Float.evaluated_value"]], "evaluated_value (libcst.imaginary property)": [[11, "libcst.Imaginary.evaluated_value"]], "evaluated_value (libcst.integer property)": [[11, "libcst.Integer.evaluated_value"]], "evaluated_value (libcst.simplestring property)": [[11, "libcst.SimpleString.evaluated_value"]], "exc (libcst.raise attribute)": [[11, "libcst.Raise.exc"]], "expression (libcst.await attribute)": [[11, "libcst.Await.expression"]], "expression (libcst.formattedstringexpression attribute)": [[11, "libcst.FormattedStringExpression.expression"]], "expression (libcst.unaryoperation attribute)": [[11, "libcst.UnaryOperation.expression"]], "field() (libcst.cstnode class method)": [[11, "libcst.CSTNode.field"]], "finalbody (libcst.try attribute)": [[11, "libcst.Try.finalbody"]], "first_colon (libcst.slice attribute)": [[11, "libcst.Slice.first_colon"]], "first_line (libcst.parenthesizedwhitespace attribute)": [[11, "libcst.ParenthesizedWhitespace.first_line"]], "footer (libcst.indentedblock attribute)": [[11, "libcst.IndentedBlock.footer"]], "footer (libcst.module attribute)": [[11, "libcst.Module.footer"]], "for_in (libcst.basecomp attribute)": [[11, "libcst.BaseComp.for_in"]], "for_in (libcst.basesimplecomp attribute)": [[11, "libcst.BaseSimpleComp.for_in"]], "for_in (libcst.dictcomp attribute)": [[11, "libcst.DictComp.for_in"]], "for_in (libcst.generatorexp attribute)": [[11, "libcst.GeneratorExp.for_in"]], "for_in (libcst.listcomp attribute)": [[11, "libcst.ListComp.for_in"]], "for_in (libcst.setcomp attribute)": [[11, "libcst.SetComp.for_in"]], "format_spec (libcst.formattedstringexpression attribute)": [[11, "libcst.FormattedStringExpression.format_spec"]], "func (libcst.call attribute)": [[11, "libcst.Call.func"]], "get_docstring() (libcst.classdef method)": [[11, "libcst.ClassDef.get_docstring"]], "get_docstring() (libcst.functiondef method)": [[11, "libcst.FunctionDef.get_docstring"]], "get_docstring() (libcst.module method)": [[11, "libcst.Module.get_docstring"]], "handlers (libcst.try attribute)": [[11, "libcst.Try.handlers"]], "has_trailing_newline (libcst.module attribute)": [[11, "libcst.Module.has_trailing_newline"]], "header (libcst.indentedblock attribute)": [[11, "libcst.IndentedBlock.header"]], "header (libcst.module attribute)": [[11, "libcst.Module.header"]], "ifs (libcst.compfor attribute)": [[11, "libcst.CompFor.ifs"]], "indent (libcst.emptyline attribute)": [[11, "libcst.EmptyLine.indent"]], "indent (libcst.indentedblock attribute)": [[11, "libcst.IndentedBlock.indent"]], "indent (libcst.parenthesizedwhitespace attribute)": [[11, "libcst.ParenthesizedWhitespace.indent"]], "inner_for_in (libcst.compfor attribute)": [[11, "libcst.CompFor.inner_for_in"]], "item (libcst.from attribute)": [[11, "libcst.From.item"]], "item (libcst.withitem attribute)": [[11, "libcst.WithItem.item"]], "items (libcst.with attribute)": [[11, "libcst.With.items"]], "iter (libcst.compfor attribute)": [[11, "libcst.CompFor.iter"]], "iter (libcst.for attribute)": [[11, "libcst.For.iter"]], "key (libcst.dictcomp attribute)": [[11, "libcst.DictComp.key"]], "key (libcst.dictelement attribute)": [[11, "libcst.DictElement.key"]], "keyword (libcst.arg attribute)": [[11, "libcst.Arg.keyword"]], "keywords (libcst.classdef attribute)": [[11, "libcst.ClassDef.keywords"]], "kwonly_params (libcst.parameters attribute)": [[11, "libcst.Parameters.kwonly_params"]], "last_line (libcst.parenthesizedwhitespace attribute)": [[11, "libcst.ParenthesizedWhitespace.last_line"]], "lbrace (libcst.dict attribute)": [[11, "libcst.Dict.lbrace"]], "lbrace (libcst.dictcomp attribute)": [[11, "libcst.DictComp.lbrace"]], "lbrace (libcst.set attribute)": [[11, "libcst.Set.lbrace"]], "lbrace (libcst.setcomp attribute)": [[11, "libcst.SetComp.lbrace"]], "lbracket (libcst.baselist attribute)": [[11, "libcst.BaseList.lbracket"]], "lbracket (libcst.list attribute)": [[11, "libcst.List.lbracket"]], "lbracket (libcst.listcomp attribute)": [[11, "libcst.ListComp.lbracket"]], "lbracket (libcst.subscript attribute)": [[11, "libcst.Subscript.lbracket"]], "leading_lines (libcst.basecompoundstatement attribute)": [[11, "libcst.BaseCompoundStatement.leading_lines"]], "leading_lines (libcst.classdef attribute)": [[11, "libcst.ClassDef.leading_lines"]], "leading_lines (libcst.decorator attribute)": [[11, "libcst.Decorator.leading_lines"]], "leading_lines (libcst.else attribute)": [[11, "libcst.Else.leading_lines"]], "leading_lines (libcst.excepthandler attribute)": [[11, "libcst.ExceptHandler.leading_lines"]], "leading_lines (libcst.finally attribute)": [[11, "libcst.Finally.leading_lines"]], "leading_lines (libcst.for attribute)": [[11, "libcst.For.leading_lines"]], "leading_lines (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.leading_lines"]], "leading_lines (libcst.if attribute)": [[11, "libcst.If.leading_lines"]], "leading_lines (libcst.simplestatementline attribute)": [[11, "libcst.SimpleStatementLine.leading_lines"]], "leading_lines (libcst.try attribute)": [[11, "libcst.Try.leading_lines"]], "leading_lines (libcst.while attribute)": [[11, "libcst.While.leading_lines"]], "leading_lines (libcst.with attribute)": [[11, "libcst.With.leading_lines"]], "leading_whitespace (libcst.simplestatementsuite attribute)": [[11, "libcst.SimpleStatementSuite.leading_whitespace"]], "left (libcst.binaryoperation attribute)": [[11, "libcst.BinaryOperation.left"]], "left (libcst.booleanoperation attribute)": [[11, "libcst.BooleanOperation.left"]], "left (libcst.comparison attribute)": [[11, "libcst.Comparison.left"]], "left (libcst.concatenatedstring attribute)": [[11, "libcst.ConcatenatedString.left"]], "libcst.add (built-in class)": [[11, "libcst.Add"]], "libcst.addassign (built-in class)": [[11, "libcst.AddAssign"]], "libcst.and (built-in class)": [[11, "libcst.And"]], "libcst.baseaugop (built-in class)": [[11, "libcst.BaseAugOp"]], "libcst.basebinaryop (built-in class)": [[11, "libcst.BaseBinaryOp"]], "libcst.basebooleanop (built-in class)": [[11, "libcst.BaseBooleanOp"]], "libcst.basecompop (built-in class)": [[11, "libcst.BaseCompOp"]], "libcst.baseunaryop (built-in class)": [[11, "libcst.BaseUnaryOp"]], "libcst.bitand (built-in class)": [[11, "libcst.BitAnd"]], "libcst.bitandassign (built-in class)": [[11, "libcst.BitAndAssign"]], "libcst.bitinvert (built-in class)": [[11, "libcst.BitInvert"]], "libcst.bitor (built-in class)": [[11, "libcst.BitOr"]], "libcst.bitorassign (built-in class)": [[11, "libcst.BitOrAssign"]], "libcst.bitxor (built-in class)": [[11, "libcst.BitXor"]], "libcst.bitxorassign (built-in class)": [[11, "libcst.BitXorAssign"]], "libcst.divide (built-in class)": [[11, "libcst.Divide"]], "libcst.divideassign (built-in class)": [[11, "libcst.DivideAssign"]], "libcst.equal (built-in class)": [[11, "libcst.Equal"]], "libcst.floordivide (built-in class)": [[11, "libcst.FloorDivide"]], "libcst.floordivideassign (built-in class)": [[11, "libcst.FloorDivideAssign"]], "libcst.greaterthan (built-in class)": [[11, "libcst.GreaterThan"]], "libcst.greaterthanequal (built-in class)": [[11, "libcst.GreaterThanEqual"]], "libcst.in (built-in class)": [[11, "libcst.In"]], "libcst.is (built-in class)": [[11, "libcst.Is"]], "libcst.isnot (built-in class)": [[11, "libcst.IsNot"]], "libcst.leftshift (built-in class)": [[11, "libcst.LeftShift"]], "libcst.leftshiftassign (built-in class)": [[11, "libcst.LeftShiftAssign"]], "libcst.lessthan (built-in class)": [[11, "libcst.LessThan"]], "libcst.matrixmultiply (built-in class)": [[11, "libcst.MatrixMultiply"]], "libcst.matrixmultiplyassign (built-in class)": [[11, "libcst.MatrixMultiplyAssign"]], "libcst.minus (built-in class)": [[11, "libcst.Minus"]], "libcst.modulo (built-in class)": [[11, "libcst.Modulo"]], "libcst.moduloassign (built-in class)": [[11, "libcst.ModuloAssign"]], "libcst.multiply (built-in class)": [[11, "libcst.Multiply"]], "libcst.multiplyassign (built-in class)": [[11, "libcst.MultiplyAssign"]], "libcst.not (built-in class)": [[11, "libcst.Not"]], "libcst.power (built-in class)": [[11, "libcst.Power"]], "libcst.powerassign (built-in class)": [[11, "libcst.PowerAssign"]], "libcst.rightshift (built-in class)": [[11, "libcst.RightShift"]], "libcst.rightshiftassign (built-in class)": [[11, "libcst.RightShiftAssign"]], "lines_after_decorators (libcst.classdef attribute)": [[11, "libcst.ClassDef.lines_after_decorators"]], "lines_after_decorators (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.lines_after_decorators"]], "lower (libcst.slice attribute)": [[11, "libcst.Slice.lower"]], "lpar (libcst.attribute attribute)": [[11, "libcst.Attribute.lpar"]], "lpar (libcst.await attribute)": [[11, "libcst.Await.lpar"]], "lpar (libcst.baselist attribute)": [[11, "libcst.BaseList.lpar"]], "lpar (libcst.binaryoperation attribute)": [[11, "libcst.BinaryOperation.lpar"]], "lpar (libcst.booleanoperation attribute)": [[11, "libcst.BooleanOperation.lpar"]], "lpar (libcst.call attribute)": [[11, "libcst.Call.lpar"]], "lpar (libcst.classdef attribute)": [[11, "libcst.ClassDef.lpar"]], "lpar (libcst.comparison attribute)": [[11, "libcst.Comparison.lpar"]], "lpar (libcst.concatenatedstring attribute)": [[11, "libcst.ConcatenatedString.lpar"]], "lpar (libcst.dict attribute)": [[11, "libcst.Dict.lpar"]], "lpar (libcst.dictcomp attribute)": [[11, "libcst.DictComp.lpar"]], "lpar (libcst.ellipsis attribute)": [[11, "libcst.Ellipsis.lpar"]], "lpar (libcst.float attribute)": [[11, "libcst.Float.lpar"]], "lpar (libcst.formattedstring attribute)": [[11, "libcst.FormattedString.lpar"]], "lpar (libcst.generatorexp attribute)": [[11, "libcst.GeneratorExp.lpar"]], "lpar (libcst.ifexp attribute)": [[11, "libcst.IfExp.lpar"]], "lpar (libcst.imaginary attribute)": [[11, "libcst.Imaginary.lpar"]], "lpar (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.lpar"]], "lpar (libcst.integer attribute)": [[11, "libcst.Integer.lpar"]], "lpar (libcst.lambda attribute)": [[11, "libcst.Lambda.lpar"]], "lpar (libcst.list attribute)": [[11, "libcst.List.lpar"]], "lpar (libcst.listcomp attribute)": [[11, "libcst.ListComp.lpar"]], "lpar (libcst.name attribute)": [[11, "libcst.Name.lpar"]], "lpar (libcst.set attribute)": [[11, "libcst.Set.lpar"]], "lpar (libcst.setcomp attribute)": [[11, "libcst.SetComp.lpar"]], "lpar (libcst.simplestring attribute)": [[11, "libcst.SimpleString.lpar"]], "lpar (libcst.starredelement attribute)": [[11, "libcst.StarredElement.lpar"]], "lpar (libcst.subscript attribute)": [[11, "libcst.Subscript.lpar"]], "lpar (libcst.tuple attribute)": [[11, "libcst.Tuple.lpar"]], "lpar (libcst.unaryoperation attribute)": [[11, "libcst.UnaryOperation.lpar"]], "lpar (libcst.yield attribute)": [[11, "libcst.Yield.lpar"]], "module (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.module"]], "msg (libcst.assert attribute)": [[11, "libcst.Assert.msg"]], "name (libcst.asname attribute)": [[11, "libcst.AsName.name"]], "name (libcst.classdef attribute)": [[11, "libcst.ClassDef.name"]], "name (libcst.excepthandler attribute)": [[11, "libcst.ExceptHandler.name"]], "name (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.name"]], "name (libcst.importalias attribute)": [[11, "libcst.ImportAlias.name"]], "name (libcst.nameitem attribute)": [[11, "libcst.NameItem.name"]], "name (libcst.param attribute)": [[11, "libcst.Param.name"]], "names (libcst.global attribute)": [[11, "libcst.Global.names"]], "names (libcst.import attribute)": [[11, "libcst.Import.names"]], "names (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.names"]], "names (libcst.nonlocal attribute)": [[11, "libcst.Nonlocal.names"]], "newline (libcst.emptyline attribute)": [[11, "libcst.EmptyLine.newline"]], "newline (libcst.trailingwhitespace attribute)": [[11, "libcst.TrailingWhitespace.newline"]], "operator (libcst.augassign attribute)": [[11, "libcst.AugAssign.operator"]], "operator (libcst.binaryoperation attribute)": [[11, "libcst.BinaryOperation.operator"]], "operator (libcst.booleanoperation attribute)": [[11, "libcst.BooleanOperation.operator"]], "operator (libcst.comparisontarget attribute)": [[11, "libcst.ComparisonTarget.operator"]], "operator (libcst.unaryoperation attribute)": [[11, "libcst.UnaryOperation.operator"]], "orelse (libcst.for attribute)": [[11, "libcst.For.orelse"]], "orelse (libcst.if attribute)": [[11, "libcst.If.orelse"]], "orelse (libcst.ifexp attribute)": [[11, "libcst.IfExp.orelse"]], "orelse (libcst.try attribute)": [[11, "libcst.Try.orelse"]], "orelse (libcst.while attribute)": [[11, "libcst.While.orelse"]], "params (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.params"]], "params (libcst.lambda attribute)": [[11, "libcst.Lambda.params"]], "params (libcst.parameters attribute)": [[11, "libcst.Parameters.params"]], "parts (libcst.formattedstring attribute)": [[11, "libcst.FormattedString.parts"]], "posonly_ind (libcst.parameters attribute)": [[11, "libcst.Parameters.posonly_ind"]], "posonly_params (libcst.parameters attribute)": [[11, "libcst.Parameters.posonly_params"]], "prefix (libcst.formattedstring property)": [[11, "libcst.FormattedString.prefix"]], "prefix (libcst.simplestring property)": [[11, "libcst.SimpleString.prefix"]], "quote (libcst.formattedstring property)": [[11, "libcst.FormattedString.quote"]], "quote (libcst.simplestring property)": [[11, "libcst.SimpleString.quote"]], "raw_value (libcst.simplestring property)": [[11, "libcst.SimpleString.raw_value"]], "rbrace (libcst.dict attribute)": [[11, "libcst.Dict.rbrace"]], "rbrace (libcst.dictcomp attribute)": [[11, "libcst.DictComp.rbrace"]], "rbrace (libcst.set attribute)": [[11, "libcst.Set.rbrace"]], "rbrace (libcst.setcomp attribute)": [[11, "libcst.SetComp.rbrace"]], "rbracket (libcst.baselist attribute)": [[11, "libcst.BaseList.rbracket"]], "rbracket (libcst.list attribute)": [[11, "libcst.List.rbracket"]], "rbracket (libcst.listcomp attribute)": [[11, "libcst.ListComp.rbracket"]], "rbracket (libcst.subscript attribute)": [[11, "libcst.Subscript.rbracket"]], "relative (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.relative"]], "returns (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.returns"]], "right (libcst.binaryoperation attribute)": [[11, "libcst.BinaryOperation.right"]], "right (libcst.booleanoperation attribute)": [[11, "libcst.BooleanOperation.right"]], "right (libcst.concatenatedstring attribute)": [[11, "libcst.ConcatenatedString.right"]], "rpar (libcst.attribute attribute)": [[11, "libcst.Attribute.rpar"]], "rpar (libcst.await attribute)": [[11, "libcst.Await.rpar"]], "rpar (libcst.baselist attribute)": [[11, "libcst.BaseList.rpar"]], "rpar (libcst.binaryoperation attribute)": [[11, "libcst.BinaryOperation.rpar"]], "rpar (libcst.booleanoperation attribute)": [[11, "libcst.BooleanOperation.rpar"]], "rpar (libcst.call attribute)": [[11, "libcst.Call.rpar"]], "rpar (libcst.classdef attribute)": [[11, "libcst.ClassDef.rpar"]], "rpar (libcst.comparison attribute)": [[11, "libcst.Comparison.rpar"]], "rpar (libcst.concatenatedstring attribute)": [[11, "libcst.ConcatenatedString.rpar"]], "rpar (libcst.dict attribute)": [[11, "libcst.Dict.rpar"]], "rpar (libcst.dictcomp attribute)": [[11, "libcst.DictComp.rpar"]], "rpar (libcst.ellipsis attribute)": [[11, "libcst.Ellipsis.rpar"]], "rpar (libcst.float attribute)": [[11, "libcst.Float.rpar"]], "rpar (libcst.formattedstring attribute)": [[11, "libcst.FormattedString.rpar"]], "rpar (libcst.generatorexp attribute)": [[11, "libcst.GeneratorExp.rpar"]], "rpar (libcst.ifexp attribute)": [[11, "libcst.IfExp.rpar"]], "rpar (libcst.imaginary attribute)": [[11, "libcst.Imaginary.rpar"]], "rpar (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.rpar"]], "rpar (libcst.integer attribute)": [[11, "libcst.Integer.rpar"]], "rpar (libcst.lambda attribute)": [[11, "libcst.Lambda.rpar"]], "rpar (libcst.list attribute)": [[11, "libcst.List.rpar"]], "rpar (libcst.listcomp attribute)": [[11, "libcst.ListComp.rpar"]], "rpar (libcst.name attribute)": [[11, "libcst.Name.rpar"]], "rpar (libcst.set attribute)": [[11, "libcst.Set.rpar"]], "rpar (libcst.setcomp attribute)": [[11, "libcst.SetComp.rpar"]], "rpar (libcst.simplestring attribute)": [[11, "libcst.SimpleString.rpar"]], "rpar (libcst.starredelement attribute)": [[11, "libcst.StarredElement.rpar"]], "rpar (libcst.subscript attribute)": [[11, "libcst.Subscript.rpar"]], "rpar (libcst.tuple attribute)": [[11, "libcst.Tuple.rpar"]], "rpar (libcst.unaryoperation attribute)": [[11, "libcst.UnaryOperation.rpar"]], "rpar (libcst.yield attribute)": [[11, "libcst.Yield.rpar"]], "second_colon (libcst.slice attribute)": [[11, "libcst.Slice.second_colon"]], "semicolon (libcst.annassign attribute)": [[11, "libcst.AnnAssign.semicolon"]], "semicolon (libcst.assert attribute)": [[11, "libcst.Assert.semicolon"]], "semicolon (libcst.assign attribute)": [[11, "libcst.Assign.semicolon"]], "semicolon (libcst.augassign attribute)": [[11, "libcst.AugAssign.semicolon"]], "semicolon (libcst.basesmallstatement attribute)": [[11, "libcst.BaseSmallStatement.semicolon"]], "semicolon (libcst.break attribute)": [[11, "libcst.Break.semicolon"]], "semicolon (libcst.continue attribute)": [[11, "libcst.Continue.semicolon"]], "semicolon (libcst.del attribute)": [[11, "libcst.Del.semicolon"]], "semicolon (libcst.expr attribute)": [[11, "libcst.Expr.semicolon"]], "semicolon (libcst.global attribute)": [[11, "libcst.Global.semicolon"]], "semicolon (libcst.import attribute)": [[11, "libcst.Import.semicolon"]], "semicolon (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.semicolon"]], "semicolon (libcst.nonlocal attribute)": [[11, "libcst.Nonlocal.semicolon"]], "semicolon (libcst.pass attribute)": [[11, "libcst.Pass.semicolon"]], "semicolon (libcst.raise attribute)": [[11, "libcst.Raise.semicolon"]], "semicolon (libcst.return attribute)": [[11, "libcst.Return.semicolon"]], "slice (libcst.subscript attribute)": [[11, "libcst.Subscript.slice"]], "slice (libcst.subscriptelement attribute)": [[11, "libcst.SubscriptElement.slice"]], "star (libcst.arg attribute)": [[11, "libcst.Arg.star"]], "star (libcst.param attribute)": [[11, "libcst.Param.star"]], "star_arg (libcst.parameters attribute)": [[11, "libcst.Parameters.star_arg"]], "star_kwarg (libcst.parameters attribute)": [[11, "libcst.Parameters.star_kwarg"]], "start (libcst.formattedstring attribute)": [[11, "libcst.FormattedString.start"]], "step (libcst.slice attribute)": [[11, "libcst.Slice.step"]], "target (libcst.annassign attribute)": [[11, "libcst.AnnAssign.target"]], "target (libcst.assigntarget attribute)": [[11, "libcst.AssignTarget.target"]], "target (libcst.augassign attribute)": [[11, "libcst.AugAssign.target"]], "target (libcst.compfor attribute)": [[11, "libcst.CompFor.target"]], "target (libcst.del attribute)": [[11, "libcst.Del.target"]], "target (libcst.for attribute)": [[11, "libcst.For.target"]], "targets (libcst.assign attribute)": [[11, "libcst.Assign.targets"]], "test (libcst.assert attribute)": [[11, "libcst.Assert.test"]], "test (libcst.compif attribute)": [[11, "libcst.CompIf.test"]], "test (libcst.if attribute)": [[11, "libcst.If.test"]], "test (libcst.ifexp attribute)": [[11, "libcst.IfExp.test"]], "test (libcst.while attribute)": [[11, "libcst.While.test"]], "trailing_whitespace (libcst.decorator attribute)": [[11, "libcst.Decorator.trailing_whitespace"]], "trailing_whitespace (libcst.simplestatementline attribute)": [[11, "libcst.SimpleStatementLine.trailing_whitespace"]], "trailing_whitespace (libcst.simplestatementsuite attribute)": [[11, "libcst.SimpleStatementSuite.trailing_whitespace"]], "type (libcst.excepthandler attribute)": [[11, "libcst.ExceptHandler.type"]], "upper (libcst.slice attribute)": [[11, "libcst.Slice.upper"]], "validate_types_deep() (libcst.cstnode method)": [[11, "libcst.CSTNode.validate_types_deep"]], "validate_types_shallow() (libcst.cstnode method)": [[11, "libcst.CSTNode.validate_types_shallow"]], "value (libcst.annassign attribute)": [[11, "libcst.AnnAssign.value"]], "value (libcst.arg attribute)": [[11, "libcst.Arg.value"]], "value (libcst.assign attribute)": [[11, "libcst.Assign.value"]], "value (libcst.attribute attribute)": [[11, "libcst.Attribute.value"]], "value (libcst.augassign attribute)": [[11, "libcst.AugAssign.value"]], "value (libcst.comment attribute)": [[11, "libcst.Comment.value"]], "value (libcst.dictcomp attribute)": [[11, "libcst.DictComp.value"]], "value (libcst.dictelement attribute)": [[11, "libcst.DictElement.value"]], "value (libcst.element attribute)": [[11, "libcst.Element.value"]], "value (libcst.expr attribute)": [[11, "libcst.Expr.value"]], "value (libcst.float attribute)": [[11, "libcst.Float.value"]], "value (libcst.formattedstringtext attribute)": [[11, "libcst.FormattedStringText.value"]], "value (libcst.imaginary attribute)": [[11, "libcst.Imaginary.value"]], "value (libcst.index attribute)": [[11, "libcst.Index.value"]], "value (libcst.integer attribute)": [[11, "libcst.Integer.value"]], "value (libcst.name attribute)": [[11, "libcst.Name.value"]], "value (libcst.newline attribute)": [[11, "libcst.Newline.value"]], "value (libcst.notequal attribute)": [[11, "libcst.NotEqual.value"]], "value (libcst.return attribute)": [[11, "libcst.Return.value"]], "value (libcst.simplestring attribute)": [[11, "libcst.SimpleString.value"]], "value (libcst.simplewhitespace attribute)": [[11, "libcst.SimpleWhitespace.value"]], "value (libcst.starreddictelement attribute)": [[11, "libcst.StarredDictElement.value"]], "value (libcst.starredelement attribute)": [[11, "libcst.StarredElement.value"]], "value (libcst.subscript attribute)": [[11, "libcst.Subscript.value"]], "value (libcst.yield attribute)": [[11, "libcst.Yield.value"]], "visit() (libcst.cstnode method)": [[11, "libcst.CSTNode.visit"]], "visit() (libcst.module method)": [[11, "libcst.Module.visit"]], "whitespace (libcst.emptyline attribute)": [[11, "libcst.EmptyLine.whitespace"]], "whitespace (libcst.trailingwhitespace attribute)": [[11, "libcst.TrailingWhitespace.whitespace"]], "whitespace_after (libcst.assignequal attribute)": [[11, "libcst.AssignEqual.whitespace_after"]], "whitespace_after (libcst.asynchronous attribute)": [[11, "libcst.Asynchronous.whitespace_after"]], "whitespace_after (libcst.colon attribute)": [[11, "libcst.Colon.whitespace_after"]], "whitespace_after (libcst.comma attribute)": [[11, "libcst.Comma.whitespace_after"]], "whitespace_after (libcst.dot attribute)": [[11, "libcst.Dot.whitespace_after"]], "whitespace_after (libcst.leftcurlybrace attribute)": [[11, "libcst.LeftCurlyBrace.whitespace_after"]], "whitespace_after (libcst.leftparen attribute)": [[11, "libcst.LeftParen.whitespace_after"]], "whitespace_after (libcst.leftsquarebracket attribute)": [[11, "libcst.LeftSquareBracket.whitespace_after"]], "whitespace_after (libcst.lessthanequal attribute)": [[11, "libcst.LessThanEqual.whitespace_after"]], "whitespace_after (libcst.notequal attribute)": [[11, "libcst.NotEqual.whitespace_after"]], "whitespace_after (libcst.notin attribute)": [[11, "libcst.NotIn.whitespace_after"]], "whitespace_after (libcst.or attribute)": [[11, "libcst.Or.whitespace_after"]], "whitespace_after (libcst.plus attribute)": [[11, "libcst.Plus.whitespace_after"]], "whitespace_after (libcst.semicolon attribute)": [[11, "libcst.Semicolon.whitespace_after"]], "whitespace_after (libcst.subtract attribute)": [[11, "libcst.Subtract.whitespace_after"]], "whitespace_after (libcst.subtractassign attribute)": [[11, "libcst.SubtractAssign.whitespace_after"]], "whitespace_after_arg (libcst.arg attribute)": [[11, "libcst.Arg.whitespace_after_arg"]], "whitespace_after_as (libcst.asname attribute)": [[11, "libcst.AsName.whitespace_after_as"]], "whitespace_after_assert (libcst.assert attribute)": [[11, "libcst.Assert.whitespace_after_assert"]], "whitespace_after_at (libcst.decorator attribute)": [[11, "libcst.Decorator.whitespace_after_at"]], "whitespace_after_await (libcst.await attribute)": [[11, "libcst.Await.whitespace_after_await"]], "whitespace_after_class (libcst.classdef attribute)": [[11, "libcst.ClassDef.whitespace_after_class"]], "whitespace_after_colon (libcst.dictcomp attribute)": [[11, "libcst.DictComp.whitespace_after_colon"]], "whitespace_after_colon (libcst.dictelement attribute)": [[11, "libcst.DictElement.whitespace_after_colon"]], "whitespace_after_def (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.whitespace_after_def"]], "whitespace_after_del (libcst.del attribute)": [[11, "libcst.Del.whitespace_after_del"]], "whitespace_after_else (libcst.ifexp attribute)": [[11, "libcst.IfExp.whitespace_after_else"]], "whitespace_after_equal (libcst.assigntarget attribute)": [[11, "libcst.AssignTarget.whitespace_after_equal"]], "whitespace_after_except (libcst.excepthandler attribute)": [[11, "libcst.ExceptHandler.whitespace_after_except"]], "whitespace_after_expression (libcst.formattedstringexpression attribute)": [[11, "libcst.FormattedStringExpression.whitespace_after_expression"]], "whitespace_after_for (libcst.compfor attribute)": [[11, "libcst.CompFor.whitespace_after_for"]], "whitespace_after_for (libcst.for attribute)": [[11, "libcst.For.whitespace_after_for"]], "whitespace_after_from (libcst.from attribute)": [[11, "libcst.From.whitespace_after_from"]], "whitespace_after_from (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.whitespace_after_from"]], "whitespace_after_func (libcst.call attribute)": [[11, "libcst.Call.whitespace_after_func"]], "whitespace_after_global (libcst.global attribute)": [[11, "libcst.Global.whitespace_after_global"]], "whitespace_after_if (libcst.ifexp attribute)": [[11, "libcst.IfExp.whitespace_after_if"]], "whitespace_after_import (libcst.import attribute)": [[11, "libcst.Import.whitespace_after_import"]], "whitespace_after_import (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.whitespace_after_import"]], "whitespace_after_in (libcst.compfor attribute)": [[11, "libcst.CompFor.whitespace_after_in"]], "whitespace_after_in (libcst.for attribute)": [[11, "libcst.For.whitespace_after_in"]], "whitespace_after_indicator (libcst.annotation attribute)": [[11, "libcst.Annotation.whitespace_after_indicator"]], "whitespace_after_lambda (libcst.lambda attribute)": [[11, "libcst.Lambda.whitespace_after_lambda"]], "whitespace_after_name (libcst.classdef attribute)": [[11, "libcst.ClassDef.whitespace_after_name"]], "whitespace_after_name (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.whitespace_after_name"]], "whitespace_after_nonlocal (libcst.nonlocal attribute)": [[11, "libcst.Nonlocal.whitespace_after_nonlocal"]], "whitespace_after_param (libcst.param attribute)": [[11, "libcst.Param.whitespace_after_param"]], "whitespace_after_raise (libcst.raise attribute)": [[11, "libcst.Raise.whitespace_after_raise"]], "whitespace_after_return (libcst.return attribute)": [[11, "libcst.Return.whitespace_after_return"]], "whitespace_after_star (libcst.arg attribute)": [[11, "libcst.Arg.whitespace_after_star"]], "whitespace_after_star (libcst.param attribute)": [[11, "libcst.Param.whitespace_after_star"]], "whitespace_after_test (libcst.if attribute)": [[11, "libcst.If.whitespace_after_test"]], "whitespace_after_value (libcst.subscript attribute)": [[11, "libcst.Subscript.whitespace_after_value"]], "whitespace_after_while (libcst.while attribute)": [[11, "libcst.While.whitespace_after_while"]], "whitespace_after_with (libcst.with attribute)": [[11, "libcst.With.whitespace_after_with"]], "whitespace_after_yield (libcst.yield attribute)": [[11, "libcst.Yield.whitespace_after_yield"]], "whitespace_before (libcst.assignequal attribute)": [[11, "libcst.AssignEqual.whitespace_before"]], "whitespace_before (libcst.colon attribute)": [[11, "libcst.Colon.whitespace_before"]], "whitespace_before (libcst.comma attribute)": [[11, "libcst.Comma.whitespace_before"]], "whitespace_before (libcst.compfor attribute)": [[11, "libcst.CompFor.whitespace_before"]], "whitespace_before (libcst.compif attribute)": [[11, "libcst.CompIf.whitespace_before"]], "whitespace_before (libcst.dot attribute)": [[11, "libcst.Dot.whitespace_before"]], "whitespace_before (libcst.lessthanequal attribute)": [[11, "libcst.LessThanEqual.whitespace_before"]], "whitespace_before (libcst.notequal attribute)": [[11, "libcst.NotEqual.whitespace_before"]], "whitespace_before (libcst.notin attribute)": [[11, "libcst.NotIn.whitespace_before"]], "whitespace_before (libcst.or attribute)": [[11, "libcst.Or.whitespace_before"]], "whitespace_before (libcst.rightcurlybrace attribute)": [[11, "libcst.RightCurlyBrace.whitespace_before"]], "whitespace_before (libcst.rightparen attribute)": [[11, "libcst.RightParen.whitespace_before"]], "whitespace_before (libcst.rightsquarebracket attribute)": [[11, "libcst.RightSquareBracket.whitespace_before"]], "whitespace_before (libcst.semicolon attribute)": [[11, "libcst.Semicolon.whitespace_before"]], "whitespace_before (libcst.subtract attribute)": [[11, "libcst.Subtract.whitespace_before"]], "whitespace_before (libcst.subtractassign attribute)": [[11, "libcst.SubtractAssign.whitespace_before"]], "whitespace_before_args (libcst.call attribute)": [[11, "libcst.Call.whitespace_before_args"]], "whitespace_before_as (libcst.asname attribute)": [[11, "libcst.AsName.whitespace_before_as"]], "whitespace_before_colon (libcst.classdef attribute)": [[11, "libcst.ClassDef.whitespace_before_colon"]], "whitespace_before_colon (libcst.dictcomp attribute)": [[11, "libcst.DictComp.whitespace_before_colon"]], "whitespace_before_colon (libcst.dictelement attribute)": [[11, "libcst.DictElement.whitespace_before_colon"]], "whitespace_before_colon (libcst.else attribute)": [[11, "libcst.Else.whitespace_before_colon"]], "whitespace_before_colon (libcst.excepthandler attribute)": [[11, "libcst.ExceptHandler.whitespace_before_colon"]], "whitespace_before_colon (libcst.finally attribute)": [[11, "libcst.Finally.whitespace_before_colon"]], "whitespace_before_colon (libcst.for attribute)": [[11, "libcst.For.whitespace_before_colon"]], "whitespace_before_colon (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.whitespace_before_colon"]], "whitespace_before_colon (libcst.try attribute)": [[11, "libcst.Try.whitespace_before_colon"]], "whitespace_before_colon (libcst.while attribute)": [[11, "libcst.While.whitespace_before_colon"]], "whitespace_before_colon (libcst.with attribute)": [[11, "libcst.With.whitespace_before_colon"]], "whitespace_before_else (libcst.ifexp attribute)": [[11, "libcst.IfExp.whitespace_before_else"]], "whitespace_before_equal (libcst.assigntarget attribute)": [[11, "libcst.AssignTarget.whitespace_before_equal"]], "whitespace_before_expression (libcst.formattedstringexpression attribute)": [[11, "libcst.FormattedStringExpression.whitespace_before_expression"]], "whitespace_before_from (libcst.from attribute)": [[11, "libcst.From.whitespace_before_from"]], "whitespace_before_if (libcst.ifexp attribute)": [[11, "libcst.IfExp.whitespace_before_if"]], "whitespace_before_import (libcst.importfrom attribute)": [[11, "libcst.ImportFrom.whitespace_before_import"]], "whitespace_before_in (libcst.compfor attribute)": [[11, "libcst.CompFor.whitespace_before_in"]], "whitespace_before_in (libcst.for attribute)": [[11, "libcst.For.whitespace_before_in"]], "whitespace_before_indicator (libcst.annotation attribute)": [[11, "libcst.Annotation.whitespace_before_indicator"]], "whitespace_before_params (libcst.functiondef attribute)": [[11, "libcst.FunctionDef.whitespace_before_params"]], "whitespace_before_test (libcst.compif attribute)": [[11, "libcst.CompIf.whitespace_before_test"]], "whitespace_before_test (libcst.if attribute)": [[11, "libcst.If.whitespace_before_test"]], "whitespace_before_value (libcst.starreddictelement attribute)": [[11, "libcst.StarredDictElement.whitespace_before_value"]], "whitespace_before_value (libcst.starredelement attribute)": [[11, "libcst.StarredElement.whitespace_before_value"]], "whitespace_between (libcst.concatenatedstring attribute)": [[11, "libcst.ConcatenatedString.whitespace_between"]], "whitespace_between (libcst.notin attribute)": [[11, "libcst.NotIn.whitespace_between"]], "with_changes() (libcst.cstnode method)": [[11, "libcst.CSTNode.with_changes"]], "with_deep_changes() (libcst.cstnode method)": [[11, "libcst.CSTNode.with_deep_changes"]], "parsersyntaxerror (class in libcst)": [[12, "libcst.ParserSyntaxError"]], "partialparserconfig (class in libcst)": [[12, "libcst.PartialParserConfig"]], "__str__() (libcst.parsersyntaxerror method)": [[12, "libcst.ParserSyntaxError.__str__"]], "context (libcst.parsersyntaxerror property)": [[12, "libcst.ParserSyntaxError.context"]], "default_indent (libcst.partialparserconfig attribute)": [[12, "libcst.PartialParserConfig.default_indent"]], "default_newline (libcst.partialparserconfig attribute)": [[12, "libcst.PartialParserConfig.default_newline"]], "editor_column (libcst.parsersyntaxerror property)": [[12, "libcst.ParserSyntaxError.editor_column"]], "editor_line (libcst.parsersyntaxerror property)": [[12, "libcst.ParserSyntaxError.editor_line"]], "encoding (libcst.partialparserconfig attribute)": [[12, "libcst.PartialParserConfig.encoding"]], "future_imports (libcst.partialparserconfig attribute)": [[12, "libcst.PartialParserConfig.future_imports"]], "message (libcst.parsersyntaxerror attribute)": [[12, "libcst.ParserSyntaxError.message"]], "parse_expression() (in module libcst)": [[12, "libcst.parse_expression"]], "parse_module() (in module libcst)": [[12, "libcst.parse_module"]], "parse_statement() (in module libcst)": [[12, "libcst.parse_statement"]], "parsed_python_version (libcst.partialparserconfig attribute)": [[12, "libcst.PartialParserConfig.parsed_python_version"]], "python_version (libcst.partialparserconfig attribute)": [[12, "libcst.PartialParserConfig.python_version"]], "raw_column (libcst.parsersyntaxerror attribute)": [[12, "libcst.ParserSyntaxError.raw_column"]], "raw_line (libcst.parsersyntaxerror attribute)": [[12, "libcst.ParserSyntaxError.raw_line"]], "batchablecstvisitor (class in libcst)": [[15, "libcst.BatchableCSTVisitor"]], "csttransformer (class in libcst)": [[15, "libcst.CSTTransformer"]], "cstvisitor (class in libcst)": [[15, "libcst.CSTVisitor"]], "flattensentinel (class in libcst)": [[15, "libcst.FlattenSentinel"]], "remove (libcst.removalsentinel attribute)": [[15, "libcst.RemovalSentinel.REMOVE"]], "removalsentinel (class in libcst)": [[15, "libcst.RemovalSentinel"]], "removefromparent() (in module libcst)": [[15, "libcst.RemoveFromParent"]], "get_visitors() (libcst.batchablecstvisitor method)": [[15, "libcst.BatchableCSTVisitor.get_visitors"]], "nodes (libcst.flattensentinel attribute)": [[15, "libcst.FlattenSentinel.nodes"]], "on_leave() (libcst.csttransformer method)": [[15, "libcst.CSTTransformer.on_leave"]], "on_leave() (libcst.cstvisitor method)": [[15, "libcst.CSTVisitor.on_leave"]], "on_leave_attribute() (libcst.csttransformer method)": [[15, "libcst.CSTTransformer.on_leave_attribute"]], "on_leave_attribute() (libcst.cstvisitor method)": [[15, "libcst.CSTVisitor.on_leave_attribute"]], "on_visit() (libcst.csttransformer method)": [[15, "libcst.CSTTransformer.on_visit"]], "on_visit() (libcst.cstvisitor method)": [[15, "libcst.CSTVisitor.on_visit"]], "on_visit_attribute() (libcst.csttransformer method)": [[15, "libcst.CSTTransformer.on_visit_attribute"]], "on_visit_attribute() (libcst.cstvisitor method)": [[15, "libcst.CSTVisitor.on_visit_attribute"]], "visit_batched() (in module libcst)": [[15, "libcst.visit_batched"]]}})